BeginPackage["KnotTheory`Kh4TorusKnots`", {"KnotTheory`"}]
Message[KnotTheory::loading, "Kh4TorusKnots`"]

Begin["`Private`"]

KOs = {
  TorusKnot[3, 2], TorusKnot[5, 2], TorusKnot[7, 2], TorusKnot[4, 3],
  TorusKnot[9, 2], TorusKnot[5, 3], TorusKnot[11, 2], TorusKnot[13, 2],
  TorusKnot[7, 3], TorusKnot[5, 4], TorusKnot[15, 2], TorusKnot[8, 3],
  TorusKnot[17, 2], TorusKnot[19, 2], TorusKnot[10, 3], TorusKnot[7, 4],
  TorusKnot[21, 2], TorusKnot[11, 3], TorusKnot[23, 2], TorusKnot[6, 5],
  TorusKnot[25, 2], TorusKnot[13, 3], TorusKnot[9, 4], TorusKnot[27, 2],
  TorusKnot[7, 5], TorusKnot[14, 3], TorusKnot[29, 2], TorusKnot[31, 2],
  TorusKnot[8, 5], TorusKnot[16, 3], TorusKnot[11, 4], TorusKnot[33, 2],
  TorusKnot[17, 3], TorusKnot[7, 6], TorusKnot[35, 2], TorusKnot[9, 5]
}

Is = {q + q^3 + q^5*t^2 + q^9*t^3, q^3 + q^5 + q^7*t^2 + q^11*t^3 + 
  q^11*t^4 + q^15*t^5, q^5 + q^7 + q^9*t^2 + q^13*t^3 + q^13*t^4 + 
  q^17*t^5 + q^17*t^6 + q^21*t^7, q^5 + q^7 + q^9*t^2 + q^13*t^3 + 
  q^11*t^4 + q^13*t^4 + q^15*t^5 + q^17*t^5, 
 q^7 + q^9 + q^11*t^2 + q^15*t^3 + q^15*t^4 + q^19*t^5 + q^19*t^6 + 
  q^23*t^7 + q^23*t^8 + q^27*t^9, q^7 + q^9 + q^11*t^2 + q^15*t^3 + 
  q^13*t^4 + q^15*t^4 + q^17*t^5 + q^19*t^5 + q^17*t^6 + q^21*t^7, 
 q^9 + q^11 + q^13*t^2 + q^17*t^3 + q^17*t^4 + q^21*t^5 + q^21*t^6 + 
  q^25*t^7 + q^25*t^8 + q^29*t^9 + q^29*t^10 + q^33*t^11, 
 q^11 + q^13 + q^15*t^2 + q^19*t^3 + q^19*t^4 + q^23*t^5 + q^23*t^6 + 
  q^27*t^7 + q^27*t^8 + q^31*t^9 + q^31*t^10 + q^35*t^11 + 
  q^35*t^12 + q^39*t^13, q^11 + q^13 + q^15*t^2 + q^19*t^3 + 
  q^17*t^4 + q^19*t^4 + q^21*t^5 + q^23*t^5 + q^21*t^6 + q^25*t^7 + 
  q^23*t^8 + q^25*t^8 + q^27*t^9 + q^29*t^9, 
 q^11 + q^13 + q^15*t^2 + q^19*t^3 + q^17*t^4 + q^19*t^4 + q^21*t^5 + 
  q^23*t^5 + q^19*t^6 + q^21*t^6 + q^23*t^7 + q^25*t^7 + q^23*t^8 + 
  q^27*t^9, q^13 + q^15 + q^17*t^2 + q^21*t^3 + q^21*t^4 + q^25*t^5 + 
  q^25*t^6 + q^29*t^7 + q^29*t^8 + q^33*t^9 + q^33*t^10 + q^37*t^11 + 
  q^37*t^12 + q^41*t^13 + q^41*t^14 + q^45*t^15, 
 q^13 + q^15 + q^17*t^2 + q^21*t^3 + q^19*t^4 + q^21*t^4 + q^23*t^5 + 
  q^25*t^5 + q^23*t^6 + q^27*t^7 + q^25*t^8 + q^27*t^8 + q^29*t^9 + 
  q^31*t^9 + q^29*t^10 + q^33*t^11, q^15 + q^17 + q^19*t^2 + 
  q^23*t^3 + q^23*t^4 + q^27*t^5 + q^27*t^6 + q^31*t^7 + q^31*t^8 + 
  q^35*t^9 + q^35*t^10 + q^39*t^11 + q^39*t^12 + q^43*t^13 + 
  q^43*t^14 + q^47*t^15 + q^47*t^16 + q^51*t^17, 
 q^17 + q^19 + q^21*t^2 + q^25*t^3 + q^25*t^4 + q^29*t^5 + q^29*t^6 + 
  q^33*t^7 + q^33*t^8 + q^37*t^9 + q^37*t^10 + q^41*t^11 + 
  q^41*t^12 + q^45*t^13 + q^45*t^14 + q^49*t^15 + q^49*t^16 + 
  q^53*t^17 + q^53*t^18 + q^57*t^19, q^17 + q^19 + q^21*t^2 + 
  q^25*t^3 + q^23*t^4 + q^25*t^4 + q^27*t^5 + q^29*t^5 + q^27*t^6 + 
  q^31*t^7 + q^29*t^8 + q^31*t^8 + q^33*t^9 + q^35*t^9 + q^33*t^10 + 
  q^37*t^11 + q^35*t^12 + q^37*t^12 + q^39*t^13 + q^41*t^13, 
 q^17 + q^19 + q^21*t^2 + q^25*t^3 + q^23*t^4 + q^25*t^4 + q^27*t^5 + 
  q^29*t^5 + q^25*t^6 + q^27*t^6 + q^29*t^7 + q^31*t^7 + 2*q^29*t^8 + 
  2*q^33*t^9 + q^31*t^10 + q^33*t^10 + 2*q^35*t^11 + q^37*t^11 + 
  q^35*t^12 + q^39*t^12 + q^39*t^13, q^19 + q^21 + q^23*t^2 + 
  q^27*t^3 + q^27*t^4 + q^31*t^5 + q^31*t^6 + q^35*t^7 + q^35*t^8 + 
  q^39*t^9 + q^39*t^10 + q^43*t^11 + q^43*t^12 + q^47*t^13 + 
  q^47*t^14 + q^51*t^15 + q^51*t^16 + q^55*t^17 + q^55*t^18 + 
  q^59*t^19 + q^59*t^20 + q^63*t^21, q^19 + q^21 + q^23*t^2 + 
  q^27*t^3 + q^25*t^4 + q^27*t^4 + q^29*t^5 + q^31*t^5 + q^29*t^6 + 
  q^33*t^7 + q^31*t^8 + q^33*t^8 + q^35*t^9 + q^37*t^9 + q^35*t^10 + 
  q^39*t^11 + q^37*t^12 + q^39*t^12 + q^41*t^13 + q^43*t^13 + 
  q^41*t^14 + q^45*t^15, q^21 + q^23 + q^25*t^2 + q^29*t^3 + 
  q^29*t^4 + q^33*t^5 + q^33*t^6 + q^37*t^7 + q^37*t^8 + q^41*t^9 + 
  q^41*t^10 + q^45*t^11 + q^45*t^12 + q^49*t^13 + q^49*t^14 + 
  q^53*t^15 + q^53*t^16 + q^57*t^17 + q^57*t^18 + q^61*t^19 + 
  q^61*t^20 + q^65*t^21 + q^65*t^22 + q^69*t^23, 
 q^19 + q^21 + q^23*t^2 + q^27*t^3 + q^25*t^4 + q^27*t^4 + q^29*t^5 + 
  q^31*t^5 + q^27*t^6 + q^29*t^6 + q^31*t^7 + q^33*t^7 + q^29*t^8 + 
  2*q^31*t^8 + q^33*t^9 + 2*q^35*t^9 + q^33*t^10 + 2*q^37*t^11 + 
  q^35*t^12 + q^37*t^12 + q^41*t^12 + q^39*t^13 + q^41*t^13, 
 q^23 + q^25 + q^27*t^2 + q^31*t^3 + q^31*t^4 + q^35*t^5 + q^35*t^6 + 
  q^39*t^7 + q^39*t^8 + q^43*t^9 + q^43*t^10 + q^47*t^11 + 
  q^47*t^12 + q^51*t^13 + q^51*t^14 + q^55*t^15 + q^55*t^16 + 
  q^59*t^17 + q^59*t^18 + q^63*t^19 + q^63*t^20 + q^67*t^21 + 
  q^67*t^22 + q^71*t^23 + q^71*t^24 + q^75*t^25, 
 q^23 + q^25 + q^27*t^2 + q^31*t^3 + q^29*t^4 + q^31*t^4 + q^33*t^5 + 
  q^35*t^5 + q^33*t^6 + q^37*t^7 + q^35*t^8 + q^37*t^8 + q^39*t^9 + 
  q^41*t^9 + q^39*t^10 + q^43*t^11 + q^41*t^12 + q^43*t^12 + 
  q^45*t^13 + q^47*t^13 + q^45*t^14 + q^49*t^15 + q^47*t^16 + 
  q^49*t^16 + q^51*t^17 + q^53*t^17, q^23 + q^25 + q^27*t^2 + 
  q^31*t^3 + q^29*t^4 + q^31*t^4 + q^33*t^5 + q^35*t^5 + q^31*t^6 + 
  q^33*t^6 + q^35*t^7 + q^37*t^7 + 2*q^35*t^8 + 2*q^39*t^9 + 
  q^37*t^10 + q^39*t^10 + 2*q^41*t^11 + q^43*t^11 + q^39*t^12 + 
  2*q^41*t^12 + q^45*t^12 + q^43*t^13 + 2*q^45*t^13 + q^43*t^14 + 
  2*q^47*t^15 + q^47*t^16 + q^51*t^16 + q^51*t^17, 
 q^25 + q^27 + q^29*t^2 + q^33*t^3 + q^33*t^4 + q^37*t^5 + q^37*t^6 + 
  q^41*t^7 + q^41*t^8 + q^45*t^9 + q^45*t^10 + q^49*t^11 + 
  q^49*t^12 + q^53*t^13 + q^53*t^14 + q^57*t^15 + q^57*t^16 + 
  q^61*t^17 + q^61*t^18 + q^65*t^19 + q^65*t^20 + q^69*t^21 + 
  q^69*t^22 + q^73*t^23 + q^73*t^24 + q^77*t^25 + q^77*t^26 + 
  q^81*t^27, q^23 + q^25 + q^27*t^2 + q^31*t^3 + q^29*t^4 + 
  q^31*t^4 + q^33*t^5 + q^35*t^5 + q^31*t^6 + q^33*t^6 + q^35*t^7 + 
  q^37*t^7 + q^33*t^8 + 2*q^35*t^8 + q^37*t^9 + 2*q^39*t^9 + 
  2*q^37*t^10 + 3*q^41*t^11 + q^39*t^12 + 2*q^41*t^12 + q^45*t^12 + 
  2*q^43*t^13 + 2*q^45*t^13 + q^43*t^14 + q^47*t^14 + 2*q^47*t^15 + 
  q^47*t^16 + q^51*t^16 + q^51*t^17, q^25 + q^27 + q^29*t^2 + 
  q^33*t^3 + q^31*t^4 + q^33*t^4 + q^35*t^5 + q^37*t^5 + q^35*t^6 + 
  q^39*t^7 + q^37*t^8 + q^39*t^8 + q^41*t^9 + q^43*t^9 + q^41*t^10 + 
  q^45*t^11 + q^43*t^12 + q^45*t^12 + q^47*t^13 + q^49*t^13 + 
  q^47*t^14 + q^51*t^15 + q^49*t^16 + q^51*t^16 + q^53*t^17 + 
  q^55*t^17 + q^53*t^18 + q^57*t^19, q^27 + q^29 + q^31*t^2 + 
  q^35*t^3 + q^35*t^4 + q^39*t^5 + q^39*t^6 + q^43*t^7 + q^43*t^8 + 
  q^47*t^9 + q^47*t^10 + q^51*t^11 + q^51*t^12 + q^55*t^13 + 
  q^55*t^14 + q^59*t^15 + q^59*t^16 + q^63*t^17 + q^63*t^18 + 
  q^67*t^19 + q^67*t^20 + q^71*t^21 + q^71*t^22 + q^75*t^23 + 
  q^75*t^24 + q^79*t^25 + q^79*t^26 + q^83*t^27 + q^83*t^28 + 
  q^87*t^29, q^29 + q^31 + q^33*t^2 + q^37*t^3 + q^37*t^4 + 
  q^41*t^5 + q^41*t^6 + q^45*t^7 + q^45*t^8 + q^49*t^9 + q^49*t^10 + 
  q^53*t^11 + q^53*t^12 + q^57*t^13 + q^57*t^14 + q^61*t^15 + 
  q^61*t^16 + q^65*t^17 + q^65*t^18 + q^69*t^19 + q^69*t^20 + 
  q^73*t^21 + q^73*t^22 + q^77*t^23 + q^77*t^24 + q^81*t^25 + 
  q^81*t^26 + q^85*t^27 + q^85*t^28 + q^89*t^29 + q^89*t^30 + 
  q^93*t^31, q^27 + q^29 + q^31*t^2 + q^35*t^3 + q^33*t^4 + 
  q^35*t^4 + q^37*t^5 + q^39*t^5 + q^35*t^6 + q^37*t^6 + q^39*t^7 + 
  q^41*t^7 + q^37*t^8 + 2*q^39*t^8 + q^41*t^9 + 2*q^43*t^9 + 
  2*q^41*t^10 + 3*q^45*t^11 + 2*q^43*t^12 + 2*q^45*t^12 + q^49*t^12 + 
  3*q^47*t^13 + 2*q^49*t^13 + 2*q^47*t^14 + q^51*t^14 + q^49*t^15 + 
  3*q^51*t^15 + q^49*t^16 + q^51*t^16 + q^53*t^16 + q^55*t^16 + 
  2*q^53*t^17 + q^55*t^17 + q^53*t^18 + q^57*t^18 + q^57*t^19, 
 q^29 + q^31 + q^33*t^2 + q^37*t^3 + q^35*t^4 + q^37*t^4 + q^39*t^5 + 
  q^41*t^5 + q^39*t^6 + q^43*t^7 + q^41*t^8 + q^43*t^8 + q^45*t^9 + 
  q^47*t^9 + q^45*t^10 + q^49*t^11 + q^47*t^12 + q^49*t^12 + 
  q^51*t^13 + q^53*t^13 + q^51*t^14 + q^55*t^15 + q^53*t^16 + 
  q^55*t^16 + q^57*t^17 + q^59*t^17 + q^57*t^18 + q^61*t^19 + 
  q^59*t^20 + q^61*t^20 + q^63*t^21 + q^65*t^21, 
 q^29 + q^31 + q^33*t^2 + q^37*t^3 + q^35*t^4 + q^37*t^4 + q^39*t^5 + 
  q^41*t^5 + q^37*t^6 + q^39*t^6 + q^41*t^7 + q^43*t^7 + 2*q^41*t^8 + 
  2*q^45*t^9 + q^43*t^10 + q^45*t^10 + 2*q^47*t^11 + q^49*t^11 + 
  q^45*t^12 + 2*q^47*t^12 + q^51*t^12 + q^49*t^13 + 2*q^51*t^13 + 
  2*q^49*t^14 + 3*q^53*t^15 + q^51*t^16 + 2*q^53*t^16 + q^57*t^16 + 
  2*q^55*t^17 + 2*q^57*t^17 + q^55*t^18 + q^59*t^18 + 2*q^59*t^19 + 
  q^59*t^20 + q^63*t^20 + q^63*t^21, q^31 + q^33 + q^35*t^2 + 
  q^39*t^3 + q^39*t^4 + q^43*t^5 + q^43*t^6 + q^47*t^7 + q^47*t^8 + 
  q^51*t^9 + q^51*t^10 + q^55*t^11 + q^55*t^12 + q^59*t^13 + 
  q^59*t^14 + q^63*t^15 + q^63*t^16 + q^67*t^17 + q^67*t^18 + 
  q^71*t^19 + q^71*t^20 + q^75*t^21 + q^75*t^22 + q^79*t^23 + 
  q^79*t^24 + q^83*t^25 + q^83*t^26 + q^87*t^27 + q^87*t^28 + 
  q^91*t^29 + q^91*t^30 + q^95*t^31 + q^95*t^32 + q^99*t^33, 
 q^31 + q^33 + q^35*t^2 + q^39*t^3 + q^37*t^4 + q^39*t^4 + q^41*t^5 + 
  q^43*t^5 + q^41*t^6 + q^45*t^7 + q^43*t^8 + q^45*t^8 + q^47*t^9 + 
  q^49*t^9 + q^47*t^10 + q^51*t^11 + q^49*t^12 + q^51*t^12 + 
  q^53*t^13 + q^55*t^13 + q^53*t^14 + q^57*t^15 + q^55*t^16 + 
  q^57*t^16 + q^59*t^17 + q^61*t^17 + q^59*t^18 + q^63*t^19 + 
  q^61*t^20 + q^63*t^20 + q^65*t^21 + q^67*t^21 + q^65*t^22 + 
  q^69*t^23, q^29 + q^31 + q^33*t^2 + q^37*t^3 + q^35*t^4 + 
  q^37*t^4 + q^39*t^5 + q^41*t^5 + q^37*t^6 + q^39*t^6 + q^41*t^7 + 
  q^43*t^7 + q^39*t^8 + 2*q^41*t^8 + q^43*t^9 + 2*q^45*t^9 + 
  q^41*t^10 + 2*q^43*t^10 + q^45*t^11 + 3*q^47*t^11 + 2*q^45*t^12 + 
  q^47*t^12 + q^51*t^12 + 3*q^49*t^13 + q^51*t^13 + q^47*t^14 + 
  q^49*t^14 + q^53*t^14 + 2*q^51*t^15 + 2*q^53*t^15 + q^49*t^16 + 
  q^51*t^16 + q^55*t^16 + q^57*t^16 + q^53*t^17 + q^55*t^17 + 
  q^53*t^18 + q^57*t^19, q^33 + q^35 + q^37*t^2 + q^41*t^3 + 
  q^41*t^4 + q^45*t^5 + q^45*t^6 + q^49*t^7 + q^49*t^8 + q^53*t^9 + 
  q^53*t^10 + q^57*t^11 + q^57*t^12 + q^61*t^13 + q^61*t^14 + 
  q^65*t^15 + q^65*t^16 + q^69*t^17 + q^69*t^18 + q^73*t^19 + 
  q^73*t^20 + q^77*t^21 + q^77*t^22 + q^81*t^23 + q^81*t^24 + 
  q^85*t^25 + q^85*t^26 + q^89*t^27 + q^89*t^28 + q^93*t^29 + 
  q^93*t^30 + q^97*t^31 + q^97*t^32 + q^101*t^33 + q^101*t^34 + 
  q^105*t^35, q^31 + q^33 + q^35*t^2 + q^39*t^3 + q^37*t^4 + 
  q^39*t^4 + q^41*t^5 + q^43*t^5 + q^39*t^6 + q^41*t^6 + q^43*t^7 + 
  q^45*t^7 + q^41*t^8 + 2*q^43*t^8 + q^45*t^9 + 2*q^47*t^9 + 
  2*q^45*t^10 + 3*q^49*t^11 + 2*q^47*t^12 + 2*q^49*t^12 + q^53*t^12 + 
  3*q^51*t^13 + 2*q^53*t^13 + q^49*t^14 + 2*q^51*t^14 + q^55*t^14 + 
  2*q^53*t^15 + 3*q^55*t^15 + 2*q^53*t^16 + q^57*t^16 + q^59*t^16 + 
  3*q^57*t^17 + q^55*t^18 + q^57*t^18 + q^61*t^18 + 2*q^59*t^19 + 
  q^61*t^19 + q^59*t^20 + q^63*t^20 + q^63*t^21}

Is = Function /@ (Is /. {q -> #1, t -> #2})

MapThread[(Kh[#1] = #2)&, {KOs, Is}]

Clear[KOs, Is]

End[]; EndPackage[]

