BeginPackage["KnotTheory`Kauffman4Knots`", {"KnotTheory`"}]
Message[KnotTheory::loading, "Kauffman4Knots`"]

Begin["`Private`"]

KOs = Select[AllKnots[], (Crossings[#] <= 10)&]

Is = {
1, -2*a^2 - a^4 + a^3*z + a^5*z + a^2*z^2 + 
  a^4*z^2, -1 - a^(-2) - a^2 - z/a - a*z + 2*z^2 + z^2/a^2 + a^2*z^2 + 
  z^3/a + a*z^3, 3*a^4 + 2*a^6 - 2*a^5*z - a^7*z + a^9*z - 4*a^4*z^2 - 
  3*a^6*z^2 + a^8*z^2 + a^5*z^3 + a^7*z^3 + a^4*z^4 + a^6*z^4, 
 -a^2 + a^4 + a^6 - 2*a^5*z - 2*a^7*z + a^2*z^2 - a^4*z^2 - 2*a^6*z^2 + 
  a^3*z^3 + 2*a^5*z^3 + a^7*z^3 + a^4*z^4 + a^6*z^4, 
 -a^(-2) + a^2 + a^4 + 2*a*z + 2*a^3*z + z^2/a^2 - 4*a^2*z^2 - 3*a^4*z^2 + 
  z^3/a - 2*a*z^3 - 3*a^3*z^3 + z^4 + 2*a^2*z^4 + a^4*z^4 + a*z^5 + a^3*z^5, 
 2 + 2*a^2 + a^4 - a^3*z - a^5*z - 3*z^2 - 6*a^2*z^2 - 2*a^4*z^2 + a^6*z^2 - 
  2*a*z^3 + 2*a^5*z^3 + z^4 + 3*a^2*z^4 + 2*a^4*z^4 + a*z^5 + a^3*z^5, 
 3 + a^(-2) + a^2 - z/a^3 - (2*z)/a - 2*a*z - a^3*z - 6*z^2 - (3*z^2)/a^2 - 
  3*a^2*z^2 + z^3/a^3 + z^3/a + a*z^3 + a^3*z^3 + 4*z^4 + (2*z^4)/a^2 + 
  2*a^2*z^4 + z^5/a + a*z^5, -4*a^6 - 3*a^8 + 3*a^7*z + a^9*z - a^11*z + 
  a^13*z + 10*a^6*z^2 + 7*a^8*z^2 - 2*a^10*z^2 + a^12*z^2 - 4*a^7*z^3 - 
  3*a^9*z^3 + a^11*z^3 - 6*a^6*z^4 - 5*a^8*z^4 + a^10*z^4 + a^7*z^5 + 
  a^9*z^5 + a^6*z^6 + a^8*z^6, -a^2 - a^6 - a^8 + 3*a^7*z + 3*a^9*z + 
  a^2*z^2 + 3*a^6*z^2 + 4*a^8*z^2 + a^3*z^3 - a^5*z^3 - 6*a^7*z^3 - 
  4*a^9*z^3 + a^4*z^4 - 3*a^6*z^4 - 4*a^8*z^4 + a^5*z^5 + 2*a^7*z^5 + 
  a^9*z^5 + a^6*z^6 + a^8*z^6, -2/a^8 - 2/a^6 + a^(-4) - (2*z)/a^11 + z/a^9 + 
  (3*z)/a^7 - z^2/a^10 + (6*z^2)/a^8 + (4*z^2)/a^6 - (3*z^2)/a^4 + z^3/a^11 - 
  z^3/a^9 - (4*z^3)/a^7 - (2*z^3)/a^5 + z^4/a^10 - (3*z^4)/a^8 - 
  (3*z^4)/a^6 + z^4/a^4 + z^5/a^9 + (2*z^5)/a^7 + z^5/a^5 + z^6/a^8 + 
  z^6/a^6, -a^(-8) + 2/a^4 + (4*z)/a^9 + (4*z)/a^7 + (2*z^2)/a^8 - 
  (3*z^2)/a^6 - (4*z^2)/a^4 + z^2/a^2 - (4*z^3)/a^9 - (8*z^3)/a^7 - 
  (2*z^3)/a^5 + (2*z^3)/a^3 - (3*z^4)/a^8 + (3*z^4)/a^4 + z^5/a^9 + 
  (3*z^5)/a^7 + (2*z^5)/a^5 + z^6/a^8 + z^6/a^6, 
 2*a^4 - a^8 - a^5*z + a^7*z + a^9*z - a^11*z - 3*a^4*z^2 + a^8*z^2 - 
  2*a^10*z^2 - a^5*z^3 - 4*a^7*z^3 - 2*a^9*z^3 + a^11*z^3 + a^4*z^4 - 
  a^6*z^4 + 2*a^10*z^4 + a^5*z^5 + 3*a^7*z^5 + 2*a^9*z^5 + a^6*z^6 + a^8*z^6, 
 1 + a^2 + 2*a^4 + a^6 + a*z + 2*a^3*z - a^7*z - 2*z^2 - 4*a^2*z^2 - 
  4*a^4*z^2 - 2*a^6*z^2 - 4*a*z^3 - 6*a^3*z^3 - a^5*z^3 + a^7*z^3 + z^4 + 
  a^2*z^4 + 2*a^4*z^4 + 2*a^6*z^4 + 2*a*z^5 + 4*a^3*z^5 + 2*a^5*z^5 + 
  a^2*z^6 + a^4*z^6, 2 + a^(-4) + 2/a^2 + (2*z)/a^3 + (3*z)/a + a*z - 7*z^2 - 
  (2*z^2)/a^4 - (6*z^2)/a^2 - 3*a^2*z^2 - (4*z^3)/a^3 - (8*z^3)/a - 3*a*z^3 + 
  a^3*z^3 + 4*z^4 + z^4/a^4 + (2*z^4)/a^2 + 3*a^2*z^4 + (2*z^5)/a^3 + 
  (5*z^5)/a + 3*a*z^5 + z^6 + z^6/a^2, -a^(-2) - a^4 - a^6 - 3*a^3*z - 
  3*a^5*z + z^2/a^2 + 7*a^4*z^2 + 6*a^6*z^2 + z^3/a - a*z^3 + 5*a^3*z^3 + 
  7*a^5*z^3 + z^4 - 2*a^2*z^4 - 8*a^4*z^4 - 5*a^6*z^4 + a*z^5 - 4*a^3*z^5 - 
  5*a^5*z^5 + a^2*z^6 + 2*a^4*z^6 + a^6*z^6 + a^3*z^7 + a^5*z^7, 
 -3*a^2 - 3*a^4 - a^6 + a^3*z + a^5*z - a^7*z - a^9*z + 7*a^2*z^2 + 
  12*a^4*z^2 + 3*a^6*z^2 - a^8*z^2 + a^10*z^2 + 3*a^3*z^3 - a^5*z^3 - 
  2*a^7*z^3 + 2*a^9*z^3 - 5*a^2*z^4 - 12*a^4*z^4 - 5*a^6*z^4 + 2*a^8*z^4 - 
  4*a^3*z^5 - 2*a^5*z^5 + 2*a^7*z^5 + a^2*z^6 + 3*a^4*z^6 + 2*a^6*z^6 + 
  a^3*z^7 + a^5*z^7, -1 + a^(-4) + a^4 - (4*z)/a - 4*a*z + 8*z^2 - 
  (3*z^2)/a^4 + z^2/a^2 + a^2*z^2 - 3*a^4*z^2 - (2*z^3)/a^3 + (8*z^3)/a + 
  8*a*z^3 - 2*a^3*z^3 - 6*z^4 + z^4/a^4 - (2*z^4)/a^2 - 2*a^2*z^4 + a^4*z^4 + 
  z^5/a^3 - (4*z^5)/a - 4*a*z^5 + a^3*z^5 + 2*z^6 + z^6/a^2 + a^2*z^6 + 
  z^7/a + a*z^7, -2 - 2/a^2 + a^4 - z/a + a*z + 2*a^3*z + 10*z^2 + 
  (7*z^2)/a^2 - a^2*z^2 - 3*a^4*z^2 + a^6*z^2 + (4*z^3)/a - 3*a*z^3 - 
  5*a^3*z^3 + 2*a^5*z^3 - 11*z^4 - (5*z^4)/a^2 - 3*a^2*z^4 + 3*a^4*z^4 - 
  (4*z^5)/a - a*z^5 + 3*a^3*z^5 + 3*z^6 + z^6/a^2 + 2*a^2*z^6 + z^7/a + 
  a*z^7, -2/a^6 - 5/a^4 - 4/a^2 + (4*z)/a^7 + (7*z)/a^5 + (3*z)/a^3 + 
  z^2/a^10 - (2*z^2)/a^8 + (4*z^2)/a^6 + (15*z^2)/a^4 + (8*z^2)/a^2 + 
  (2*z^3)/a^9 - (8*z^3)/a^7 - (10*z^3)/a^5 + (3*z^4)/a^8 - (7*z^4)/a^6 - 
  (15*z^4)/a^4 - (5*z^4)/a^2 + (4*z^5)/a^7 + z^5/a^5 - (3*z^5)/a^3 + 
  (3*z^6)/a^6 + (4*z^6)/a^4 + z^6/a^2 + z^7/a^5 + z^7/a^3, 
 2 + a^2 - a^4 - a^6 - a*z - 3*a^3*z - a^5*z + a^7*z - 3*z^2 - 2*a^2*z^2 + 
  6*a^4*z^2 + 3*a^6*z^2 - 2*a^8*z^2 - a*z^3 + 5*a^3*z^3 + 2*a^5*z^3 - 
  4*a^7*z^3 + z^4 - 6*a^4*z^4 - 4*a^6*z^4 + a^8*z^4 + a*z^5 - 2*a^3*z^5 - 
  a^5*z^5 + 2*a^7*z^5 + a^2*z^6 + 3*a^4*z^6 + 2*a^6*z^6 + a^3*z^7 + a^5*z^7, 
 -1 - 2/a^4 - 4/a^2 - z/a^7 + (2*z)/a^3 + (2*z)/a + a*z + 6*z^2 - 
  (2*z^2)/a^6 + (4*z^2)/a^4 + (12*z^2)/a^2 + z^3/a^7 - z^3/a^5 - 
  (2*z^3)/a^3 - (3*z^3)/a - 3*a*z^3 - 7*z^4 + (2*z^4)/a^6 - (3*z^4)/a^4 - 
  (12*z^4)/a^2 + (2*z^5)/a^5 - z^5/a + a*z^5 + 2*z^6 + (2*z^6)/a^4 + 
  (4*z^6)/a^2 + z^7/a^3 + z^7/a, 2 - a^(-4) - a^(-2) + a^2 + (2*z)/a^5 + 
  (3*z)/a^3 + z/a - a*z - a^3*z - z^2 + (4*z^2)/a^4 + (5*z^2)/a^2 - 
  2*a^2*z^2 - (3*z^3)/a^5 - (5*z^3)/a^3 - (3*z^3)/a + a^3*z^3 - z^4 - 
  (6*z^4)/a^4 - (9*z^4)/a^2 + 2*a^2*z^4 + z^5/a^5 + z^5/a + 2*a*z^5 + 2*z^6 + 
  (2*z^6)/a^4 + (4*z^6)/a^2 + z^7/a^3 + z^7/a, 
 -3 - 2/a^2 - 2*a^2 + z/a^3 + z/a + a*z + a^3*z + 12*z^2 - (2*z^2)/a^4 + 
  (4*z^2)/a^2 + 4*a^2*z^2 - 2*a^4*z^2 - (4*z^3)/a^3 - z^3/a - a*z^3 - 
  4*a^3*z^3 - 10*z^4 + z^4/a^4 - (4*z^4)/a^2 - 4*a^2*z^4 + a^4*z^4 + 
  (2*z^5)/a^3 + 2*a^3*z^5 + 4*z^6 + (2*z^6)/a^2 + 2*a^2*z^6 + z^7/a + a*z^7, 
 -2 - 3/a^4 - 6/a^2 - z/a^7 + (2*z)/a^5 + (6*z)/a^3 + (5*z)/a + 2*a*z + 
  5*z^2 - z^2/a^6 + (6*z^2)/a^4 + (12*z^2)/a^2 + z^3/a^7 - (3*z^3)/a^5 - 
  (9*z^3)/a^3 - (8*z^3)/a - 3*a*z^3 - 6*z^4 + (2*z^4)/a^6 - (5*z^4)/a^4 - 
  (13*z^4)/a^2 + (3*z^5)/a^5 + (3*z^5)/a^3 + z^5/a + a*z^5 + 2*z^6 + 
  (3*z^6)/a^4 + (5*z^6)/a^2 + z^7/a^3 + z^7/a, 
 1 - a^2 - 2*a^4 - a^6 + a^3*z + 3*a^5*z + 2*a^7*z - 2*z^2 + 6*a^4*z^2 + 
  2*a^6*z^2 - 2*a^8*z^2 - 3*a*z^3 - 2*a^3*z^3 - 3*a^5*z^3 - 4*a^7*z^3 + z^4 - 
  2*a^2*z^4 - 7*a^4*z^4 - 3*a^6*z^4 + a^8*z^4 + 2*a*z^5 + a^3*z^5 + a^5*z^5 + 
  2*a^7*z^5 + 2*a^2*z^6 + 4*a^4*z^6 + 2*a^6*z^6 + a^3*z^7 + a^5*z^7, 
 1 + a^(-4) + a^(-2) + a^2 + a^4 + z/a^3 + a^3*z - (2*z^2)/a^4 - 
  (2*z^2)/a^2 - 2*a^2*z^2 - 2*a^4*z^2 - (3*z^3)/a^3 - (3*z^3)/a - 3*a*z^3 - 
  3*a^3*z^3 - 4*z^4 + z^4/a^4 - z^4/a^2 - a^2*z^4 + a^4*z^4 + (2*z^5)/a^3 + 
  (2*z^5)/a + 2*a*z^5 + 2*a^3*z^5 + 4*z^6 + (2*z^6)/a^2 + 2*a^2*z^6 + z^7/a + 
  a*z^7, -a^(-4) - 2/a^2 + (2*z)/a^5 + (4*z)/a^3 + (3*z)/a + a*z + 
  (5*z^2)/a^4 + (7*z^2)/a^2 - 2*a^2*z^2 - (3*z^3)/a^5 - (7*z^3)/a^3 - 
  (9*z^3)/a - 4*a*z^3 + a^3*z^3 - 2*z^4 - (6*z^4)/a^4 - (11*z^4)/a^2 + 
  3*a^2*z^4 + z^5/a^5 + z^5/a^3 + (4*z^5)/a + 4*a*z^5 + 3*z^6 + (2*z^6)/a^4 + 
  (5*z^6)/a^2 + z^7/a^3 + z^7/a, 1 + a*z + 3*a^3*z + 3*a^5*z + a^7*z - 
  2*z^2 - a^2*z^2 + 3*a^4*z^2 + a^6*z^2 - a^8*z^2 - 3*a*z^3 - 6*a^3*z^3 - 
  8*a^5*z^3 - 5*a^7*z^3 + z^4 - a^2*z^4 - 7*a^4*z^4 - 4*a^6*z^4 + a^8*z^4 + 
  2*a*z^5 + 3*a^3*z^5 + 4*a^5*z^5 + 3*a^7*z^5 + 2*a^2*z^6 + 5*a^4*z^6 + 
  3*a^6*z^6 + a^3*z^7 + a^5*z^7, a^4 - 3*a^6 - 4*a^8 - a^10 + 6*a^7*z + 
  8*a^9*z + 2*a^11*z - 2*a^4*z^2 + 5*a^6*z^2 + 8*a^8*z^2 - a^12*z^2 - 
  2*a^5*z^3 - 11*a^7*z^3 - 14*a^9*z^3 - 5*a^11*z^3 + a^4*z^4 - 5*a^6*z^4 - 
  10*a^8*z^4 - 3*a^10*z^4 + a^12*z^4 + 2*a^5*z^5 + 5*a^7*z^5 + 6*a^9*z^5 + 
  3*a^11*z^5 + 3*a^6*z^6 + 6*a^8*z^6 + 3*a^10*z^6 + a^7*z^7 + a^9*z^7, 
 -2*a^2 - a^4 + z/a + 3*a*z + 4*a^3*z + 2*a^5*z + 5*z^2 + 10*a^2*z^2 + 
  4*a^4*z^2 - a^6*z^2 - (2*z^3)/a - 6*a*z^3 - 10*a^3*z^3 - 5*a^5*z^3 + 
  a^7*z^3 - 8*z^4 - 18*a^2*z^4 - 7*a^4*z^4 + 3*a^6*z^4 + z^5/a - a*z^5 + 
  3*a^3*z^5 + 5*a^5*z^5 + 3*z^6 + 8*a^2*z^6 + 5*a^4*z^6 + 2*a*z^7 + 
  2*a^3*z^7, -1 - a^(-2) - a^2 + z/a^3 + (2*z)/a + 2*a*z + a^3*z + 8*z^2 - 
  z^2/a^4 + (3*z^2)/a^2 + 3*a^2*z^2 - a^4*z^2 - (4*z^3)/a^3 - (6*z^3)/a - 
  6*a*z^3 - 4*a^3*z^3 - 14*z^4 + z^4/a^4 - (6*z^4)/a^2 - 6*a^2*z^4 + 
  a^4*z^4 + (3*z^5)/a^3 + (2*z^5)/a + 2*a*z^5 + 3*a^3*z^5 + 8*z^6 + 
  (4*z^6)/a^2 + 4*a^2*z^6 + (2*z^7)/a + 2*a*z^7, 
 3 + a^(-2) + a^2 + z/a + a*z + 6*z^2 + (3*z^2)/a^2 + 3*a^2*z^2 - 
  (4*z^3)/a^3 - (9*z^3)/a - 9*a*z^3 - 4*a^3*z^3 - 20*z^4 + z^4/a^4 - 
  (9*z^4)/a^2 - 9*a^2*z^4 + a^4*z^4 + (4*z^5)/a^3 + (3*z^5)/a + 3*a*z^5 + 
  4*a^3*z^5 + 12*z^6 + (6*z^6)/a^2 + 6*a^2*z^6 + (3*z^7)/a + 3*a*z^7, 
 -a^(-10) - 5/a^8 - 5/a^6 + (5*z)/a^9 + (5*z)/a^7 + (10*z^2)/a^8 + 
  (10*z^2)/a^6 - (5*z^3)/a^9 - (5*z^3)/a^7 - (6*z^4)/a^8 - (6*z^4)/a^6 + 
  z^5/a^9 + z^5/a^7 + z^6/a^8 + z^6/a^6, -1 - 4*a^2 - 2*a^4 + z/a + 3*a*z + 
  5*a^3*z + 3*a^5*z + 2*z^2 + 6*a^2*z^2 + 4*a^4*z^2 - 3*a*z^3 - 7*a^3*z^3 - 
  4*a^5*z^3 - 4*a^2*z^4 - 4*a^4*z^4 + a*z^5 + 2*a^3*z^5 + a^5*z^5 + a^2*z^6 + 
  a^4*z^6, -3*a^2 - 3*a^4 - a^6 + 2*a^3*z + 4*a^5*z + 2*a^7*z + 3*a^2*z^2 + 
  5*a^4*z^2 - 2*a^8*z^2 - a^3*z^3 - 6*a^5*z^3 - 5*a^7*z^3 - 2*a^4*z^4 - 
  a^6*z^4 + a^8*z^4 + a^3*z^5 + 3*a^5*z^5 + 2*a^7*z^5 + a^4*z^6 + a^6*z^6, 
 5*a^8 + 4*a^10 - 4*a^9*z - a^11*z + a^13*z - a^15*z + a^17*z - 20*a^8*z^2 - 
  14*a^10*z^2 + 3*a^12*z^2 - 2*a^14*z^2 + a^16*z^2 + 10*a^9*z^3 + 
  6*a^11*z^3 - 3*a^13*z^3 + a^15*z^3 + 21*a^8*z^4 + 16*a^10*z^4 - 
  4*a^12*z^4 + a^14*z^4 - 6*a^9*z^5 - 5*a^11*z^5 + a^13*z^5 - 8*a^8*z^6 - 
  7*a^10*z^6 + a^12*z^6 + a^9*z^7 + a^11*z^7 + a^8*z^8 + a^10*z^8, 
 -a^2 + a^8 + a^10 - 4*a^9*z - 4*a^11*z + a^2*z^2 - 6*a^8*z^2 - 7*a^10*z^2 + 
  a^3*z^3 - a^5*z^3 + a^7*z^3 + 13*a^9*z^3 + 10*a^11*z^3 + a^4*z^4 - 
  2*a^6*z^4 + 8*a^8*z^4 + 11*a^10*z^4 + a^5*z^5 - 3*a^7*z^5 - 10*a^9*z^5 - 
  6*a^11*z^5 + a^6*z^6 - 5*a^8*z^6 - 6*a^10*z^6 + a^7*z^7 + 2*a^9*z^7 + 
  a^11*z^7 + a^8*z^8 + a^10*z^8, 3/a^10 + 3/a^8 - a^(-6) - (2*z)/a^15 + 
  z/a^13 - z/a^11 - (4*z)/a^9 - z^2/a^14 + (3*z^2)/a^12 - (11*z^2)/a^10 - 
  (9*z^2)/a^8 + (6*z^2)/a^6 + z^3/a^15 - z^3/a^13 + (4*z^3)/a^11 + 
  (9*z^3)/a^9 + (3*z^3)/a^7 + z^4/a^14 - (2*z^4)/a^12 + (11*z^4)/a^10 + 
  (9*z^4)/a^8 - (5*z^4)/a^6 + z^5/a^13 - (3*z^5)/a^11 - (8*z^5)/a^9 - 
  (4*z^5)/a^7 + z^6/a^12 - (5*z^6)/a^10 - (5*z^6)/a^8 + z^6/a^6 + z^7/a^11 + 
  (2*z^7)/a^9 + z^7/a^7 + z^8/a^10 + z^8/a^8, 
 a^4 + 2*a^8 + 2*a^10 - 4*a^9*z - a^11*z + 3*a^13*z - 3*a^4*z^2 + a^6*z^2 - 
  7*a^8*z^2 - 10*a^10*z^2 + a^12*z^2 - 2*a^5*z^3 + 4*a^7*z^3 + 12*a^9*z^3 + 
  2*a^11*z^3 - 4*a^13*z^3 + a^4*z^4 - 2*a^6*z^4 + 11*a^8*z^4 + 11*a^10*z^4 - 
  3*a^12*z^4 + a^5*z^5 - 3*a^7*z^5 - 8*a^9*z^5 - 3*a^11*z^5 + a^13*z^5 + 
  a^6*z^6 - 5*a^8*z^6 - 5*a^10*z^6 + a^12*z^6 + a^7*z^7 + 2*a^9*z^7 + 
  a^11*z^7 + a^8*z^8 + a^10*z^8, a^(-10) - a^(-6) + a^(-4) - (6*z)/a^11 - 
  (6*z)/a^9 - (3*z^2)/a^10 + (4*z^2)/a^8 + (3*z^2)/a^6 - (3*z^2)/a^4 + 
  z^2/a^2 + (11*z^3)/a^11 + (18*z^3)/a^9 + z^3/a^7 - (4*z^3)/a^5 + 
  (2*z^3)/a^3 + (7*z^4)/a^10 - (3*z^4)/a^8 - (7*z^4)/a^6 + (3*z^4)/a^4 - 
  (6*z^5)/a^11 - (14*z^5)/a^9 - (5*z^5)/a^7 + (3*z^5)/a^5 - (5*z^6)/a^10 - 
  (2*z^6)/a^8 + (3*z^6)/a^6 + z^7/a^11 + (3*z^7)/a^9 + (2*z^7)/a^7 + 
  z^8/a^10 + z^8/a^8, -3*a^6 - a^8 + a^10 + 2*a^7*z - a^9*z - 2*a^11*z - 
  a^15*z + 7*a^6*z^2 + a^8*z^2 - 3*a^10*z^2 + a^12*z^2 - 2*a^14*z^2 + 
  8*a^9*z^3 + 6*a^11*z^3 - a^13*z^3 + a^15*z^3 - 5*a^6*z^4 + a^8*z^4 + 
  2*a^10*z^4 - 2*a^12*z^4 + 2*a^14*z^4 - 3*a^7*z^5 - 10*a^9*z^5 - 
  5*a^11*z^5 + 2*a^13*z^5 + a^6*z^6 - 3*a^8*z^6 - 2*a^10*z^6 + 2*a^12*z^6 + 
  a^7*z^7 + 3*a^9*z^7 + 2*a^11*z^7 + a^8*z^8 + a^10*z^8, 
 2*a^4 + a^6 + a^8 + a^10 - a^5*z - a^7*z - 3*a^9*z - 2*a^11*z + a^13*z - 
  3*a^4*z^2 - 2*a^6*z^2 - 4*a^8*z^2 - 2*a^10*z^2 + 3*a^12*z^2 - a^5*z^3 + 
  2*a^7*z^3 + 11*a^9*z^3 + 5*a^11*z^3 - 3*a^13*z^3 + a^4*z^4 + 7*a^8*z^4 + 
  2*a^10*z^4 - 6*a^12*z^4 + a^5*z^5 - a^7*z^5 - 9*a^9*z^5 - 6*a^11*z^5 + 
  a^13*z^5 + a^6*z^6 - 3*a^8*z^6 - 2*a^10*z^6 + 2*a^12*z^6 + a^7*z^7 + 
  3*a^9*z^7 + 2*a^11*z^7 + a^8*z^8 + a^10*z^8, 
 -1 - a^(-2) + 2*a^4 + a^6 - (2*z)/a - 3*a*z - a^3*z - a^5*z - a^7*z + 
  7*z^2 + (4*z^2)/a^2 + 2*a^2*z^2 - 3*a^4*z^2 - 2*a^6*z^2 + (8*z^3)/a + 
  11*a*z^3 + 2*a^3*z^3 + a^7*z^3 - 6*z^4 - (4*z^4)/a^2 - 4*a^2*z^4 + 
  2*a^6*z^4 - (8*z^5)/a - 13*a*z^5 - 3*a^3*z^5 + 2*a^5*z^5 - z^6 + z^6/a^2 + 
  2*a^4*z^6 + (2*z^7)/a + 4*a*z^7 + 2*a^3*z^7 + z^8 + a^2*z^8, 
 -2*a^6 + a^8 + 2*a^10 + a^7*z - 2*a^9*z + 2*a^13*z - a^15*z + 7*a^6*z^2 - 
  3*a^8*z^2 - 6*a^10*z^2 + 3*a^12*z^2 - a^14*z^2 + a^7*z^3 + 5*a^9*z^3 - 
  3*a^13*z^3 + a^15*z^3 - 5*a^6*z^4 + 3*a^8*z^4 + 2*a^10*z^4 - 4*a^12*z^4 + 
  2*a^14*z^4 - 3*a^7*z^5 - 8*a^9*z^5 - 2*a^11*z^5 + 3*a^13*z^5 + a^6*z^6 - 
  3*a^8*z^6 - a^10*z^6 + 3*a^12*z^6 + a^7*z^7 + 3*a^9*z^7 + 2*a^11*z^7 + 
  a^8*z^8 + a^10*z^8, 2/a^10 + a^(-8) - 2/a^6 + (4*z)/a^13 - (4*z)/a^9 - 
  (11*z^2)/a^10 - (2*z^2)/a^8 + (7*z^2)/a^6 - (2*z^2)/a^4 - (4*z^3)/a^13 - 
  z^3/a^11 + (9*z^3)/a^9 + (3*z^3)/a^7 - (3*z^3)/a^5 - (2*z^4)/a^12 + 
  (9*z^4)/a^10 + (3*z^4)/a^8 - (7*z^4)/a^6 + z^4/a^4 + z^5/a^13 - z^5/a^11 - 
  (7*z^5)/a^9 - (3*z^5)/a^7 + (2*z^5)/a^5 + z^6/a^12 - (3*z^6)/a^10 - 
  z^6/a^8 + (3*z^6)/a^6 + z^7/a^11 + (3*z^7)/a^9 + (2*z^7)/a^7 + z^8/a^10 + 
  z^8/a^8, -2/a^8 - 3/a^6 - a^(-4) - a^(-2) - z/a^11 + (2*z)/a^9 + 
  (2*z)/a^7 - (2*z)/a^5 - z/a^3 - z^2/a^10 + (4*z^2)/a^8 + (6*z^2)/a^6 + 
  (5*z^2)/a^4 + (4*z^2)/a^2 + z^3/a^11 - (3*z^3)/a^9 - (3*z^3)/a^7 + 
  (9*z^3)/a^5 + (8*z^3)/a^3 + (2*z^4)/a^10 - (4*z^4)/a^8 - (7*z^4)/a^6 - 
  (5*z^4)/a^4 - (4*z^4)/a^2 + (3*z^5)/a^9 - z^5/a^7 - (12*z^5)/a^5 - 
  (8*z^5)/a^3 + (3*z^6)/a^8 + z^6/a^6 - z^6/a^4 + z^6/a^2 + (2*z^7)/a^7 + 
  (4*z^7)/a^5 + (2*z^7)/a^3 + z^8/a^6 + z^8/a^4, 
 1 - a^4 - 2*a^6 - a^8 - 2*a^3*z - 4*a^5*z - a^7*z + a^9*z - 2*z^2 - 
  2*a^2*z^2 + 3*a^4*z^2 + 7*a^6*z^2 + 4*a^8*z^2 - 3*a*z^3 + 4*a^3*z^3 + 
  13*a^5*z^3 + 3*a^7*z^3 - 3*a^9*z^3 + z^4 - a^2*z^4 - a^4*z^4 - 5*a^6*z^4 - 
  6*a^8*z^4 + 2*a*z^5 - 3*a^3*z^5 - 11*a^5*z^5 - 5*a^7*z^5 + a^9*z^5 + 
  2*a^2*z^6 + 2*a^8*z^6 + 2*a^3*z^7 + 4*a^5*z^7 + 2*a^7*z^7 + a^4*z^8 + 
  a^6*z^8, a^(-10) - a^(-8) - 3/a^6 + (2*z)/a^13 - (2*z)/a^11 - (3*z)/a^9 + 
  z/a^7 + (2*z^2)/a^12 - (2*z^2)/a^10 + (6*z^2)/a^8 + (8*z^2)/a^6 - 
  (2*z^2)/a^4 - (3*z^3)/a^13 + (2*z^3)/a^11 + (9*z^3)/a^9 + z^3/a^7 - 
  (3*z^3)/a^5 - (5*z^4)/a^12 - z^4/a^10 - (4*z^4)/a^8 - (7*z^4)/a^6 + 
  z^4/a^4 + z^5/a^13 - (4*z^5)/a^11 - (9*z^5)/a^9 - (2*z^5)/a^7 + 
  (2*z^5)/a^5 + (2*z^6)/a^12 + z^6/a^8 + (3*z^6)/a^6 + (2*z^7)/a^11 + 
  (4*z^7)/a^9 + (2*z^7)/a^7 + z^8/a^10 + z^8/a^8, 
 1 - a^(-6) - 2/a^4 - a^(-2) - (3*z)/a^5 - (5*z)/a^3 - (2*z)/a + 
  (4*z^2)/a^6 + (10*z^2)/a^4 + (8*z^2)/a^2 - 2*a^2*z^2 + (9*z^3)/a^5 + 
  (15*z^3)/a^3 + (2*z^3)/a - 3*a*z^3 + a^3*z^3 - 4*z^4 - (4*z^4)/a^6 - 
  (9*z^4)/a^4 - (12*z^4)/a^2 + 3*a^2*z^4 - (8*z^5)/a^5 - (16*z^5)/a^3 - 
  (4*z^5)/a + 4*a*z^5 + 4*z^6 + z^6/a^6 + (3*z^6)/a^2 + (2*z^7)/a^5 + 
  (5*z^7)/a^3 + (3*z^7)/a + z^8/a^4 + z^8/a^2, 
 1 - a^(-8) - a^(-6) + a^(-4) + a^(-2) + (2*z)/a^9 + z/a^7 - z/a^5 + z/a^3 + 
  z/a - 2*z^2 + (3*z^2)/a^8 + (2*z^2)/a^6 - (2*z^2)/a^4 - (3*z^2)/a^2 - 
  (3*z^3)/a^9 - z^3/a^7 + (5*z^3)/a^5 - (3*z^3)/a + z^4 - (5*z^4)/a^8 - 
  (4*z^4)/a^6 + z^5/a^9 - (3*z^5)/a^7 - (7*z^5)/a^5 - z^5/a^3 + (2*z^5)/a + 
  (2*z^6)/a^8 + z^6/a^6 + z^6/a^4 + (2*z^6)/a^2 + (2*z^7)/a^7 + (4*z^7)/a^5 + 
  (2*z^7)/a^3 + z^8/a^6 + z^8/a^4, -3/a^8 - 4/a^6 + (2*z)/a^13 + (2*z)/a^11 + 
  (4*z)/a^9 + (4*z)/a^7 - z^2/a^14 + (2*z^2)/a^12 + z^2/a^10 + (6*z^2)/a^8 + 
  (8*z^2)/a^6 + z^3/a^15 - (5*z^3)/a^13 - (5*z^3)/a^11 - z^3/a^9 - 
  (2*z^3)/a^7 + (3*z^4)/a^14 - (6*z^4)/a^12 - (8*z^4)/a^10 - (4*z^4)/a^8 - 
  (5*z^4)/a^6 + (5*z^5)/a^13 - z^5/a^11 - (8*z^5)/a^9 - (2*z^5)/a^7 + 
  (5*z^6)/a^12 + (3*z^6)/a^10 - z^6/a^8 + z^6/a^6 + (3*z^7)/a^11 + 
  (4*z^7)/a^9 + z^7/a^7 + z^8/a^10 + z^8/a^8, 
 -3 - 2/a^2 - 2*a^2 - z/a + a*z + 3*a^3*z + a^5*z + 13*z^2 + (5*z^2)/a^2 + 
  9*a^2*z^2 - a^4*z^2 - 2*a^6*z^2 + (6*z^3)/a + 6*a*z^3 - 4*a^3*z^3 - 
  3*a^5*z^3 + a^7*z^3 - 12*z^4 - (4*z^4)/a^2 - 14*a^2*z^4 - 3*a^4*z^4 + 
  3*a^6*z^4 - (7*z^5)/a - 13*a*z^5 - 2*a^3*z^5 + 4*a^5*z^5 + z^6 + z^6/a^2 + 
  4*a^2*z^6 + 4*a^4*z^6 + (2*z^7)/a + 5*a*z^7 + 3*a^3*z^7 + z^8 + a^2*z^8, 
 a^4 - a^6 + a^10 + 2*a^7*z + 2*a^13*z - 2*a^4*z^2 + 3*a^6*z^2 - 2*a^10*z^2 + 
  3*a^12*z^2 - 2*a^5*z^3 - 4*a^7*z^3 + a^9*z^3 - 3*a^13*z^3 + a^4*z^4 - 
  4*a^6*z^4 - 2*a^8*z^4 - 2*a^10*z^4 - 5*a^12*z^4 + 2*a^5*z^5 + a^7*z^5 - 
  5*a^9*z^5 - 3*a^11*z^5 + a^13*z^5 + 3*a^6*z^6 + 2*a^8*z^6 + a^10*z^6 + 
  2*a^12*z^6 + 2*a^7*z^7 + 4*a^9*z^7 + 2*a^11*z^7 + a^8*z^8 + a^10*z^8, 
 a^(-4) + a^(-2) - a^2 + z/a^3 - z/a - 3*a*z - a^3*z + 3*z^2 - (2*z^2)/a^4 - 
  (3*z^2)/a^2 + 8*a^2*z^2 + 4*a^4*z^2 - (3*z^3)/a^3 + z^3/a + 10*a*z^3 + 
  4*a^3*z^3 - 2*a^5*z^3 - 4*z^4 + z^4/a^4 - 11*a^2*z^4 - 8*a^4*z^4 + 
  (2*z^5)/a^3 - z^5/a - 11*a*z^5 - 7*a^3*z^5 + a^5*z^5 + 2*z^6 + 
  (2*z^6)/a^2 + 3*a^2*z^6 + 3*a^4*z^6 + (2*z^7)/a + 5*a*z^7 + 3*a^3*z^7 + 
  z^8 + a^2*z^8, -2*a^2 - 2*a^4 - 2*a^6 - a^8 + 2*a^7*z + 2*a^9*z + 
  5*a^2*z^2 + 11*a^4*z^2 + 10*a^6*z^2 + 3*a^8*z^2 - a^10*z^2 + 6*a^3*z^3 + 
  5*a^5*z^3 - 7*a^7*z^3 - 5*a^9*z^3 + a^11*z^3 - 4*a^2*z^4 - 11*a^4*z^4 - 
  16*a^6*z^4 - 6*a^8*z^4 + 3*a^10*z^4 - 7*a^3*z^5 - 12*a^5*z^5 + 5*a^9*z^5 + 
  a^2*z^6 + a^4*z^6 + 5*a^6*z^6 + 5*a^8*z^6 + 2*a^3*z^7 + 5*a^5*z^7 + 
  3*a^7*z^7 + a^4*z^8 + a^6*z^8, -a^(-8) - a^(-6) - a^(-2) + (2*z)/a^9 - 
  (3*z)/a^5 - z/a^3 - z^2 + (3*z^2)/a^8 + (5*z^2)/a^6 + (6*z^2)/a^4 + 
  (3*z^2)/a^2 - (3*z^3)/a^9 + (9*z^3)/a^5 + (2*z^3)/a^3 - (4*z^3)/a + z^4 - 
  (5*z^4)/a^8 - (7*z^4)/a^6 - (9*z^4)/a^4 - (6*z^4)/a^2 + z^5/a^9 - 
  (3*z^5)/a^7 - (10*z^5)/a^5 - (3*z^5)/a^3 + (3*z^5)/a + (2*z^6)/a^8 + 
  (2*z^6)/a^6 + (4*z^6)/a^4 + (4*z^6)/a^2 + (2*z^7)/a^7 + (5*z^7)/a^5 + 
  (3*z^7)/a^3 + z^8/a^6 + z^8/a^4, -4 - a^(-4) - 4/a^2 - 2*a^2 + z/a^5 + 
  z/a^3 - (2*z)/a - 2*a*z + 16*z^2 - z^2/a^6 + (5*z^2)/a^4 + (17*z^2)/a^2 + 
  5*a^2*z^2 + z^3/a^7 - (4*z^3)/a^5 - (2*z^3)/a^3 + (10*z^3)/a + 7*a*z^3 - 
  15*z^4 + (3*z^4)/a^6 - (9*z^4)/a^4 - (23*z^4)/a^2 - 4*a^2*z^4 + 
  (5*z^5)/a^5 - (4*z^5)/a^3 - (16*z^5)/a - 7*a*z^5 + 2*z^6 + (6*z^6)/a^4 + 
  (7*z^6)/a^2 + a^2*z^6 + (4*z^7)/a^3 + (6*z^7)/a + 2*a*z^7 + z^8 + z^8/a^2, 
 a^4 - 2*a^6 - 2*a^8 + 4*a^7*z + 4*a^9*z + a^11*z + a^13*z - 2*a^4*z^2 + 
  4*a^6*z^2 + 6*a^8*z^2 + 3*a^10*z^2 + 3*a^12*z^2 - 2*a^5*z^3 - 6*a^7*z^3 - 
  2*a^9*z^3 - 2*a^13*z^3 + a^4*z^4 - 4*a^6*z^4 - 8*a^8*z^4 - 10*a^10*z^4 - 
  7*a^12*z^4 + 2*a^5*z^5 + 2*a^7*z^5 - 6*a^9*z^5 - 5*a^11*z^5 + a^13*z^5 + 
  3*a^6*z^6 + 4*a^8*z^6 + 4*a^10*z^6 + 3*a^12*z^6 + 2*a^7*z^7 + 5*a^9*z^7 + 
  3*a^11*z^7 + a^8*z^8 + a^10*z^8, -3 - a^(-2) - 5*a^2 - 2*a^4 + z/a^3 + 
  (2*z)/a + 2*a*z + 3*a^3*z + 2*a^5*z + 9*z^2 - z^2/a^4 + (2*z^2)/a^2 + 
  10*a^2*z^2 + 4*a^4*z^2 - (4*z^3)/a^3 - (3*z^3)/a + a*z^3 - 3*a^3*z^3 - 
  3*a^5*z^3 - 11*z^4 + z^4/a^4 - (5*z^4)/a^2 - 10*a^2*z^4 - 5*a^4*z^4 + 
  (3*z^5)/a^3 - z^5/a - 7*a*z^5 - 2*a^3*z^5 + a^5*z^5 + 5*z^6 + (4*z^6)/a^2 + 
  3*a^2*z^6 + 2*a^4*z^6 + (3*z^7)/a + 5*a*z^7 + 2*a^3*z^7 + z^8 + a^2*z^8, 
 1 - a^2 - 3*a^4 - 3*a^6 - a^8 - a^3*z - a^5*z + a^7*z + a^9*z - 2*z^2 + 
  2*a^2*z^2 + 13*a^4*z^2 + 13*a^6*z^2 + 4*a^8*z^2 - 2*a*z^3 + 3*a^3*z^3 + 
  5*a^5*z^3 - 2*a^7*z^3 - 2*a^9*z^3 + z^4 - 3*a^2*z^4 - 15*a^4*z^4 - 
  18*a^6*z^4 - 7*a^8*z^4 + 2*a*z^5 - 3*a^3*z^5 - 10*a^5*z^5 - 4*a^7*z^5 + 
  a^9*z^5 + 3*a^2*z^6 + 6*a^4*z^6 + 6*a^6*z^6 + 3*a^8*z^6 + 3*a^3*z^7 + 
  6*a^5*z^7 + 3*a^7*z^7 + a^4*z^8 + a^6*z^8, -a^(-6) - 3/a^4 - 3/a^2 + 
  z/a^7 + z/a^5 - z/a^3 - z/a + 5*z^2 - z^2/a^8 + (2*z^2)/a^6 + 
  (11*z^2)/a^4 + (13*z^2)/a^2 - (4*z^3)/a^7 - (2*z^3)/a^5 + (7*z^3)/a^3 + 
  (3*z^3)/a - 2*a*z^3 - 8*z^4 + z^4/a^8 - (5*z^4)/a^6 - (14*z^4)/a^4 - 
  (16*z^4)/a^2 + (3*z^5)/a^7 - z^5/a^5 - (11*z^5)/a^3 - (6*z^5)/a + a*z^5 + 
  3*z^6 + (4*z^6)/a^6 + (6*z^6)/a^4 + (5*z^6)/a^2 + (3*z^7)/a^5 + 
  (6*z^7)/a^3 + (3*z^7)/a + z^8/a^4 + z^8/a^2, 
 -2 - a^(-2) - 3*a^2 - a^4 + z/a^3 + (2*z)/a + 2*a*z + 2*a^3*z + a^5*z + 
  12*z^2 - z^2/a^4 + (3*z^2)/a^2 + 12*a^2*z^2 + 4*a^4*z^2 - (4*z^3)/a^3 - 
  (4*z^3)/a - 2*a^3*z^3 - 2*a^5*z^3 - 16*z^4 + z^4/a^4 - (5*z^4)/a^2 - 
  17*a^2*z^4 - 7*a^4*z^4 + (3*z^5)/a^3 - 8*a*z^5 - 4*a^3*z^5 + a^5*z^5 + 
  7*z^6 + (4*z^6)/a^2 + 6*a^2*z^6 + 3*a^4*z^6 + (3*z^7)/a + 6*a*z^7 + 
  3*a^3*z^7 + z^8 + a^2*z^8, -1 - 5*a^2 - 4*a^4 - a^6 + z/a + 3*a*z + 
  6*a^3*z + 6*a^5*z + 2*a^7*z + 5*z^2 + 14*a^2*z^2 + 12*a^4*z^2 + 2*a^6*z^2 - 
  a^8*z^2 - (2*z^3)/a - 4*a*z^3 - 7*a^3*z^3 - 9*a^5*z^3 - 4*a^7*z^3 - 7*z^4 - 
  19*a^2*z^4 - 17*a^4*z^4 - 4*a^6*z^4 + a^8*z^4 + z^5/a - 3*a*z^5 - 
  5*a^3*z^5 + 2*a^5*z^5 + 3*a^7*z^5 + 3*z^6 + 7*a^2*z^6 + 8*a^4*z^6 + 
  4*a^6*z^6 + 3*a*z^7 + 6*a^3*z^7 + 3*a^5*z^7 + a^2*z^8 + a^4*z^8, 
 -3 - a^(-2) - 5*a^2 - 2*a^4 - z/a - a*z + 2*a^3*z + 2*a^5*z + 12*z^2 + 
  (3*z^2)/a^2 + 17*a^2*z^2 + 8*a^4*z^2 + (9*z^3)/a + 14*a*z^3 - a^3*z^3 - 
  5*a^5*z^3 + a^7*z^3 - 11*z^4 - (3*z^4)/a^2 - 24*a^2*z^4 - 13*a^4*z^4 + 
  3*a^6*z^4 - (10*z^5)/a - 24*a*z^5 - 8*a^3*z^5 + 6*a^5*z^5 - z^6 + z^6/a^2 + 
  6*a^2*z^6 + 8*a^4*z^6 + (3*z^7)/a + 9*a*z^7 + 6*a^3*z^7 + 2*z^8 + 
  2*a^2*z^8, -4 - 2/a^2 - 4*a^2 - a^4 + z/a^3 + z/a + a*z + 2*a^3*z + a^5*z + 
  17*z^2 - z^2/a^4 + (5*z^2)/a^2 + 16*a^2*z^2 + 5*a^4*z^2 - (3*z^3)/a^3 - 
  (2*z^3)/a - 3*a^3*z^3 - 2*a^5*z^3 - 23*z^4 + z^4/a^4 - (7*z^4)/a^2 - 
  22*a^2*z^4 - 7*a^4*z^4 + (3*z^5)/a^3 - (2*z^5)/a - 9*a*z^5 - 3*a^3*z^5 + 
  a^5*z^5 + 10*z^6 + (5*z^6)/a^2 + 8*a^2*z^6 + 3*a^4*z^6 + (4*z^7)/a + 
  7*a*z^7 + 3*a^3*z^7 + z^8 + a^2*z^8, -1 - 4*a^2 - 2*a^4 + z/a + 3*a*z + 
  5*a^3*z + 3*a^5*z + 5*z^2 + 15*a^2*z^2 + 13*a^4*z^2 + 3*a^6*z^2 - 
  (2*z^3)/a - 3*a*z^3 - 5*a^3*z^3 - 8*a^5*z^3 - 4*a^7*z^3 - 7*z^4 - 
  21*a^2*z^4 - 23*a^4*z^4 - 8*a^6*z^4 + a^8*z^4 + z^5/a - 3*a*z^5 - 
  7*a^3*z^5 + a^5*z^5 + 4*a^7*z^5 + 3*z^6 + 8*a^2*z^6 + 11*a^4*z^6 + 
  6*a^6*z^6 + 3*a*z^7 + 7*a^3*z^7 + 4*a^5*z^7 + a^2*z^8 + a^4*z^8, 
 1 - a^(-6) - 2/a^4 - a^(-2) + z/a^7 - (2*z)/a^3 - z/a + 3*z^2 - z^2/a^8 + 
  (4*z^2)/a^6 + (12*z^2)/a^4 + (10*z^2)/a^2 - (3*z^3)/a^7 + (2*z^3)/a^5 + 
  (9*z^3)/a^3 + (3*z^3)/a - a*z^3 - 8*z^4 + z^4/a^8 - (6*z^4)/a^6 - 
  (18*z^4)/a^4 - (19*z^4)/a^2 + (3*z^5)/a^7 - (5*z^5)/a^5 - (18*z^5)/a^3 - 
  (9*z^5)/a + a*z^5 + 4*z^6 + (5*z^6)/a^6 + (7*z^6)/a^4 + (6*z^6)/a^2 + 
  (5*z^7)/a^5 + (10*z^7)/a^3 + (5*z^7)/a + (2*z^8)/a^4 + (2*z^8)/a^2, 
 -2*a^2 - a^4 + a^3*z + a^5*z + 9*z^2 + (3*z^2)/a^2 + 10*a^2*z^2 + 
  4*a^4*z^2 - (3*z^3)/a^3 - z^3/a + 5*a*z^3 + a^3*z^3 - 2*a^5*z^3 - 20*z^4 + 
  z^4/a^4 - (9*z^4)/a^2 - 16*a^2*z^4 - 6*a^4*z^4 + (4*z^5)/a^3 - (5*z^5)/a - 
  16*a*z^5 - 6*a^3*z^5 + a^5*z^5 + 9*z^6 + (7*z^6)/a^2 + 5*a^2*z^6 + 
  3*a^4*z^6 + (6*z^7)/a + 10*a*z^7 + 4*a^3*z^7 + 2*z^8 + 2*a^2*z^8, 
 -1 - a^(-2) - a^2 - z/a - a*z + 11*z^2 + (4*z^2)/a^2 + 10*a^2*z^2 + 
  3*a^4*z^2 - (2*z^3)/a^3 + (4*z^3)/a + 12*a*z^3 + 5*a^3*z^3 - a^5*z^3 - 
  23*z^4 + z^4/a^4 - (10*z^4)/a^2 - 19*a^2*z^4 - 7*a^4*z^4 + (4*z^5)/a^3 - 
  (10*z^5)/a - 26*a*z^5 - 11*a^3*z^5 + a^5*z^5 + 9*z^6 + (8*z^6)/a^2 + 
  5*a^2*z^6 + 4*a^4*z^6 + (8*z^7)/a + 14*a*z^7 + 6*a^3*z^7 + 3*z^8 + 
  3*a^2*z^8, -3*a^6 - a^8 + a^10 - a^7*z - 9*a^9*z - 8*a^11*z + a^2*z^2 - 
  2*a^4*z^2 + 12*a^6*z^2 + 16*a^8*z^2 + a^10*z^2 + 2*a^3*z^3 - 6*a^5*z^3 + 
  3*a^7*z^3 + 23*a^9*z^3 + 12*a^11*z^3 + 3*a^4*z^4 - 15*a^6*z^4 - 
  15*a^8*z^4 + 3*a^10*z^4 + 4*a^5*z^5 - 8*a^7*z^5 - 18*a^9*z^5 - 6*a^11*z^5 + 
  5*a^6*z^6 + a^8*z^6 - 4*a^10*z^6 + 3*a^7*z^7 + 4*a^9*z^7 + a^11*z^7 + 
  a^8*z^8 + a^10*z^8, -2/a^8 - 4/a^6 - 3/a^4 - 2/a^2 - z/a^11 + z/a^9 + 
  z/a^7 - (2*z)/a^5 - z/a^3 - z^2/a^10 + (7*z^2)/a^8 + (15*z^2)/a^6 + 
  (12*z^2)/a^4 + (5*z^2)/a^2 + z^3/a^11 - (2*z^3)/a^9 + (9*z^3)/a^5 + 
  (6*z^3)/a^3 + (2*z^4)/a^10 - (7*z^4)/a^8 - (17*z^4)/a^6 - (12*z^4)/a^4 - 
  (4*z^4)/a^2 + (3*z^5)/a^9 - (4*z^5)/a^7 - (14*z^5)/a^5 - (7*z^5)/a^3 + 
  (4*z^6)/a^8 + (4*z^6)/a^6 + z^6/a^4 + z^6/a^2 + (3*z^7)/a^7 + (5*z^7)/a^5 + 
  (2*z^7)/a^3 + z^8/a^6 + z^8/a^4, -2 + a^(-4) - 2*a^2 - (5*z)/a - 7*a*z - 
  2*a^3*z + 12*z^2 - (2*z^2)/a^4 + z^2/a^2 + 14*a^2*z^2 + 5*a^4*z^2 - 
  (2*z^3)/a^3 + (6*z^3)/a + 13*a*z^3 + 3*a^3*z^3 - 2*a^5*z^3 - 13*z^4 + 
  z^4/a^4 - (3*z^4)/a^2 - 17*a^2*z^4 - 8*a^4*z^4 + (2*z^5)/a^3 - (4*z^5)/a - 
  13*a*z^5 - 6*a^3*z^5 + a^5*z^5 + 5*z^6 + (3*z^6)/a^2 + 5*a^2*z^6 + 
  3*a^4*z^6 + (3*z^7)/a + 6*a*z^7 + 3*a^3*z^7 + z^8 + a^2*z^8, 
 -4*a^6 - 3*a^8 + 3*a^7*z + a^9*z - a^11*z + a^13*z - a^4*z^2 + 9*a^6*z^2 + 
  10*a^8*z^2 + 3*a^10*z^2 + 3*a^12*z^2 - 2*a^5*z^3 - 2*a^7*z^3 + 5*a^9*z^3 + 
  3*a^11*z^3 - 2*a^13*z^3 + a^4*z^4 - 10*a^6*z^4 - 15*a^8*z^4 - 10*a^10*z^4 - 
  6*a^12*z^4 + 3*a^5*z^5 - 4*a^7*z^5 - 15*a^9*z^5 - 7*a^11*z^5 + a^13*z^5 + 
  6*a^6*z^6 + 6*a^8*z^6 + 3*a^10*z^6 + 3*a^12*z^6 + 5*a^7*z^7 + 9*a^9*z^7 + 
  4*a^11*z^7 + 2*a^8*z^8 + 2*a^10*z^8, -a^(-8) - 2/a^6 - 2/a^4 - 2/a^2 + 
  z/a^9 - z/a^7 - (3*z)/a^5 - z/a^3 - z^2 + (3*z^2)/a^8 + (9*z^2)/a^6 + 
  (12*z^2)/a^4 + (5*z^2)/a^2 - (2*z^3)/a^9 + (2*z^3)/a^7 + (12*z^3)/a^5 + 
  (5*z^3)/a^3 - (3*z^3)/a + z^4 - (6*z^4)/a^8 - (13*z^4)/a^6 - (15*z^4)/a^4 - 
  (7*z^4)/a^2 + z^5/a^9 - (7*z^5)/a^7 - (18*z^5)/a^5 - (7*z^5)/a^3 + 
  (3*z^5)/a + (3*z^6)/a^8 + (3*z^6)/a^6 + (5*z^6)/a^4 + (5*z^6)/a^2 + 
  (4*z^7)/a^7 + (9*z^7)/a^5 + (5*z^7)/a^3 + (2*z^8)/a^6 + (2*z^8)/a^4, 
 2 + 2*a^2 + a^4 - a^3*z - a^5*z + 3*a^2*z^2 + 7*a^4*z^2 + 4*a^6*z^2 + 
  6*a*z^3 + 14*a^3*z^3 + 6*a^5*z^3 - 2*a^7*z^3 - 7*z^4 - 17*a^2*z^4 - 
  20*a^4*z^4 - 9*a^6*z^4 + a^8*z^4 + z^5/a - 15*a*z^5 - 32*a^3*z^5 - 
  12*a^5*z^5 + 4*a^7*z^5 + 5*z^6 + 4*a^2*z^6 + 7*a^4*z^6 + 8*a^6*z^6 + 
  8*a*z^7 + 17*a^3*z^7 + 9*a^5*z^7 + 4*a^2*z^8 + 4*a^4*z^8, 
 -3*a^2 - 3*a^4 - a^6 - 2*a*z - 4*a^3*z - 2*a^5*z + 6*z^2 - z^2/a^2 + 
  17*a^2*z^2 + 13*a^4*z^2 + 3*a^6*z^2 + z^3/a^3 - (3*z^3)/a + 6*a*z^3 + 
  19*a^3*z^3 + 9*a^5*z^3 - 11*z^4 + (3*z^4)/a^2 - 23*a^2*z^4 - 12*a^4*z^4 - 
  3*a^6*z^4 + (5*z^5)/a - 11*a*z^5 - 26*a^3*z^5 - 10*a^5*z^5 + 7*z^6 + 
  5*a^2*z^6 - a^4*z^6 + a^6*z^6 + 6*a*z^7 + 9*a^3*z^7 + 3*a^5*z^7 + 
  2*a^2*z^8 + 2*a^4*z^8, -3 - 2/a^2 - 2*a^2 - (2*z)/a - 2*a*z + 12*z^2 + 
  (6*z^2)/a^2 + 6*a^2*z^2 + (6*z^3)/a + 6*a*z^3 - 10*z^4 - (5*z^4)/a^2 - 
  5*a^2*z^4 - (5*z^5)/a - 5*a*z^5 + 2*z^6 + z^6/a^2 + a^2*z^6 + z^7/a + 
  a*z^7, -a^(-8) - 3/a^6 - 4/a^4 - 3/a^2 + z/a^9 + z/a^7 + (2*z^2)/a^8 + 
  (9*z^2)/a^6 + (14*z^2)/a^4 + (7*z^2)/a^2 - (2*z^3)/a^7 + z^3/a^5 + 
  (3*z^3)/a^3 - (8*z^4)/a^6 - (13*z^4)/a^4 - (5*z^4)/a^2 + z^5/a^7 - 
  (3*z^5)/a^5 - (4*z^5)/a^3 + (2*z^6)/a^6 + (3*z^6)/a^4 + z^6/a^2 + z^7/a^5 + 
  z^7/a^3, -2 - a^(-2) - 3*a^2 - a^4 - z/a - a*z + a^3*z + a^5*z + 6*z^2 + 
  z^2/a^2 + 10*a^2*z^2 + 5*a^4*z^2 + (2*z^3)/a + 4*a*z^3 - a^3*z^3 - 
  3*a^5*z^3 - 3*z^4 - 10*a^2*z^4 - 7*a^4*z^4 - 3*a*z^5 - 2*a^3*z^5 + 
  a^5*z^5 + z^6 + 3*a^2*z^6 + 2*a^4*z^6 + a*z^7 + a^3*z^7, 
 -2*a^2 - 2*a^4 - 2*a^6 - a^8 + 2*a^7*z + 2*a^9*z + 3*a^2*z^2 + 6*a^4*z^2 + 
  7*a^6*z^2 + 4*a^8*z^2 + a^3*z^3 - a^5*z^3 - 5*a^7*z^3 - 3*a^9*z^3 - 
  4*a^4*z^4 - 10*a^6*z^4 - 6*a^8*z^4 + a^3*z^5 + a^9*z^5 + 2*a^4*z^6 + 
  4*a^6*z^6 + 2*a^8*z^6 + a^5*z^7 + a^7*z^7, 2 + a^2 - a^4 - a^6 - 2*a*z - 
  6*a^3*z - 4*a^5*z + 3*a^2*z^2 + 9*a^4*z^2 + 6*a^6*z^2 + a*z^3 + 8*a^3*z^3 + 
  7*a^5*z^3 - 4*a^2*z^4 - 9*a^4*z^4 - 5*a^6*z^4 - 5*a^3*z^5 - 5*a^5*z^5 + 
  a^2*z^6 + 2*a^4*z^6 + a^6*z^6 + a^3*z^7 + a^5*z^7, 
 1 - a^(-6) - 2/a^4 - a^(-2) - (3*z)/a^5 - (5*z)/a^3 - (2*z)/a + 5*z^2 + 
  (3*z^2)/a^6 + (9*z^2)/a^4 + (11*z^2)/a^2 + (3*z^3)/a^5 + (6*z^3)/a^3 + 
  z^3/a - 2*a*z^3 - 9*z^4 - (7*z^4)/a^4 - (16*z^4)/a^2 + z^5/a^5 - 
  (4*z^5)/a^3 - (4*z^5)/a + a*z^5 + 3*z^6 + (3*z^6)/a^4 + (6*z^6)/a^2 + 
  (2*z^7)/a^3 + (2*z^7)/a, 2/a^6 + 3/a^4 - (4*z)/a^7 - (5*z)/a^5 - z/a^3 - 
  z^2 - z^2/a^6 + (2*z^2)/a^4 + (2*z^2)/a^2 + (3*z^3)/a^7 + (5*z^3)/a^5 - 
  (3*z^3)/a^3 - (5*z^3)/a + z^4 - (6*z^4)/a^4 - (5*z^4)/a^2 - z^5/a^5 + 
  (2*z^5)/a^3 + (3*z^5)/a + z^6/a^6 + (4*z^6)/a^4 + (3*z^6)/a^2 + z^7/a^5 + 
  z^7/a^3, -3/a^8 - 4/a^6 - (4*z)/a^11 - (2*z)/a^9 + (2*z)/a^7 - z^2/a^10 + 
  (10*z^2)/a^8 + (9*z^2)/a^6 - (2*z^2)/a^4 + (3*z^3)/a^11 + (3*z^3)/a^9 - 
  (3*z^3)/a^7 - (3*z^3)/a^5 - (9*z^4)/a^8 - (8*z^4)/a^6 + z^4/a^4 - z^5/a^9 + 
  z^5/a^7 + (2*z^5)/a^5 + z^6/a^10 + (4*z^6)/a^8 + (3*z^6)/a^6 + z^7/a^9 + 
  z^7/a^7, -a^(-2) + a^6 + a^8 + 4*a^5*z + 4*a^7*z + z^2/a^2 - 11*a^6*z^2 - 
  10*a^8*z^2 + z^3/a - a*z^3 + a^3*z^3 - 11*a^5*z^3 - 14*a^7*z^3 + z^4 - 
  2*a^2*z^4 + 3*a^4*z^4 + 21*a^6*z^4 + 15*a^8*z^4 + a*z^5 - 3*a^3*z^5 + 
  12*a^5*z^5 + 16*a^7*z^5 + a^2*z^6 - 4*a^4*z^6 - 12*a^6*z^6 - 7*a^8*z^6 + 
  a^3*z^7 - 6*a^5*z^7 - 7*a^7*z^7 + a^4*z^8 + 2*a^6*z^8 + a^8*z^8 + a^5*z^9 + 
  a^7*z^9, 4*a^4 + 4*a^6 + a^8 - 2*a^5*z - a^7*z + a^9*z - a^11*z - a^13*z - 
  14*a^4*z^2 - 21*a^6*z^2 - 5*a^8*z^2 - a^12*z^2 + a^14*z^2 - 3*a^5*z^3 + 
  3*a^7*z^3 + 2*a^9*z^3 - 2*a^11*z^3 + 2*a^13*z^3 + 16*a^4*z^4 + 33*a^6*z^4 + 
  11*a^8*z^4 - 4*a^10*z^4 + 2*a^12*z^4 + 10*a^5*z^5 + 2*a^7*z^5 - 6*a^9*z^5 + 
  2*a^11*z^5 - 7*a^4*z^6 - 18*a^6*z^6 - 9*a^8*z^6 + 2*a^10*z^6 - 6*a^5*z^7 - 
  4*a^7*z^7 + 2*a^9*z^7 + a^4*z^8 + 3*a^6*z^8 + 2*a^8*z^8 + a^5*z^9 + 
  a^7*z^9, a^(-4) + a^2 - a^6 + 6*a*z + 6*a^3*z - (3*z^2)/a^4 + z^2/a^2 - 
  12*a^2*z^2 - 2*a^4*z^2 + 6*a^6*z^2 - (2*z^3)/a^3 + (4*z^3)/a - 15*a*z^3 - 
  18*a^3*z^3 + 3*a^5*z^3 + 6*z^4 + z^4/a^4 - (2*z^4)/a^2 + 18*a^2*z^4 + 
  4*a^4*z^4 - 5*a^6*z^4 + z^5/a^3 - (3*z^5)/a + 15*a*z^5 + 15*a^3*z^5 - 
  4*a^5*z^5 - 4*z^6 + z^6/a^2 - 10*a^2*z^6 - 4*a^4*z^6 + a^6*z^6 + z^7/a - 
  6*a*z^7 - 6*a^3*z^7 + a^5*z^7 + z^8 + 2*a^2*z^8 + a^4*z^8 + a*z^9 + 
  a^3*z^9, 2/a^4 + 2/a^2 + a^4 + (2*z)/a^3 - z/a - 3*a*z + z^2 - 
  (13*z^2)/a^4 - (16*z^2)/a^2 - 3*a^4*z^2 + a^6*z^2 - (7*z^3)/a^3 + 
  (7*z^3)/a + 8*a*z^3 - 4*a^3*z^3 + 2*a^5*z^3 + 4*z^4 + (16*z^4)/a^4 + 
  (29*z^4)/a^2 - 6*a^2*z^4 + 3*a^4*z^4 + (11*z^5)/a^3 - (2*z^5)/a - 
  10*a*z^5 + 3*a^3*z^5 - 7*z^6 - (7*z^6)/a^4 - (17*z^6)/a^2 + 3*a^2*z^6 - 
  (6*z^7)/a^3 - (3*z^7)/a + 3*a*z^7 + 2*z^8 + z^8/a^4 + (3*z^8)/a^2 + 
  z^9/a^3 + z^9/a, 3/a^6 + 5/a^4 + a^(-2) - z/a^11 - z/a^7 - (3*z)/a^5 - 
  (2*z)/a^3 - z/a - (2*z^2)/a^10 + z^2/a^8 - (9*z^2)/a^6 - (22*z^2)/a^4 - 
  (10*z^2)/a^2 + z^3/a^11 - z^3/a^9 + (3*z^3)/a^7 + (6*z^3)/a^5 + 
  (7*z^3)/a^3 + (6*z^3)/a + (2*z^4)/a^10 - (2*z^4)/a^8 + (10*z^4)/a^6 + 
  (32*z^4)/a^4 + (18*z^4)/a^2 + (2*z^5)/a^9 - (4*z^5)/a^7 - (3*z^5)/a^5 - 
  (2*z^5)/a^3 - (5*z^5)/a + (2*z^6)/a^8 - (7*z^6)/a^6 - (20*z^6)/a^4 - 
  (11*z^6)/a^2 + (2*z^7)/a^7 - (2*z^7)/a^5 - (3*z^7)/a^3 + z^7/a + 
  (2*z^8)/a^6 + (4*z^8)/a^4 + (2*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 -3*a^2 - 2*a^4 + a^6 + a^8 + 2*a^3*z + 3*a^5*z + a^11*z + 7*a^2*z^2 + 
  5*a^4*z^2 - 10*a^6*z^2 - 5*a^8*z^2 + a^10*z^2 - 2*a^12*z^2 - 10*a^5*z^3 - 
  2*a^7*z^3 + 4*a^9*z^3 - 4*a^11*z^3 - 5*a^2*z^4 - 3*a^4*z^4 + 18*a^6*z^4 + 
  12*a^8*z^4 - 3*a^10*z^4 + a^12*z^4 - 3*a^3*z^5 + 8*a^5*z^5 + 5*a^7*z^5 - 
  4*a^9*z^5 + 2*a^11*z^5 + a^2*z^6 - 2*a^4*z^6 - 12*a^6*z^6 - 7*a^8*z^6 + 
  2*a^10*z^6 + a^3*z^7 - 4*a^5*z^7 - 3*a^7*z^7 + 2*a^9*z^7 + a^4*z^8 + 
  3*a^6*z^8 + 2*a^8*z^8 + a^5*z^9 + a^7*z^9, 1 + a^4 + 2*a^6 + a^8 - 
  2*a^5*z - 5*a^7*z - 3*a^9*z - 2*z^2 - 2*a^2*z^2 - 4*a^4*z^2 - 10*a^6*z^2 - 
  3*a^8*z^2 + 3*a^10*z^2 - 3*a*z^3 + a^3*z^3 + 6*a^5*z^3 + 10*a^7*z^3 + 
  8*a^9*z^3 + z^4 - a^2*z^4 + 8*a^4*z^4 + 20*a^6*z^4 + 6*a^8*z^4 - 
  4*a^10*z^4 + 2*a*z^5 - 2*a^3*z^5 - 2*a^5*z^5 - 6*a^7*z^5 - 8*a^9*z^5 + 
  2*a^2*z^6 - 5*a^4*z^6 - 15*a^6*z^6 - 7*a^8*z^6 + a^10*z^6 + 2*a^3*z^7 - 
  a^5*z^7 - a^7*z^7 + 2*a^9*z^7 + 2*a^4*z^8 + 4*a^6*z^8 + 2*a^8*z^8 + 
  a^5*z^9 + a^7*z^9, 3 + 3*a^2 - a^6 - a^3*z + a^5*z + 2*a^7*z - 13*z^2 - 
  18*a^2*z^2 + 3*a^4*z^2 + 5*a^6*z^2 - 2*a^8*z^2 + a^10*z^2 - 6*a*z^3 + 
  5*a^3*z^3 + 2*a^5*z^3 - 7*a^7*z^3 + 2*a^9*z^3 + 16*z^4 + 30*a^2*z^4 + 
  a^4*z^4 - 10*a^6*z^4 + 3*a^8*z^4 + 11*a*z^5 - a^3*z^5 - 8*a^5*z^5 + 
  4*a^7*z^5 - 7*z^6 - 17*a^2*z^6 - 6*a^4*z^6 + 4*a^6*z^6 - 6*a*z^7 - 
  3*a^3*z^7 + 3*a^5*z^7 + z^8 + 3*a^2*z^8 + 2*a^4*z^8 + a*z^9 + a^3*z^9, 
 3 + 2/a^4 + 4/a^2 + z/a^7 - (2*z)/a^3 - (2*z)/a - a*z - 8*z^2 - 
  (2*z^2)/a^8 + z^2/a^6 - (8*z^2)/a^4 - (22*z^2)/a^2 + 3*a^2*z^2 - 
  (4*z^3)/a^7 + (4*z^3)/a^5 + (5*z^3)/a^3 + (4*z^3)/a + 7*a*z^3 + 10*z^4 + 
  z^4/a^8 - (3*z^4)/a^6 + (13*z^4)/a^4 + (31*z^4)/a^2 - 4*a^2*z^4 + 
  (2*z^5)/a^7 - (4*z^5)/a^5 - (2*z^5)/a - 8*a*z^5 - 8*z^6 + (2*z^6)/a^6 - 
  (7*z^6)/a^4 - (18*z^6)/a^2 + a^2*z^6 + (2*z^7)/a^5 - (2*z^7)/a^3 - 
  (2*z^7)/a + 2*a*z^7 + 2*z^8 + (2*z^8)/a^4 + (4*z^8)/a^2 + z^9/a^3 + z^9/a, 
 1 + a^(-6) + 2/a^4 + a^(-2) - (3*z)/a^7 - (6*z)/a^5 - (4*z)/a^3 - z/a - 
  2*z^2 - (8*z^2)/a^6 - (12*z^2)/a^4 - (4*z^2)/a^2 - 2*a^2*z^2 + 
  (7*z^3)/a^7 + (17*z^3)/a^5 + (17*z^3)/a^3 + (3*z^3)/a - 3*a*z^3 + a^3*z^3 - 
  3*z^4 + (15*z^4)/a^6 + (26*z^4)/a^4 + (5*z^4)/a^2 + 3*a^2*z^4 - 
  (5*z^5)/a^7 - (10*z^5)/a^5 - (16*z^5)/a^3 - (7*z^5)/a + 4*a*z^5 + 4*z^6 - 
  (10*z^6)/a^6 - (21*z^6)/a^4 - (7*z^6)/a^2 + z^7/a^7 - z^7/a^5 + 
  (2*z^7)/a^3 + (4*z^7)/a + (2*z^8)/a^6 + (5*z^8)/a^4 + (3*z^8)/a^2 + 
  z^9/a^5 + z^9/a^3, -1 - 2/a^2 + a^2 - a^6 + z/a + 5*a*z + 2*a^3*z - 
  2*a^5*z + 2*z^2 + (7*z^2)/a^2 - 12*a^2*z^2 + 5*a^6*z^2 - 2*a^8*z^2 + 
  z^3/a - 16*a*z^3 - 5*a^3*z^3 + 9*a^5*z^3 - 3*a^7*z^3 - z^4 - (5*z^4)/a^2 + 
  16*a^2*z^4 + 5*a^4*z^4 - 6*a^6*z^4 + a^8*z^4 - (3*z^5)/a + 11*a*z^5 + 
  5*a^3*z^5 - 7*a^5*z^5 + 2*a^7*z^5 - 2*z^6 + z^6/a^2 - 10*a^2*z^6 - 
  4*a^4*z^6 + 3*a^6*z^6 + z^7/a - 4*a*z^7 - 2*a^3*z^7 + 3*a^5*z^7 + z^8 + 
  3*a^2*z^8 + 2*a^4*z^8 + a*z^9 + a^3*z^9, -1 + 2/a^6 + 2/a^4 - 2/a^2 + 
  (2*z)/a^9 - (3*z)/a^5 - z/a^3 + z/a + a*z + 4*z^2 + (2*z^2)/a^8 - 
  (8*z^2)/a^6 - (12*z^2)/a^4 + (2*z^2)/a^2 - (3*z^3)/a^9 - z^3/a^7 + 
  (4*z^3)/a^5 + (5*z^3)/a^3 - 3*a*z^3 - 6*z^4 - (5*z^4)/a^8 + (8*z^4)/a^6 + 
  (23*z^4)/a^4 + (4*z^4)/a^2 + z^5/a^9 - (3*z^5)/a^7 - z^5/a^3 - (4*z^5)/a + 
  a*z^5 + 2*z^6 + (2*z^6)/a^8 - (5*z^6)/a^6 - (14*z^6)/a^4 - (5*z^6)/a^2 + 
  (2*z^7)/a^7 - z^7/a^5 - z^7/a^3 + (2*z^7)/a + (2*z^8)/a^6 + (4*z^8)/a^4 + 
  (2*z^8)/a^2 + z^9/a^5 + z^9/a^3, -1 + a^(-4) - a^2 - a^4 - a^6 - (2*z)/a + 
  a^3*z - a^5*z + 4*z^2 - (2*z^2)/a^4 + z^2/a^2 - a^2*z^2 + 2*a^4*z^2 + 
  4*a^6*z^2 - (2*z^3)/a^3 + (3*z^3)/a + a^3*z^3 + 6*a^5*z^3 - 3*z^4 + 
  z^4/a^4 - (3*z^4)/a^2 + 6*a^2*z^4 + a^4*z^4 - 4*a^6*z^4 + (2*z^5)/a^3 - 
  (3*z^5)/a - 2*a*z^5 - 4*a^3*z^5 - 7*a^5*z^5 + (3*z^6)/a^2 - 9*a^2*z^6 - 
  5*a^4*z^6 + a^6*z^6 + (3*z^7)/a + a*z^7 + 2*a^5*z^7 + 2*z^8 + 4*a^2*z^8 + 
  2*a^4*z^8 + a*z^9 + a^3*z^9, -a^2 + a^4 + a^6 - a^3*z - 4*a^5*z - 2*a^7*z + 
  2*a^9*z + a^11*z + 4*a^2*z^2 - a^4*z^2 - 9*a^6*z^2 - 3*a^8*z^2 - a^12*z^2 + 
  6*a^3*z^3 + 10*a^5*z^3 + 8*a^7*z^3 - 4*a^11*z^3 - 4*a^2*z^4 + 2*a^4*z^4 + 
  16*a^6*z^4 + 5*a^8*z^4 - 4*a^10*z^4 + a^12*z^4 - 7*a^3*z^5 - 9*a^5*z^5 - 
  9*a^7*z^5 - 4*a^9*z^5 + 3*a^11*z^5 + a^2*z^6 - 5*a^4*z^6 - 14*a^6*z^6 - 
  4*a^8*z^6 + 4*a^10*z^6 + 2*a^3*z^7 + a^5*z^7 + 3*a^7*z^7 + 4*a^9*z^7 + 
  2*a^4*z^8 + 5*a^6*z^8 + 3*a^8*z^8 + a^5*z^9 + a^7*z^9, 
 1 - 2/a^4 - 3/a^2 + a^2 - z/a^7 + z/a^5 + (3*z)/a^3 - 3*a*z - 2*a^3*z - 
  7*z^2 - z^2/a^6 + (7*z^2)/a^4 + (8*z^2)/a^2 - 7*a^2*z^2 + z^3/a^7 - 
  (2*z^3)/a^5 - (3*z^3)/a^3 + z^3/a + 8*a*z^3 + 7*a^3*z^3 + 16*z^4 + 
  (2*z^4)/a^6 - (7*z^4)/a^4 - (8*z^4)/a^2 + 15*a^2*z^4 + (3*z^5)/a^5 - 
  (3*z^5)/a^3 - (5*z^5)/a - 4*a*z^5 - 5*a^3*z^5 - 15*z^6 + (4*z^6)/a^4 - 
  z^6/a^2 - 10*a^2*z^6 + (3*z^7)/a^3 - 2*a*z^7 + a^3*z^7 + 4*z^8 + 
  (2*z^8)/a^2 + 2*a^2*z^8 + z^9/a + a*z^9, 1 - a^(-6) + 2/a^2 - a^2 - 
  (4*z)/a^5 - (4*z)/a^3 - 2*z^2 - (2*z^2)/a^8 + (5*z^2)/a^6 + (2*z^2)/a^4 - 
  (11*z^2)/a^2 + 4*a^2*z^2 - (3*z^3)/a^7 + (10*z^3)/a^5 + (8*z^3)/a^3 + 
  5*a*z^3 + 4*z^4 + z^4/a^8 - (6*z^4)/a^6 + (2*z^4)/a^4 + (17*z^4)/a^2 - 
  4*a^2*z^4 + (2*z^5)/a^7 - (7*z^5)/a^5 - (4*z^5)/a^3 - (2*z^5)/a - 7*a*z^5 - 
  6*z^6 + (3*z^6)/a^6 - (3*z^6)/a^4 - (13*z^6)/a^2 + a^2*z^6 + (3*z^7)/a^5 - 
  z^7/a + 2*a*z^7 + 2*z^8 + (2*z^8)/a^4 + (4*z^8)/a^2 + z^9/a^3 + z^9/a, 
 5 + 2/a^2 + 2*a^2 + z/a^5 - (3*z)/a - 3*a*z + a^5*z - 22*z^2 + (3*z^2)/a^4 - 
  (8*z^2)/a^2 - 8*a^2*z^2 + 3*a^4*z^2 - (3*z^3)/a^5 + (2*z^3)/a^3 + 
  (6*z^3)/a + 6*a*z^3 + 2*a^3*z^3 - 3*a^5*z^3 + 34*z^4 - (6*z^4)/a^4 + 
  (11*z^4)/a^2 + 11*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - (5*z^5)/a^3 - 5*a^3*z^5 + 
  a^5*z^5 - 18*z^6 + (2*z^6)/a^4 - (7*z^6)/a^2 - 7*a^2*z^6 + 2*a^4*z^6 + 
  (2*z^7)/a^3 - (2*z^7)/a - 2*a*z^7 + 2*a^3*z^7 + 4*z^8 + (2*z^8)/a^2 + 
  2*a^2*z^8 + z^9/a + a*z^9, -a^(-2) + a^2 + a^4 - (2*z)/a - 4*a*z - 
  4*a^3*z - 2*a^5*z + z^2 + (4*z^2)/a^2 - 8*a^2*z^2 - 3*a^4*z^2 + a^6*z^2 - 
  a^8*z^2 + (6*z^3)/a + 11*a*z^3 + 14*a^3*z^3 + 5*a^5*z^3 - 4*a^7*z^3 + z^4 - 
  (4*z^4)/a^2 + 17*a^2*z^4 + 6*a^4*z^4 - 5*a^6*z^4 + a^8*z^4 - (7*z^5)/a - 
  10*a*z^5 - 12*a^3*z^5 - 6*a^5*z^5 + 3*a^7*z^5 - 5*z^6 + z^6/a^2 - 
  15*a^2*z^6 - 5*a^4*z^6 + 4*a^6*z^6 + (2*z^7)/a + a*z^7 + 3*a^3*z^7 + 
  4*a^5*z^7 + 2*z^8 + 5*a^2*z^8 + 3*a^4*z^8 + a*z^9 + a^3*z^9, 
 3 + a^(-2) + a^2 - (2*z)/a^3 - (4*z)/a - 2*a*z + a^3*z + a^5*z - 13*z^2 - 
  (9*z^2)/a^2 + 3*a^4*z^2 - a^6*z^2 + (7*z^3)/a^3 + (13*z^3)/a + 11*a*z^3 - 
  4*a^5*z^3 + a^7*z^3 + 23*z^4 + (16*z^4)/a^2 - 4*a^2*z^4 - 8*a^4*z^4 + 
  3*a^6*z^4 - (5*z^5)/a^3 - (8*z^5)/a - 15*a*z^5 - 7*a^3*z^5 + 5*a^5*z^5 - 
  19*z^6 - (10*z^6)/a^2 - 3*a^2*z^6 + 6*a^4*z^6 + z^7/a^3 - z^7/a + 3*a*z^7 + 
  5*a^3*z^7 + 5*z^8 + (2*z^8)/a^2 + 3*a^2*z^8 + z^9/a + a*z^9, 
 2 + a^2 + a^6 + a^8 - a*z - a^3*z + 3*a^5*z + 2*a^7*z - a^9*z - 3*z^2 - 
  2*a^2*z^2 - 9*a^6*z^2 - 5*a^8*z^2 + 3*a^10*z^2 - a*z^3 + 2*a^3*z^3 - 
  8*a^5*z^3 - 4*a^7*z^3 + 7*a^9*z^3 + z^4 + 3*a^4*z^4 + 17*a^6*z^4 + 
  9*a^8*z^4 - 4*a^10*z^4 + a*z^5 - a^3*z^5 + 9*a^5*z^5 + 3*a^7*z^5 - 
  8*a^9*z^5 + a^2*z^6 - 2*a^4*z^6 - 12*a^6*z^6 - 8*a^8*z^6 + a^10*z^6 + 
  a^3*z^7 - 4*a^5*z^7 - 3*a^7*z^7 + 2*a^9*z^7 + a^4*z^8 + 3*a^6*z^8 + 
  2*a^8*z^8 + a^5*z^9 + a^7*z^9, -a^2 + 2*a^4 + 3*a^6 + a^8 - 2*a^5*z - 
  a^7*z + 3*a^9*z + 2*a^11*z + 4*a^2*z^2 - 3*a^4*z^2 - 14*a^6*z^2 - 
  5*a^8*z^2 - 2*a^12*z^2 + 5*a^3*z^3 + 3*a^5*z^3 + 2*a^7*z^3 - 4*a^11*z^3 - 
  4*a^2*z^4 + 4*a^4*z^4 + 20*a^6*z^4 + 9*a^8*z^4 - 2*a^10*z^4 + a^12*z^4 - 
  7*a^3*z^5 - 3*a^5*z^5 - 2*a^9*z^5 + 2*a^11*z^5 + a^2*z^6 - 6*a^4*z^6 - 
  14*a^6*z^6 - 5*a^8*z^6 + 2*a^10*z^6 + 2*a^3*z^7 - a^5*z^7 - a^7*z^7 + 
  2*a^9*z^7 + 2*a^4*z^8 + 4*a^6*z^8 + 2*a^8*z^8 + a^5*z^9 + a^7*z^9, 
 -1 + 2/a^4 + 2/a^2 - 2*a^2 - z/a^5 + z/a^3 + z/a - a*z + 6*z^2 + 
  (4*z^2)/a^6 - (6*z^2)/a^4 - (12*z^2)/a^2 + 6*a^2*z^2 - 2*a^4*z^2 + 
  (6*z^3)/a^5 - (4*z^3)/a^3 + 7*a*z^3 - 3*a^3*z^3 - z^4 - (4*z^4)/a^6 + 
  (6*z^4)/a^4 + (16*z^4)/a^2 - 6*a^2*z^4 + a^4*z^4 - (7*z^5)/a^5 - z^5/a - 
  6*a*z^5 + 2*a^3*z^5 - 2*z^6 + z^6/a^6 - (6*z^6)/a^4 - (12*z^6)/a^2 + 
  3*a^2*z^6 + (2*z^7)/a^5 - z^7/a^3 + 3*a*z^7 + 2*z^8 + (2*z^8)/a^4 + 
  (4*z^8)/a^2 + z^9/a^3 + z^9/a, 2/a^6 + 3/a^4 + (2*z)/a^9 + z/a^7 - 
  (2*z)/a^5 - (2*z)/a^3 - z/a + 3*z^2 + (3*z^2)/a^8 - (6*z^2)/a^6 - 
  (13*z^2)/a^4 - z^2/a^2 - (3*z^3)/a^9 - (2*z^3)/a^7 + (3*z^3)/a^5 + 
  (9*z^3)/a^3 + (5*z^3)/a - 2*a*z^3 - 7*z^4 - (5*z^4)/a^8 + (5*z^4)/a^6 + 
  (20*z^4)/a^4 + (3*z^4)/a^2 + z^5/a^9 - (2*z^5)/a^7 - (2*z^5)/a^5 - 
  (9*z^5)/a^3 - (9*z^5)/a + a*z^5 + 3*z^6 + (2*z^6)/a^8 - (3*z^6)/a^6 - 
  (13*z^6)/a^4 - (5*z^6)/a^2 + (2*z^7)/a^7 + z^7/a^5 + (3*z^7)/a^3 + 
  (4*z^7)/a + (2*z^8)/a^6 + (5*z^8)/a^4 + (3*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 1 - a^2 - a^4 + a^6 + a^8 + 2*a^3*z + 4*a^5*z - 2*a^9*z - 2*z^2 + 
  2*a^2*z^2 + 5*a^4*z^2 - 5*a^6*z^2 - 2*a^8*z^2 + 4*a^10*z^2 - 2*a*z^3 - 
  7*a^5*z^3 - 2*a^7*z^3 + 7*a^9*z^3 + z^4 - 3*a^2*z^4 - 5*a^4*z^4 + 
  6*a^6*z^4 + 3*a^8*z^4 - 4*a^10*z^4 + 2*a*z^5 - 2*a^3*z^5 + a^5*z^5 - 
  2*a^7*z^5 - 7*a^9*z^5 + 3*a^2*z^6 + a^4*z^6 - 8*a^6*z^6 - 5*a^8*z^6 + 
  a^10*z^6 + 3*a^3*z^7 + a^5*z^7 + 2*a^9*z^7 + 2*a^4*z^8 + 4*a^6*z^8 + 
  2*a^8*z^8 + a^5*z^9 + a^7*z^9, -2*a^2 + 2*a^6 + a^8 + a^3*z - 2*a^7*z + 
  a^11*z + 5*a^2*z^2 + 4*a^4*z^2 - 4*a^6*z^2 + a^8*z^2 + 3*a^10*z^2 - 
  a^12*z^2 + 4*a^3*z^3 + 2*a^5*z^3 + 3*a^7*z^3 + 2*a^9*z^3 - 3*a^11*z^3 - 
  4*a^2*z^4 - 3*a^4*z^4 + 3*a^6*z^4 - 5*a^8*z^4 - 6*a^10*z^4 + a^12*z^4 - 
  6*a^3*z^5 - 7*a^5*z^5 - 9*a^7*z^5 - 5*a^9*z^5 + 3*a^11*z^5 + a^2*z^6 - 
  3*a^4*z^6 - 8*a^6*z^6 + a^8*z^6 + 5*a^10*z^6 + 2*a^3*z^7 + 2*a^5*z^7 + 
  5*a^7*z^7 + 5*a^9*z^7 + 2*a^4*z^8 + 5*a^6*z^8 + 3*a^8*z^8 + a^5*z^9 + 
  a^7*z^9, 1 + 2/a^4 + 3/a^2 - a^2 - (2*z)/a^5 - (2*z)/a^3 - z/a - a*z + 
  z^2 + (4*z^2)/a^6 - (4*z^2)/a^4 - (12*z^2)/a^2 + 4*a^2*z^2 - a^4*z^2 + 
  (7*z^3)/a^5 + (4*z^3)/a^3 + (5*z^3)/a + 5*a*z^3 - 3*a^3*z^3 - 2*z^4 - 
  (4*z^4)/a^6 + (4*z^4)/a^4 + (14*z^4)/a^2 - 7*a^2*z^4 + a^4*z^4 - 
  (7*z^5)/a^5 - (6*z^5)/a^3 - (9*z^5)/a - 7*a*z^5 + 3*a^3*z^5 - z^6 + 
  z^6/a^6 - (5*z^6)/a^4 - (12*z^6)/a^2 + 5*a^2*z^6 + (2*z^7)/a^5 + z^7/a^3 + 
  (4*z^7)/a + 5*a*z^7 + 3*z^8 + (2*z^8)/a^4 + (5*z^8)/a^2 + z^9/a^3 + z^9/a, 
 -a^2 + a^4 + a^6 - a*z - 2*a^3*z - 2*a^5*z + a^9*z + 4*z^2 + 4*a^2*z^2 - 
  4*a^4*z^2 - a^6*z^2 + 3*a^8*z^2 - (2*z^3)/a + 5*a*z^3 + 11*a^3*z^3 + 
  7*a^5*z^3 + a^7*z^3 - 2*a^9*z^3 - 7*z^4 - 3*a^2*z^4 + 7*a^4*z^4 - 
  3*a^6*z^4 - 6*a^8*z^4 + z^5/a - 8*a*z^5 - 14*a^3*z^5 - 12*a^5*z^5 - 
  6*a^7*z^5 + a^9*z^5 + 3*z^6 - 2*a^2*z^6 - 9*a^4*z^6 - a^6*z^6 + 3*a^8*z^6 + 
  4*a*z^7 + 6*a^3*z^7 + 6*a^5*z^7 + 4*a^7*z^7 + 3*a^2*z^8 + 6*a^4*z^8 + 
  3*a^6*z^8 + a^3*z^9 + a^5*z^9, -1 + a^(-6) - 3/a^2 - (4*z)/a^7 - 
  (6*z)/a^5 - (2*z)/a^3 + z/a + a*z + 4*z^2 - (5*z^2)/a^6 + (10*z^2)/a^2 - 
  a^2*z^2 + (8*z^3)/a^7 + (18*z^3)/a^5 + (13*z^3)/a^3 - (2*z^3)/a - 4*a*z^3 + 
  a^3*z^3 - 8*z^4 + (12*z^4)/a^6 + (11*z^4)/a^4 - (12*z^4)/a^2 + 3*a^2*z^4 - 
  (5*z^5)/a^7 - (12*z^5)/a^5 - (18*z^5)/a^3 - (6*z^5)/a + 5*a*z^5 + 6*z^6 - 
  (9*z^6)/a^6 - (16*z^6)/a^4 - z^6/a^2 + z^7/a^7 + (4*z^7)/a^3 + (5*z^7)/a + 
  (2*z^8)/a^6 + (5*z^8)/a^4 + (3*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 -2 - 2/a^2 - a^2 - a^4 - a^6 + 2*a*z - 2*a^5*z + 6*z^2 + (5*z^2)/a^2 + 
  4*a^4*z^2 + 4*a^6*z^2 - a^8*z^2 + (4*z^3)/a + 2*a*z^3 + 7*a^3*z^3 + 
  6*a^5*z^3 - 3*a^7*z^3 - 4*z^4 - (4*z^4)/a^2 + 3*a^2*z^4 - 5*a^4*z^4 - 
  7*a^6*z^4 + a^8*z^4 - (6*z^5)/a - 8*a*z^5 - 12*a^3*z^5 - 7*a^5*z^5 + 
  3*a^7*z^5 - 3*z^6 + z^6/a^2 - 9*a^2*z^6 + 5*a^6*z^6 + (2*z^7)/a + 2*a*z^7 + 
  5*a^3*z^7 + 5*a^5*z^7 + 2*z^8 + 5*a^2*z^8 + 3*a^4*z^8 + a*z^9 + a^3*z^9, 
 -2*a^2 - a^4 - a^3*z - 5*a^5*z - 6*a^7*z - 2*a^9*z - z^2 + 5*a^2*z^2 + 
  9*a^4*z^2 + 2*a^6*z^2 + a^8*z^2 + 2*a^10*z^2 - 3*a*z^3 + 4*a^3*z^3 + 
  16*a^5*z^3 + 18*a^7*z^3 + 9*a^9*z^3 + z^4 - 7*a^2*z^4 - 11*a^4*z^4 + 
  2*a^6*z^4 + 2*a^8*z^4 - 3*a^10*z^4 + 3*a*z^5 - 6*a^3*z^5 - 19*a^5*z^5 - 
  20*a^7*z^5 - 10*a^9*z^5 + 5*a^2*z^6 + 2*a^4*z^6 - 11*a^6*z^6 - 7*a^8*z^6 + 
  a^10*z^6 + 5*a^3*z^7 + 7*a^5*z^7 + 5*a^7*z^7 + 3*a^9*z^7 + 3*a^4*z^8 + 
  6*a^6*z^8 + 3*a^8*z^8 + a^5*z^9 + a^7*z^9, 2 - a^(-4) - a^(-2) + a^2 + 
  (2*z)/a^5 + (2*z)/a^3 - (2*z)/a - 4*a*z - 2*a^3*z - 10*z^2 + (3*z^2)/a^4 - 
  (2*z^2)/a^2 - 3*a^2*z^2 + 2*a^4*z^2 - (3*z^3)/a^5 - (3*z^3)/a^3 + 
  (6*z^3)/a + 15*a*z^3 + 7*a^3*z^3 - 2*a^5*z^3 + 20*z^4 - (5*z^4)/a^4 + 
  (3*z^4)/a^2 + 5*a^2*z^4 - 7*a^4*z^4 + z^5/a^5 - (2*z^5)/a^3 - (4*z^5)/a - 
  12*a*z^5 - 10*a^3*z^5 + a^5*z^5 - 14*z^6 + (2*z^6)/a^4 - (3*z^6)/a^2 - 
  6*a^2*z^6 + 3*a^4*z^6 + (2*z^7)/a^3 + z^7/a + 3*a*z^7 + 4*a^3*z^7 + 5*z^8 + 
  (2*z^8)/a^2 + 3*a^2*z^8 + z^9/a + a*z^9, -1 - a^(-2) - a^2 + z/a^3 + z/a - 
  a*z - 2*a^3*z - a^5*z + 7*z^2 - z^2/a^4 + (4*z^2)/a^2 + 2*a^6*z^2 - 
  (3*z^3)/a^3 + 7*a*z^3 + 13*a^3*z^3 + 9*a^5*z^3 - 11*z^4 + z^4/a^4 - 
  (6*z^4)/a^2 + 2*a^2*z^4 + 3*a^4*z^4 - 3*a^6*z^4 + (3*z^5)/a^3 - (4*z^5)/a - 
  15*a*z^5 - 18*a^3*z^5 - 10*a^5*z^5 + 3*z^6 + (5*z^6)/a^2 - 10*a^2*z^6 - 
  7*a^4*z^6 + a^6*z^6 + (5*z^7)/a + 7*a*z^7 + 5*a^3*z^7 + 3*a^5*z^7 + 3*z^8 + 
  6*a^2*z^8 + 3*a^4*z^8 + a*z^9 + a^3*z^9, 1 - (2*z)/a^3 - (6*z)/a - 6*a*z - 
  2*a^3*z - 6*z^2 + (3*z^2)/a^4 + 3*a^4*z^2 - (2*z^3)/a^5 + (6*z^3)/a^3 + 
  (18*z^3)/a + 18*a*z^3 + 6*a^3*z^3 - 2*a^5*z^3 + 16*z^4 - (7*z^4)/a^4 + 
  z^4/a^2 + a^2*z^4 - 7*a^4*z^4 + z^5/a^5 - (9*z^5)/a^3 - (16*z^5)/a - 
  16*a*z^5 - 9*a^3*z^5 + a^5*z^5 - 14*z^6 + (3*z^6)/a^4 - (4*z^6)/a^2 - 
  4*a^2*z^6 + 3*a^4*z^6 + (4*z^7)/a^3 + (5*z^7)/a + 5*a*z^7 + 4*a^3*z^7 + 
  6*z^8 + (3*z^8)/a^2 + 3*a^2*z^8 + z^9/a + a*z^9, 
 2 + a^(-6) + a^(-4) + a^2 - (3*z)/a^7 - (4*z)/a^5 - z/a^3 - a*z - a^3*z - 
  3*z^2 - (6*z^2)/a^6 - (8*z^2)/a^4 - (3*z^2)/a^2 - 2*a^2*z^2 + (7*z^3)/a^7 + 
  (12*z^3)/a^5 + (5*z^3)/a^3 - z^3/a + a^3*z^3 + (14*z^4)/a^6 + 
  (20*z^4)/a^4 + (4*z^4)/a^2 + 2*a^2*z^4 - (5*z^5)/a^7 - (6*z^5)/a^5 - 
  (5*z^5)/a^3 - (2*z^5)/a + 2*a*z^5 + 2*z^6 - (10*z^6)/a^6 - (17*z^6)/a^4 - 
  (5*z^6)/a^2 + z^7/a^7 - (2*z^7)/a^5 - z^7/a^3 + (2*z^7)/a + (2*z^8)/a^6 + 
  (4*z^8)/a^4 + (2*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 1 - a^(-6) - a^(-4) + a^2 + a^4 - (2*z)/a^5 - z/a^3 + z/a + a*z + a^3*z - 
  3*z^2 + (4*z^2)/a^6 + (3*z^2)/a^4 - (3*z^2)/a^2 - 3*a^2*z^2 - 2*a^4*z^2 + 
  (6*z^3)/a^5 + (5*z^3)/a^3 - 2*a*z^3 - 3*a^3*z^3 + 5*z^4 - (4*z^4)/a^6 + 
  (10*z^4)/a^2 + a^4*z^4 - (7*z^5)/a^5 - (6*z^5)/a^3 - z^5/a + 2*a^3*z^5 - 
  3*z^6 + z^6/a^6 - (5*z^6)/a^4 - (11*z^6)/a^2 + 2*a^2*z^6 + (2*z^7)/a^5 + 
  2*a*z^7 + 2*z^8 + (2*z^8)/a^4 + (4*z^8)/a^2 + z^9/a^3 + z^9/a, 
 1 + a^2 + 2*a^4 + a^6 + a*z + a^3*z - 3*a^5*z - 4*a^7*z - a^9*z - 2*z^2 - 
  3*a^2*z^2 - 6*a^4*z^2 - 8*a^6*z^2 - 2*a^8*z^2 + a^10*z^2 - 3*a*z^3 - 
  2*a^3*z^3 + 8*a^5*z^3 + 16*a^7*z^3 + 9*a^9*z^3 + z^4 + 6*a^4*z^4 + 
  18*a^6*z^4 + 8*a^8*z^4 - 3*a^10*z^4 + 2*a*z^5 - 6*a^5*z^5 - 15*a^7*z^5 - 
  11*a^9*z^5 + 2*a^2*z^6 - 3*a^4*z^6 - 16*a^6*z^6 - 10*a^8*z^6 + a^10*z^6 + 
  2*a^3*z^7 + a^5*z^7 + 2*a^7*z^7 + 3*a^9*z^7 + 2*a^4*z^8 + 5*a^6*z^8 + 
  3*a^8*z^8 + a^5*z^9 + a^7*z^9, 1 - a^(-4) - a^(-2) - a^2 - a^4 + 
  (2*z)/a^5 + (2*z)/a^3 - z/a - a*z + 2*a^3*z + 2*a^5*z - 6*z^2 + 
  (3*z^2)/a^4 + 3*a^4*z^2 - (3*z^3)/a^5 - (3*z^3)/a^3 + z^3/a + a*z^3 - 
  3*a^3*z^3 - 3*a^5*z^3 + 14*z^4 - (5*z^4)/a^4 + (2*z^4)/a^2 + 2*a^2*z^4 - 
  5*a^4*z^4 + z^5/a^5 - (2*z^5)/a^3 - 2*a^3*z^5 + a^5*z^5 - 10*z^6 + 
  (2*z^6)/a^4 - (3*z^6)/a^2 - 3*a^2*z^6 + 2*a^4*z^6 + (2*z^7)/a^3 + 
  2*a^3*z^7 + 4*z^8 + (2*z^8)/a^2 + 2*a^2*z^8 + z^9/a + a*z^9, 
 1 - a^2 - 2*a^4 - a^6 - a^7*z - a^9*z - 2*z^2 + 2*a^2*z^2 + 8*a^4*z^2 + 
  2*a^6*z^2 + 2*a^10*z^2 - 2*a*z^3 + a^3*z^3 + 3*a^5*z^3 + 8*a^7*z^3 + 
  8*a^9*z^3 + z^4 - 3*a^2*z^4 - 8*a^4*z^4 + 3*a^6*z^4 + 4*a^8*z^4 - 
  3*a^10*z^4 + 2*a*z^5 - 2*a^3*z^5 - 7*a^5*z^5 - 13*a^7*z^5 - 10*a^9*z^5 + 
  3*a^2*z^6 + 2*a^4*z^6 - 10*a^6*z^6 - 8*a^8*z^6 + a^10*z^6 + 3*a^3*z^7 + 
  3*a^5*z^7 + 3*a^7*z^7 + 3*a^9*z^7 + 2*a^4*z^8 + 5*a^6*z^8 + 3*a^8*z^8 + 
  a^5*z^9 + a^7*z^9, -2*a^2 - a^4 - a^5*z + 2*a^9*z + a^11*z + 5*a^2*z^2 + 
  5*a^4*z^2 - a^6*z^2 + a^8*z^2 + a^10*z^2 - a^12*z^2 + 4*a^3*z^3 + 
  5*a^5*z^3 + 4*a^7*z^3 - a^9*z^3 - 4*a^11*z^3 - 4*a^2*z^4 - 4*a^4*z^4 + 
  5*a^6*z^4 - 4*a^10*z^4 + a^12*z^4 - 6*a^3*z^5 - 9*a^5*z^5 - 9*a^7*z^5 - 
  3*a^9*z^5 + 3*a^11*z^5 + a^2*z^6 - 3*a^4*z^6 - 10*a^6*z^6 - 2*a^8*z^6 + 
  4*a^10*z^6 + 2*a^3*z^7 + 2*a^5*z^7 + 4*a^7*z^7 + 4*a^9*z^7 + 2*a^4*z^8 + 
  5*a^6*z^8 + 3*a^8*z^8 + a^5*z^9 + a^7*z^9, -1 + a^(-6) - 3/a^2 + z/a^9 + 
  (2*z)/a^3 + (2*z)/a + a*z + 4*z^2 + (3*z^2)/a^8 + z^2/a^6 + z^2/a^4 + 
  (7*z^2)/a^2 - (2*z^3)/a^9 + (2*z^3)/a^7 + (6*z^3)/a^5 + (3*z^3)/a^3 - 
  z^3/a - 2*a*z^3 - 6*z^4 - (6*z^4)/a^8 - (5*z^4)/a^6 - (2*z^4)/a^4 - 
  (9*z^4)/a^2 + z^5/a^9 - (6*z^5)/a^7 - (13*z^5)/a^5 - (12*z^5)/a^3 - 
  (5*z^5)/a + a*z^5 + 3*z^6 + (3*z^6)/a^8 - (5*z^6)/a^4 + z^6/a^2 + 
  (4*z^7)/a^7 + (7*z^7)/a^5 + (7*z^7)/a^3 + (4*z^7)/a + (3*z^8)/a^6 + 
  (6*z^8)/a^4 + (3*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 -1 - a^(-2) - 2*a^2 - 2*a^4 - a^6 - z/a - 2*a*z - 2*a^3*z + a^7*z + 7*z^2 + 
  (3*z^2)/a^2 + 9*a^2*z^2 + 10*a^4*z^2 + 4*a^6*z^2 - a^8*z^2 + (7*z^3)/a + 
  13*a*z^3 + 10*a^3*z^3 + a^5*z^3 - 3*a^7*z^3 - 4*z^4 - (3*z^4)/a^2 - 
  8*a^2*z^4 - 14*a^4*z^4 - 6*a^6*z^4 + a^8*z^4 - (9*z^5)/a - 20*a*z^5 - 
  18*a^3*z^5 - 4*a^5*z^5 + 3*a^7*z^5 - 5*z^6 + z^6/a^2 - 7*a^2*z^6 + 
  4*a^4*z^6 + 5*a^6*z^6 + (3*z^7)/a + 6*a*z^7 + 8*a^3*z^7 + 5*a^5*z^7 + 
  3*z^8 + 6*a^2*z^8 + 3*a^4*z^8 + a*z^9 + a^3*z^9, 
 -2 - a^(-4) - 3/a^2 - a^2 + z/a^5 + z/a^3 - z/a - a*z + 9*z^2 + 
  (4*z^2)/a^4 + (9*z^2)/a^2 + 6*a^2*z^2 + 2*a^4*z^2 - (2*z^3)/a^5 + 
  (10*z^3)/a + 14*a*z^3 + 5*a^3*z^3 - a^5*z^3 - 8*z^4 - (6*z^4)/a^4 - 
  (11*z^4)/a^2 - 10*a^2*z^4 - 7*a^4*z^4 + z^5/a^5 - (5*z^5)/a^3 - 
  (18*z^5)/a - 24*a*z^5 - 11*a^3*z^5 + a^5*z^5 - 5*z^6 + (3*z^6)/a^4 + 
  (2*z^6)/a^2 + 4*a^4*z^6 + (4*z^7)/a^3 + (9*z^7)/a + 11*a*z^7 + 6*a^3*z^7 + 
  7*z^8 + (3*z^8)/a^2 + 4*a^2*z^8 + z^9/a + a*z^9, 
 -1 - a^(-4) - 2/a^2 - 2*a^2 - a^4 + z/a^5 - (3*z)/a - 3*a*z + a^5*z + 
  8*z^2 + (3*z^2)/a^4 + (7*z^2)/a^2 + 7*a^2*z^2 + 3*a^4*z^2 - (2*z^3)/a^5 + 
  z^3/a^3 + (12*z^3)/a + 12*a*z^3 + a^3*z^3 - 2*a^5*z^3 - 4*z^4 - 
  (6*z^4)/a^4 - (8*z^4)/a^2 - 8*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - (6*z^5)/a^3 - 
  (16*z^5)/a - 16*a*z^5 - 6*a^3*z^5 + a^5*z^5 - 6*z^6 + (3*z^6)/a^4 + 
  3*a^4*z^6 + (4*z^7)/a^3 + (7*z^7)/a + 7*a*z^7 + 4*a^3*z^7 + 6*z^8 + 
  (3*z^8)/a^2 + 3*a^2*z^8 + z^9/a + a*z^9, -2 - a^(-2) - 3*a^2 - a^4 - 
  (2*z)/a - 4*a*z - 2*a^3*z + 9*z^2 + (3*z^2)/a^2 + 13*a^2*z^2 + 10*a^4*z^2 + 
  3*a^6*z^2 + (8*z^3)/a + 20*a*z^3 + 15*a^3*z^3 - 3*a^7*z^3 - 6*z^4 - 
  (3*z^4)/a^2 - 12*a^2*z^4 - 18*a^4*z^4 - 8*a^6*z^4 + a^8*z^4 - (9*z^5)/a - 
  26*a*z^5 - 27*a^3*z^5 - 6*a^5*z^5 + 4*a^7*z^5 - 4*z^6 + z^6/a^2 - 
  7*a^2*z^6 + 5*a^4*z^6 + 7*a^6*z^6 + (3*z^7)/a + 8*a*z^7 + 12*a^3*z^7 + 
  7*a^5*z^7 + 3*z^8 + 7*a^2*z^8 + 4*a^4*z^8 + a*z^9 + a^3*z^9, 
 -3 - 2/a^2 - 2*a^2 - z/a^3 - (5*z)/a - 5*a*z - a^3*z + 18*z^2 + 
  (3*z^2)/a^4 + (12*z^2)/a^2 + 12*a^2*z^2 + 3*a^4*z^2 - z^3/a^5 + 
  (5*z^3)/a^3 + (21*z^3)/a + 21*a*z^3 + 5*a^3*z^3 - a^5*z^3 - 20*z^4 - 
  (7*z^4)/a^4 - (17*z^4)/a^2 - 17*a^2*z^4 - 7*a^4*z^4 + z^5/a^5 - 
  (10*z^5)/a^3 - (31*z^5)/a - 31*a*z^5 - 10*a^3*z^5 + a^5*z^5 - 2*z^6 + 
  (4*z^6)/a^4 + (3*z^6)/a^2 + 3*a^2*z^6 + 4*a^4*z^6 + (6*z^7)/a^3 + 
  (14*z^7)/a + 14*a*z^7 + 6*a^3*z^7 + 8*z^8 + (4*z^8)/a^2 + 4*a^2*z^8 + 
  z^9/a + a*z^9, 3/a^8 + 8/a^6 + 6/a^4 + (2*z)/a^11 - (2*z)/a^9 - 
  (10*z)/a^7 - (6*z)/a^5 + z^2/a^14 - (2*z^2)/a^12 + (2*z^2)/a^10 - 
  (7*z^2)/a^8 - (29*z^2)/a^6 - (17*z^2)/a^4 + (2*z^3)/a^13 - (7*z^3)/a^11 + 
  (9*z^3)/a^9 + (23*z^3)/a^7 + (5*z^3)/a^5 + (3*z^4)/a^12 - (9*z^4)/a^10 + 
  (13*z^4)/a^8 + (42*z^4)/a^6 + (17*z^4)/a^4 + (4*z^5)/a^11 - (13*z^5)/a^9 - 
  (12*z^5)/a^7 + (5*z^5)/a^5 + (4*z^6)/a^10 - (12*z^6)/a^8 - (23*z^6)/a^6 - 
  (7*z^6)/a^4 + (4*z^7)/a^9 - z^7/a^7 - (5*z^7)/a^5 + (3*z^8)/a^8 + 
  (4*z^8)/a^6 + z^8/a^4 + z^9/a^7 + z^9/a^5, 5/a^6 + 9/a^4 + 3/a^2 - z/a^11 + 
  (2*z)/a^9 - z/a^7 - (9*z)/a^5 - (8*z)/a^3 - (3*z)/a - z^2/a^10 + z^2/a^8 - 
  (15*z^2)/a^6 - (26*z^2)/a^4 - (9*z^2)/a^2 + z^3/a^11 - (3*z^3)/a^9 + 
  (2*z^3)/a^7 + (19*z^3)/a^5 + (20*z^3)/a^3 + (7*z^3)/a + (2*z^4)/a^10 - 
  (3*z^4)/a^8 + (15*z^4)/a^6 + (35*z^4)/a^4 + (15*z^4)/a^2 + (3*z^5)/a^9 - 
  (5*z^5)/a^7 - (14*z^5)/a^5 - (11*z^5)/a^3 - (5*z^5)/a + (3*z^6)/a^8 - 
  (10*z^6)/a^6 - (23*z^6)/a^4 - (10*z^6)/a^2 + (3*z^7)/a^7 + z^7/a^5 - 
  z^7/a^3 + z^7/a + (3*z^8)/a^6 + (5*z^8)/a^4 + (2*z^8)/a^2 + z^9/a^5 + 
  z^9/a^3, 9 + 4/a^2 + 4*a^2 + z/a^5 - (3*z)/a^3 - (9*z)/a - 7*a*z + 
  2*a^5*z - 27*z^2 + z^2/a^4 - (13*z^2)/a^2 - 11*a^2*z^2 + 2*a^4*z^2 - 
  (3*z^3)/a^5 + (8*z^3)/a^3 + (21*z^3)/a + 12*a*z^3 - a^3*z^3 - 3*a^5*z^3 + 
  37*z^4 - (5*z^4)/a^4 + (18*z^4)/a^2 + 9*a^2*z^4 - 5*a^4*z^4 + z^5/a^5 - 
  (9*z^5)/a^3 - (11*z^5)/a - 5*a*z^5 - 3*a^3*z^5 + a^5*z^5 - 20*z^6 + 
  (2*z^6)/a^4 - (11*z^6)/a^2 - 5*a^2*z^6 + 2*a^4*z^6 + (3*z^7)/a^3 + z^7/a + 
  2*a^3*z^7 + 5*z^8 + (3*z^8)/a^2 + 2*a^2*z^8 + z^9/a + a*z^9, 
 -a^6 + 5*a^8 + 7*a^10 + 2*a^12 - 9*a^9*z - 10*a^11*z + a^15*z + 4*a^6*z^2 - 
  13*a^8*z^2 - 20*a^10*z^2 - 2*a^12*z^2 - a^16*z^2 + 3*a^7*z^3 + 22*a^9*z^3 + 
  24*a^11*z^3 + a^13*z^3 - 4*a^15*z^3 - 4*a^6*z^4 + 15*a^8*z^4 + 
  26*a^10*z^4 + 2*a^12*z^4 - 4*a^14*z^4 + a^16*z^4 - 6*a^7*z^5 - 18*a^9*z^5 - 
  19*a^11*z^5 - 4*a^13*z^5 + 3*a^15*z^5 + a^6*z^6 - 11*a^8*z^6 - 
  19*a^10*z^6 - 3*a^12*z^6 + 4*a^14*z^6 + 2*a^7*z^7 + 3*a^9*z^7 + 
  5*a^11*z^7 + 4*a^13*z^7 + 3*a^8*z^8 + 6*a^10*z^8 + 3*a^12*z^8 + a^9*z^9 + 
  a^11*z^9, 2/a^8 + 4/a^6 + a^(-4) - 2/a^2 - (6*z)/a^9 - (10*z)/a^7 - 
  (3*z)/a^5 + z/a^3 - (2*z^2)/a^12 + (3*z^2)/a^10 - (3*z^2)/a^8 - 
  (13*z^2)/a^6 + (5*z^2)/a^2 - (3*z^3)/a^11 + (16*z^3)/a^9 + (22*z^3)/a^7 + 
  (6*z^3)/a^5 + (3*z^3)/a^3 + z^4/a^12 - (5*z^4)/a^10 + (9*z^4)/a^8 + 
  (18*z^4)/a^6 - z^4/a^4 - (4*z^4)/a^2 + (2*z^5)/a^11 - (11*z^5)/a^9 - 
  (15*z^5)/a^7 - (8*z^5)/a^5 - (6*z^5)/a^3 + (3*z^6)/a^10 - (7*z^6)/a^8 - 
  (15*z^6)/a^6 - (4*z^6)/a^4 + z^6/a^2 + (4*z^7)/a^9 + (3*z^7)/a^7 + 
  z^7/a^5 + (2*z^7)/a^3 + (3*z^8)/a^8 + (5*z^8)/a^6 + (2*z^8)/a^4 + z^9/a^7 + 
  z^9/a^5, -1 + 3/a^6 + 4/a^4 - a^(-2) + (2*z)/a^9 - (3*z)/a^7 - (9*z)/a^5 - 
  (5*z)/a^3 + a*z + 3*z^2 + z^2/a^8 - (8*z^2)/a^6 - (8*z^2)/a^4 + 
  (4*z^2)/a^2 - (3*z^3)/a^9 + (5*z^3)/a^7 + (21*z^3)/a^5 + (15*z^3)/a^3 - 
  2*a*z^3 - 6*z^4 - (4*z^4)/a^8 + (9*z^4)/a^6 + (13*z^4)/a^4 - (6*z^4)/a^2 + 
  z^5/a^9 - (6*z^5)/a^7 - (16*z^5)/a^5 - (16*z^5)/a^3 - (6*z^5)/a + a*z^5 + 
  3*z^6 + (2*z^6)/a^8 - (6*z^6)/a^6 - (12*z^6)/a^4 - z^6/a^2 + (3*z^7)/a^7 + 
  (5*z^7)/a^5 + (6*z^7)/a^3 + (4*z^7)/a + (3*z^8)/a^6 + (6*z^8)/a^4 + 
  (3*z^8)/a^2 + z^9/a^5 + z^9/a^3, 4 - a^(-4) + 2*a^2 + (2*z)/a^5 - (7*z)/a - 
  9*a*z - 4*a^3*z - 9*z^2 + (6*z^2)/a^4 + (4*z^2)/a^2 - 7*a^2*z^2 + z^3/a^7 - 
  (5*z^3)/a^5 + (2*z^3)/a^3 + (24*z^3)/a + 24*a*z^3 + 8*a^3*z^3 + 19*z^4 + 
  (3*z^4)/a^6 - (12*z^4)/a^4 - (9*z^4)/a^2 + 13*a^2*z^4 + (6*z^5)/a^5 - 
  (11*z^5)/a^3 - (28*z^5)/a - 16*a*z^5 - 5*a^3*z^5 - 20*z^6 + (8*z^6)/a^4 - 
  (3*z^6)/a^2 - 9*a^2*z^6 + (7*z^7)/a^3 + (7*z^7)/a + a*z^7 + a^3*z^7 + 
  6*z^8 + (4*z^8)/a^2 + 2*a^2*z^8 + z^9/a + a*z^9, 
 -3*a^6 + 3*a^10 + a^12 + a^7*z - 7*a^9*z - 11*a^11*z - 3*a^13*z - a^4*z^2 + 
  8*a^6*z^2 + 4*a^8*z^2 - 5*a^10*z^2 + 2*a^12*z^2 + 2*a^14*z^2 - 2*a^5*z^3 + 
  a^7*z^3 + 21*a^9*z^3 + 28*a^11*z^3 + 10*a^13*z^3 + a^4*z^4 - 9*a^6*z^4 - 
  7*a^8*z^4 + 6*a^10*z^4 - 3*a^14*z^4 + 3*a^5*z^5 - 6*a^7*z^5 - 26*a^9*z^5 - 
  27*a^11*z^5 - 10*a^13*z^5 + 6*a^6*z^6 - 13*a^10*z^6 - 6*a^12*z^6 + 
  a^14*z^6 + 6*a^7*z^7 + 10*a^9*z^7 + 7*a^11*z^7 + 3*a^13*z^7 + 4*a^8*z^8 + 
  7*a^10*z^8 + 3*a^12*z^8 + a^9*z^9 + a^11*z^9, 
 3 - 2/a^4 - 2/a^2 + 2*a^2 - z/a^7 + z/a^5 + z/a^3 - (5*z)/a - 8*a*z - 
  4*a^3*z - 7*z^2 - z^2/a^6 + (5*z^2)/a^4 + (5*z^2)/a^2 - 6*a^2*z^2 + 
  z^3/a^7 - (2*z^3)/a^5 + (2*z^3)/a^3 + (17*z^3)/a + 20*a*z^3 + 8*a^3*z^3 + 
  17*z^4 + (2*z^4)/a^6 - (6*z^4)/a^4 - (3*z^4)/a^2 + 12*a^2*z^4 + 
  (3*z^5)/a^5 - (7*z^5)/a^3 - (18*z^5)/a - 13*a*z^5 - 5*a^3*z^5 - 18*z^6 + 
  (4*z^6)/a^4 - (5*z^6)/a^2 - 9*a^2*z^6 + (4*z^7)/a^3 + (3*z^7)/a + a^3*z^7 + 
  5*z^8 + (3*z^8)/a^2 + 2*a^2*z^8 + z^9/a + a*z^9, 
 a^4 - a^6 + a^8 + 3*a^10 + a^12 + 2*a^7*z - 4*a^9*z - 9*a^11*z - 3*a^13*z - 
  2*a^4*z^2 + 2*a^6*z^2 - 3*a^8*z^2 - 8*a^10*z^2 + a^12*z^2 + 2*a^14*z^2 - 
  2*a^5*z^3 - 2*a^7*z^3 + 15*a^9*z^3 + 24*a^11*z^3 + 9*a^13*z^3 + a^4*z^4 - 
  3*a^6*z^4 + 5*a^8*z^4 + 13*a^10*z^4 + a^12*z^4 - 3*a^14*z^4 + 2*a^5*z^5 - 
  a^7*z^5 - 16*a^9*z^5 - 23*a^11*z^5 - 10*a^13*z^5 + 3*a^6*z^6 - 4*a^8*z^6 - 
  15*a^10*z^6 - 7*a^12*z^6 + a^14*z^6 + 3*a^7*z^7 + 5*a^9*z^7 + 5*a^11*z^7 + 
  3*a^13*z^7 + 3*a^8*z^8 + 6*a^10*z^8 + 3*a^12*z^8 + a^9*z^9 + a^11*z^9, 
 a^(-8) + 2/a^6 - 2/a^2 - (4*z)/a^9 - (8*z)/a^7 - (4*z)/a^5 - z^2/a^12 + 
  (2*z^2)/a^10 - (2*z^2)/a^8 - (7*z^2)/a^6 + (3*z^2)/a^4 + (5*z^2)/a^2 - 
  (3*z^3)/a^11 + (11*z^3)/a^9 + (21*z^3)/a^7 + (11*z^3)/a^5 + (4*z^3)/a^3 + 
  z^4/a^12 - (6*z^4)/a^10 + (4*z^4)/a^8 + (12*z^4)/a^6 - (3*z^4)/a^4 - 
  (4*z^4)/a^2 + (3*z^5)/a^11 - (11*z^5)/a^9 - (21*z^5)/a^7 - (13*z^5)/a^5 - 
  (6*z^5)/a^3 + (5*z^6)/a^10 - (5*z^6)/a^8 - (14*z^6)/a^6 - (3*z^6)/a^4 + 
  z^6/a^2 + (6*z^7)/a^9 + (7*z^7)/a^7 + (3*z^7)/a^5 + (2*z^7)/a^3 + 
  (4*z^8)/a^8 + (6*z^8)/a^6 + (2*z^8)/a^4 + z^9/a^7 + z^9/a^5, 
 -1 + 2/a^6 + 2/a^4 - 2/a^2 + z/a^9 - (3*z)/a^7 - (6*z)/a^5 - (2*z)/a^3 + 
  z/a + a*z + 4*z^2 + (2*z^2)/a^8 - (2*z^2)/a^6 + (8*z^2)/a^2 - (2*z^3)/a^9 + 
  (6*z^3)/a^7 + (18*z^3)/a^5 + (12*z^3)/a^3 - 2*a*z^3 - 6*z^4 - (5*z^4)/a^8 - 
  z^4/a^6 - z^4/a^4 - (11*z^4)/a^2 + z^5/a^9 - (9*z^5)/a^7 - (23*z^5)/a^5 - 
  (19*z^5)/a^3 - (5*z^5)/a + a*z^5 + 3*z^6 + (3*z^6)/a^8 - (3*z^6)/a^6 - 
  (7*z^6)/a^4 + (2*z^6)/a^2 + (5*z^7)/a^7 + (10*z^7)/a^5 + (9*z^7)/a^3 + 
  (4*z^7)/a + (4*z^8)/a^6 + (7*z^8)/a^4 + (3*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 -2 + a^(-4) - 3*a^2 - 2*a^4 - a^6 - (4*z)/a - 6*a*z - 4*a^3*z - 2*a^5*z + 
  8*z^2 - (2*z^2)/a^4 + 10*a^2*z^2 + 7*a^4*z^2 + 3*a^6*z^2 - (2*z^3)/a^3 + 
  (8*z^3)/a + 21*a*z^3 + 18*a^3*z^3 + 7*a^5*z^3 - 5*z^4 + z^4/a^4 - 
  (2*z^4)/a^2 - 4*a^2*z^4 - 5*a^4*z^4 - 3*a^6*z^4 + (2*z^5)/a^3 - (6*z^5)/a - 
  22*a*z^5 - 23*a^3*z^5 - 9*a^5*z^5 - z^6 + (3*z^6)/a^2 - 10*a^2*z^6 - 
  5*a^4*z^6 + a^6*z^6 + (4*z^7)/a + 7*a*z^7 + 6*a^3*z^7 + 3*a^5*z^7 + 3*z^8 + 
  6*a^2*z^8 + 3*a^4*z^8 + a*z^9 + a^3*z^9, -2 - a^(-6) - 3/a^4 - 4/a^2 - 
  a^2 + z/a^7 - (4*z)/a^3 - (5*z)/a - 2*a*z + 8*z^2 - z^2/a^8 + (3*z^2)/a^6 + 
  (10*z^2)/a^4 + (11*z^2)/a^2 + 3*a^2*z^2 - (3*z^3)/a^7 + (4*z^3)/a^5 + 
  (20*z^3)/a^3 + (21*z^3)/a + 8*a*z^3 - 6*z^4 + z^4/a^8 - (5*z^4)/a^6 - 
  (11*z^4)/a^4 - (8*z^4)/a^2 - 3*a^2*z^4 + (3*z^5)/a^7 - (7*z^5)/a^5 - 
  (28*z^5)/a^3 - (27*z^5)/a - 9*a*z^5 - 4*z^6 + (5*z^6)/a^6 + z^6/a^4 - 
  (9*z^6)/a^2 + a^2*z^6 + (6*z^7)/a^5 + (11*z^7)/a^3 + (8*z^7)/a + 3*a*z^7 + 
  3*z^8 + (4*z^8)/a^4 + (7*z^8)/a^2 + z^9/a^3 + z^9/a, 
 -2 - a^(-2) - 4*a^2 - 3*a^4 - a^6 - (2*z)/a - 6*a*z - 7*a^3*z - 3*a^5*z + 
  14*z^2 + (4*z^2)/a^2 + 18*a^2*z^2 + 11*a^4*z^2 + 3*a^6*z^2 - (2*z^3)/a^3 + 
  (5*z^3)/a + 25*a*z^3 + 27*a^3*z^3 + 9*a^5*z^3 - 22*z^4 + z^4/a^4 - 
  (9*z^4)/a^2 - 17*a^2*z^4 - 8*a^4*z^4 - 3*a^6*z^4 + (4*z^5)/a^3 - 
  (11*z^5)/a - 38*a*z^5 - 32*a^3*z^5 - 9*a^5*z^5 + 5*z^6 + (8*z^6)/a^2 - 
  7*a^2*z^6 - 3*a^4*z^6 + a^6*z^6 + (9*z^7)/a + 16*a*z^7 + 10*a^3*z^7 + 
  3*a^5*z^7 + 5*z^8 + 8*a^2*z^8 + 3*a^4*z^8 + a*z^9 + a^3*z^9, 
 4 - a^(-6) + a^(-4) + 5/a^2 - (6*z)/a^5 - (8*z)/a^3 - (2*z)/a - 16*z^2 + 
  z^2/a^10 - (2*z^2)/a^8 + (6*z^2)/a^6 + z^2/a^4 - (24*z^2)/a^2 + 
  (2*z^3)/a^9 - (6*z^3)/a^7 + (17*z^3)/a^5 + (26*z^3)/a^3 + z^3/a + 17*z^4 + 
  (3*z^4)/a^8 - (13*z^4)/a^6 + (5*z^4)/a^4 + (38*z^4)/a^2 + (4*z^5)/a^7 - 
  (18*z^5)/a^5 - (16*z^5)/a^3 + (6*z^5)/a - 7*z^6 + (5*z^6)/a^6 - 
  (10*z^6)/a^4 - (22*z^6)/a^2 + (5*z^7)/a^5 - (5*z^7)/a + z^8 + (3*z^8)/a^4 + 
  (4*z^8)/a^2 + z^9/a^3 + z^9/a, 4/a^6 + 7/a^4 + 2/a^2 - z/a^11 + z/a^9 - 
  z/a^7 - (6*z)/a^5 - (5*z)/a^3 - (2*z)/a - z^2/a^10 + (4*z^2)/a^8 - 
  (8*z^2)/a^6 - (23*z^2)/a^4 - (10*z^2)/a^2 + z^3/a^11 - (2*z^3)/a^9 + 
  (5*z^3)/a^7 + (16*z^3)/a^5 + (15*z^3)/a^3 + (7*z^3)/a + (2*z^4)/a^10 - 
  (6*z^4)/a^8 + (6*z^4)/a^6 + (30*z^4)/a^4 + (16*z^4)/a^2 + (3*z^5)/a^9 - 
  (8*z^5)/a^7 - (15*z^5)/a^5 - (9*z^5)/a^3 - (5*z^5)/a + (4*z^6)/a^8 - 
  (7*z^6)/a^6 - (21*z^6)/a^4 - (10*z^6)/a^2 + (4*z^7)/a^7 + (2*z^7)/a^5 - 
  z^7/a^3 + z^7/a + (3*z^8)/a^6 + (5*z^8)/a^4 + (2*z^8)/a^2 + z^9/a^5 + 
  z^9/a^3, a^4 + 3*a^8 + 4*a^10 + a^12 - 8*a^9*z - 10*a^11*z - 2*a^13*z - 
  2*a^4*z^2 + a^6*z^2 - 10*a^8*z^2 - 16*a^10*z^2 - 2*a^12*z^2 + a^14*z^2 - 
  2*a^5*z^3 + 20*a^9*z^3 + 28*a^11*z^3 + 10*a^13*z^3 + a^4*z^4 - 3*a^6*z^4 + 
  11*a^8*z^4 + 24*a^10*z^4 + 6*a^12*z^4 - 3*a^14*z^4 + 2*a^5*z^5 - 
  2*a^7*z^5 - 16*a^9*z^5 - 23*a^11*z^5 - 11*a^13*z^5 + 3*a^6*z^6 - 
  6*a^8*z^6 - 19*a^10*z^6 - 9*a^12*z^6 + a^14*z^6 + 3*a^7*z^7 + 4*a^9*z^7 + 
  4*a^11*z^7 + 3*a^13*z^7 + 3*a^8*z^8 + 6*a^10*z^8 + 3*a^12*z^8 + a^9*z^9 + 
  a^11*z^9, 4 + 3/a^4 + 6/a^2 - (4*z)/a^5 - (6*z)/a^3 - (3*z)/a - a*z - 
  9*z^2 - (2*z^2)/a^8 + (3*z^2)/a^6 - (8*z^2)/a^4 - (26*z^2)/a^2 + 
  4*a^2*z^2 - (3*z^3)/a^7 + (15*z^3)/a^5 + (16*z^3)/a^3 + (4*z^3)/a + 
  6*a*z^3 + 7*z^4 + z^4/a^8 - (5*z^4)/a^6 + (13*z^4)/a^4 + (30*z^4)/a^2 - 
  4*a^2*z^4 + (2*z^5)/a^7 - (11*z^5)/a^5 - (11*z^5)/a^3 - (5*z^5)/a - 
  7*a*z^5 - 6*z^6 + (3*z^6)/a^6 - (8*z^6)/a^4 - (18*z^6)/a^2 + a^2*z^6 + 
  (4*z^7)/a^5 + (2*z^7)/a^3 + 2*a*z^7 + 2*z^8 + (3*z^8)/a^4 + (5*z^8)/a^2 + 
  z^9/a^3 + z^9/a, 3/a^6 + 5/a^4 + a^(-2) + (2*z)/a^9 - (2*z)/a^7 - 
  (8*z)/a^5 - (6*z)/a^3 - (2*z)/a + 3*z^2 + z^2/a^8 - (12*z^2)/a^6 - 
  (17*z^2)/a^4 - z^2/a^2 - (3*z^3)/a^9 + (4*z^3)/a^7 + (19*z^3)/a^5 + 
  (20*z^3)/a^3 + (6*z^3)/a - 2*a*z^3 - 7*z^4 - (4*z^4)/a^8 + (12*z^4)/a^6 + 
  (24*z^4)/a^4 + z^4/a^2 + z^5/a^9 - (6*z^5)/a^7 - (14*z^5)/a^5 - 
  (17*z^5)/a^3 - (9*z^5)/a + a*z^5 + 3*z^6 + (2*z^6)/a^8 - (7*z^6)/a^6 - 
  (16*z^6)/a^4 - (4*z^6)/a^2 + (3*z^7)/a^7 + (4*z^7)/a^5 + (5*z^7)/a^3 + 
  (4*z^7)/a + (3*z^8)/a^6 + (6*z^8)/a^4 + (3*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 -2*a^6 + 2*a^8 + 4*a^10 + a^12 + a^7*z - 5*a^9*z - 6*a^11*z + 5*a^6*z^2 - 
  6*a^8*z^2 - 8*a^10*z^2 + 5*a^12*z^2 + 2*a^14*z^2 + 2*a^7*z^3 + 20*a^9*z^3 + 
  22*a^11*z^3 + a^13*z^3 - 3*a^15*z^3 - 4*a^6*z^4 + 8*a^8*z^4 + 8*a^10*z^4 - 
  13*a^12*z^4 - 8*a^14*z^4 + a^16*z^4 - 5*a^7*z^5 - 22*a^9*z^5 - 
  28*a^11*z^5 - 7*a^13*z^5 + 4*a^15*z^5 + a^6*z^6 - 8*a^8*z^6 - 13*a^10*z^6 + 
  3*a^12*z^6 + 7*a^14*z^6 + 2*a^7*z^7 + 6*a^9*z^7 + 11*a^11*z^7 + 
  7*a^13*z^7 + 3*a^8*z^8 + 7*a^10*z^8 + 4*a^12*z^8 + a^9*z^9 + a^11*z^9, 
 1 - 2*a^3*z - 6*a^5*z - 6*a^7*z - 2*a^9*z - 2*z^2 + 2*a^4*z^2 - 2*a^6*z^2 + 
  2*a^10*z^2 - 2*a*z^3 + 7*a^3*z^3 + 19*a^5*z^3 + 19*a^7*z^3 + 9*a^9*z^3 + 
  z^4 - 2*a^2*z^4 - a^4*z^4 + 7*a^6*z^4 + 2*a^8*z^4 - 3*a^10*z^4 + 2*a*z^5 - 
  6*a^3*z^5 - 19*a^5*z^5 - 21*a^7*z^5 - 10*a^9*z^5 + 3*a^2*z^6 - 2*a^4*z^6 - 
  13*a^6*z^6 - 7*a^8*z^6 + a^10*z^6 + 4*a^3*z^7 + 6*a^5*z^7 + 5*a^7*z^7 + 
  3*a^9*z^7 + 3*a^4*z^8 + 6*a^6*z^8 + 3*a^8*z^8 + a^5*z^9 + a^7*z^9, 
 -a^2 + a^4 + a^6 - 2*a*z - 6*a^3*z - 8*a^5*z - 4*a^7*z + 4*z^2 - z^2/a^2 + 
  7*a^2*z^2 - 5*a^4*z^2 - 7*a^6*z^2 + z^3/a^3 - (3*z^3)/a + 8*a*z^3 + 
  27*a^3*z^3 + 23*a^5*z^3 + 8*a^7*z^3 - 10*z^4 + (3*z^4)/a^2 - 9*a^2*z^4 + 
  17*a^4*z^4 + 13*a^6*z^4 + (5*z^5)/a - 14*a*z^5 - 30*a^3*z^5 - 16*a^5*z^5 - 
  5*a^7*z^5 + 7*z^6 - 4*a^2*z^6 - 20*a^4*z^6 - 9*a^6*z^6 + 7*a*z^7 + 
  7*a^3*z^7 + a^5*z^7 + a^7*z^7 + 4*a^2*z^8 + 6*a^4*z^8 + 2*a^6*z^8 + 
  a^3*z^9 + a^5*z^9, -a^(-8) - 2/a^6 - 2/a^4 - 2/a^2 + z/a^9 - (2*z)/a^7 - 
  (6*z)/a^5 - (4*z)/a^3 - z/a + 3*z^2 + (3*z^2)/a^8 + (7*z^2)/a^6 + 
  (12*z^2)/a^4 + (11*z^2)/a^2 - (2*z^3)/a^9 + (5*z^3)/a^7 + (23*z^3)/a^5 + 
  (22*z^3)/a^3 + (5*z^3)/a - a*z^3 - 7*z^4 - (5*z^4)/a^8 - (9*z^4)/a^6 - 
  (14*z^4)/a^4 - (17*z^4)/a^2 + z^5/a^9 - (8*z^5)/a^7 - (30*z^5)/a^5 - 
  (32*z^5)/a^3 - (10*z^5)/a + a*z^5 + 4*z^6 + (3*z^6)/a^8 - (4*z^6)/a^4 + 
  (3*z^6)/a^2 + (5*z^7)/a^7 + (13*z^7)/a^5 + (14*z^7)/a^3 + (6*z^7)/a + 
  (4*z^8)/a^6 + (8*z^8)/a^4 + (4*z^8)/a^2 + z^9/a^5 + z^9/a^3, 
 -3 - a^(-6) - 2/a^4 - 3/a^2 - 2*a^2 + z/a^7 + z/a^5 + z/a^3 - a*z + 10*z^2 - 
  z^2/a^8 + (4*z^2)/a^6 + (9*z^2)/a^4 + (9*z^2)/a^2 + 5*a^2*z^2 - 
  (3*z^3)/a^7 + (2*z^3)/a^3 + (4*z^3)/a + 5*a*z^3 - 7*z^4 + z^4/a^8 - 
  (6*z^4)/a^6 - (12*z^4)/a^4 - (8*z^4)/a^2 - 4*a^2*z^4 + (3*z^5)/a^7 - 
  (4*z^5)/a^5 - (11*z^5)/a^3 - (10*z^5)/a - 6*a*z^5 - 2*z^6 + (5*z^6)/a^6 + 
  (3*z^6)/a^4 - (5*z^6)/a^2 + a^2*z^6 + (5*z^7)/a^5 + (6*z^7)/a^3 + 
  (3*z^7)/a + 2*a*z^7 + 2*z^8 + (3*z^8)/a^4 + (5*z^8)/a^2 + z^9/a^3 + z^9/a, 
 -3 - a^(-4) - 3/a^2 - 3*a^2 - a^4 + z/a^5 + z/a^3 - z/a - a*z + a^3*z + 
  a^5*z + 12*z^2 + (4*z^2)/a^4 + (10*z^2)/a^2 + 10*a^2*z^2 + 4*a^4*z^2 - 
  (2*z^3)/a^5 + (7*z^3)/a + 7*a*z^3 - 2*a^5*z^3 - 12*z^4 - (6*z^4)/a^4 - 
  (12*z^4)/a^2 - 12*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - (5*z^5)/a^3 - 
  (15*z^5)/a - 15*a*z^5 - 5*a^3*z^5 + a^5*z^5 - 2*z^6 + (3*z^6)/a^4 + 
  (2*z^6)/a^2 + 2*a^2*z^6 + 3*a^4*z^6 + (4*z^7)/a^3 + (8*z^7)/a + 8*a*z^7 + 
  4*a^3*z^7 + 6*z^8 + (3*z^8)/a^2 + 3*a^2*z^8 + z^9/a + a*z^9, 
 -a^(-8) - 2/a^6 - 2/a^4 - 2/a^2 + z/a^9 - z/a^7 - (3*z)/a^5 - z/a^3 + 
  (2*z^2)/a^10 + (6*z^2)/a^8 + (7*z^2)/a^6 + (8*z^2)/a^4 + (5*z^2)/a^2 - 
  (3*z^3)/a^11 + (9*z^3)/a^7 + (11*z^3)/a^5 + (5*z^3)/a^3 + z^4/a^12 - 
  (8*z^4)/a^10 - (11*z^4)/a^8 - (4*z^4)/a^6 - (6*z^4)/a^4 - (4*z^4)/a^2 + 
  (4*z^5)/a^11 - (7*z^5)/a^9 - (19*z^5)/a^7 - (14*z^5)/a^5 - (6*z^5)/a^3 + 
  (7*z^6)/a^10 + (2*z^6)/a^8 - (8*z^6)/a^6 - (2*z^6)/a^4 + z^6/a^2 + 
  (7*z^7)/a^9 + (9*z^7)/a^7 + (4*z^7)/a^5 + (2*z^7)/a^3 + (4*z^8)/a^8 + 
  (6*z^8)/a^6 + (2*z^8)/a^4 + z^9/a^7 + z^9/a^5, 
 -3*a^2 - 4*a^4 - 3*a^6 - a^8 - a*z - 3*a^3*z - 3*a^5*z + a^9*z + 3*z^2 + 
  12*a^2*z^2 + 17*a^4*z^2 + 12*a^6*z^2 + 4*a^8*z^2 - z^3/a + 4*a*z^3 + 
  16*a^3*z^3 + 14*a^5*z^3 + a^7*z^3 - 2*a^9*z^3 - 7*z^4 - 16*a^2*z^4 - 
  17*a^4*z^4 - 14*a^6*z^4 - 6*a^8*z^4 + z^5/a - 10*a*z^5 - 26*a^3*z^5 - 
  21*a^5*z^5 - 5*a^7*z^5 + a^9*z^5 + 4*z^6 + 2*a^2*z^6 - 2*a^4*z^6 + 
  3*a^6*z^6 + 3*a^8*z^6 + 6*a*z^7 + 12*a^3*z^7 + 10*a^5*z^7 + 4*a^7*z^7 + 
  4*a^2*z^8 + 7*a^4*z^8 + 3*a^6*z^8 + a^3*z^9 + a^5*z^9, 
 -2*a^2 + 2*a^6 + a^8 - 4*a^5*z - 8*a^7*z - 4*a^9*z - z^2 + 5*a^2*z^2 + 
  8*a^4*z^2 - a^6*z^2 + a^8*z^2 + 4*a^10*z^2 - 3*a*z^3 + 3*a^3*z^3 + 
  9*a^5*z^3 + 11*a^7*z^3 + 8*a^9*z^3 + z^4 - 7*a^2*z^4 - 9*a^4*z^4 + 
  3*a^6*z^4 - 4*a^10*z^4 + 3*a*z^5 - 6*a^3*z^5 - 12*a^5*z^5 - 10*a^7*z^5 - 
  7*a^9*z^5 + 5*a^2*z^6 + a^4*z^6 - 9*a^6*z^6 - 4*a^8*z^6 + a^10*z^6 + 
  5*a^3*z^7 + 5*a^5*z^7 + 2*a^7*z^7 + 2*a^9*z^7 + 3*a^4*z^8 + 5*a^6*z^8 + 
  2*a^8*z^8 + a^5*z^9 + a^7*z^9, -a^(-6) - 3/a^4 - 3/a^2 - (3*z)/a^5 - 
  (7*z)/a^3 - (5*z)/a - a*z + 15*z^2 + (3*z^2)/a^6 + (12*z^2)/a^4 + 
  (20*z^2)/a^2 + 4*a^2*z^2 + (9*z^3)/a^5 + (24*z^3)/a^3 + (17*z^3)/a - 
  a*z^3 - 3*a^3*z^3 - 24*z^4 - (3*z^4)/a^6 - (9*z^4)/a^4 - (21*z^4)/a^2 - 
  8*a^2*z^4 + a^4*z^4 - (9*z^5)/a^5 - (29*z^5)/a^3 - (29*z^5)/a - 5*a*z^5 + 
  4*a^3*z^5 + 7*z^6 + z^6/a^6 - (3*z^6)/a^4 - (4*z^6)/a^2 + 7*a^2*z^6 + 
  (3*z^7)/a^5 + (9*z^7)/a^3 + (13*z^7)/a + 7*a*z^7 + 4*z^8 + (3*z^8)/a^4 + 
  (7*z^8)/a^2 + z^9/a^3 + z^9/a, a^(-8) - 4/a^4 - 4/a^2 - (2*z)/a^9 + 
  (2*z)/a^7 + (8*z)/a^5 + (4*z)/a^3 - z^2/a^12 + (3*z^2)/a^10 - (4*z^2)/a^8 - 
  (7*z^2)/a^6 + (9*z^2)/a^4 + (8*z^2)/a^2 - (3*z^3)/a^11 + (7*z^3)/a^9 - 
  (3*z^3)/a^7 - (15*z^3)/a^5 - (2*z^3)/a^3 + z^4/a^12 - (7*z^4)/a^10 + 
  (4*z^4)/a^8 + (10*z^4)/a^6 - (7*z^4)/a^4 - (5*z^4)/a^2 + (3*z^5)/a^11 - 
  (8*z^5)/a^9 - (2*z^5)/a^7 + (7*z^5)/a^5 - (2*z^5)/a^3 + (5*z^6)/a^10 - 
  (3*z^6)/a^8 - (9*z^6)/a^6 + z^6/a^2 + (5*z^7)/a^9 + (2*z^7)/a^7 - 
  (2*z^7)/a^5 + z^7/a^3 + (3*z^8)/a^8 + (4*z^8)/a^6 + z^8/a^4 + z^9/a^7 + 
  z^9/a^5, -2 + a^(-6) - a^(-4) - 5/a^2 + z/a^9 - z/a^7 - z/a^5 + (3*z)/a^3 + 
  (4*z)/a + 2*a*z + 4*z^2 + (2*z^2)/a^8 - (2*z^2)/a^6 - z^2/a^4 + 
  (7*z^2)/a^2 - (2*z^3)/a^9 + (2*z^3)/a^7 + (6*z^3)/a^5 - (5*z^3)/a - 
  3*a*z^3 - 5*z^4 - (6*z^4)/a^8 + (8*z^4)/a^4 - (3*z^4)/a^2 + z^5/a^9 - 
  (7*z^5)/a^7 - (9*z^5)/a^5 - (3*z^5)/a^3 - z^5/a + a*z^5 + 2*z^6 + 
  (3*z^6)/a^8 - (3*z^6)/a^6 - (9*z^6)/a^4 - z^6/a^2 + (4*z^7)/a^7 + 
  (4*z^7)/a^5 + (2*z^7)/a^3 + (2*z^7)/a + (3*z^8)/a^6 + (5*z^8)/a^4 + 
  (2*z^8)/a^2 + z^9/a^5 + z^9/a^3, -a^2 - a^4 - 4*a^6 - 4*a^8 - a^10 - 
  a^3*z - 3*a^5*z + 2*a^7*z + 6*a^9*z + 2*a^11*z + 3*a^2*z^2 + 6*a^4*z^2 + 
  11*a^6*z^2 + 10*a^8*z^2 + a^10*z^2 - a^12*z^2 + 7*a^3*z^3 + 15*a^5*z^3 + 
  5*a^7*z^3 - 7*a^9*z^3 - 4*a^11*z^3 - 3*a^2*z^4 - 4*a^4*z^4 - 7*a^6*z^4 - 
  10*a^8*z^4 - 3*a^10*z^4 + a^12*z^4 - 9*a^3*z^5 - 21*a^5*z^5 - 15*a^7*z^5 + 
  3*a^11*z^5 + a^2*z^6 - 5*a^4*z^6 - 8*a^6*z^6 + 2*a^8*z^6 + 4*a^10*z^6 + 
  3*a^3*z^7 + 6*a^5*z^7 + 7*a^7*z^7 + 4*a^9*z^7 + 3*a^4*z^8 + 6*a^6*z^8 + 
  3*a^8*z^8 + a^5*z^9 + a^7*z^9, 11 + 5/a^2 + 5*a^2 + (2*z)/a^5 - (2*z)/a^3 - 
  (11*z)/a - 11*a*z - 2*a^3*z + 2*a^5*z - 28*z^2 + z^2/a^4 - (13*z^2)/a^2 - 
  13*a^2*z^2 + a^4*z^2 - (3*z^3)/a^5 + (4*z^3)/a^3 + (22*z^3)/a + 22*a*z^3 + 
  4*a^3*z^3 - 3*a^5*z^3 + 32*z^4 - (4*z^4)/a^4 + (12*z^4)/a^2 + 12*a^2*z^4 - 
  4*a^4*z^4 + z^5/a^5 - (6*z^5)/a^3 - (15*z^5)/a - 15*a*z^5 - 6*a^3*z^5 + 
  a^5*z^5 - 18*z^6 + (2*z^6)/a^4 - (7*z^6)/a^2 - 7*a^2*z^6 + 2*a^4*z^6 + 
  (3*z^7)/a^3 + (4*z^7)/a + 4*a*z^7 + 3*a^3*z^7 + 6*z^8 + (3*z^8)/a^2 + 
  3*a^2*z^8 + z^9/a + a*z^9, -2*a^6 + 3*a^8 + 6*a^10 + 2*a^12 + a^7*z - 
  8*a^9*z - 12*a^11*z - 2*a^13*z + a^15*z + 5*a^6*z^2 - 7*a^8*z^2 - 
  13*a^10*z^2 + 2*a^12*z^2 + 2*a^14*z^2 - a^16*z^2 + 2*a^7*z^3 + 22*a^9*z^3 + 
  29*a^11*z^3 + 6*a^13*z^3 - 3*a^15*z^3 - 4*a^6*z^4 + 8*a^8*z^4 + 
  13*a^10*z^4 - 5*a^12*z^4 - 5*a^14*z^4 + a^16*z^4 - 5*a^7*z^5 - 23*a^9*z^5 - 
  29*a^11*z^5 - 8*a^13*z^5 + 3*a^15*z^5 + a^6*z^6 - 8*a^8*z^6 - 15*a^10*z^6 - 
  a^12*z^6 + 5*a^14*z^6 + 2*a^7*z^7 + 6*a^9*z^7 + 10*a^11*z^7 + 6*a^13*z^7 + 
  3*a^8*z^8 + 7*a^10*z^8 + 4*a^12*z^8 + a^9*z^9 + a^11*z^9, 
 1 - a^(-4) - a^(-2) - a^2 - a^4 + z/a^5 - (2*z)/a^3 - (8*z)/a - 8*a*z - 
  2*a^3*z + a^5*z + 6*z^2 + (3*z^2)/a^4 + (6*z^2)/a^2 + 6*a^2*z^2 + 
  3*a^4*z^2 - (2*z^3)/a^5 + (5*z^3)/a^3 + (25*z^3)/a + 25*a*z^3 + 5*a^3*z^3 - 
  2*a^5*z^3 - 8*z^4 - (5*z^4)/a^4 - (9*z^4)/a^2 - 9*a^2*z^4 - 5*a^4*z^4 + 
  z^5/a^5 - (8*z^5)/a^3 - (31*z^5)/a - 31*a*z^5 - 8*a^3*z^5 + a^5*z^5 - 
  6*z^6 + (3*z^6)/a^4 + 3*a^4*z^6 + (5*z^7)/a^3 + (13*z^7)/a + 13*a*z^7 + 
  5*a^3*z^7 + 8*z^8 + (4*z^8)/a^2 + 4*a^2*z^8 + z^9/a + a*z^9, 
 1 - z/a - 2*a*z + 2*a^5*z + a^7*z - 6*z^2 + z^2/a^2 - 13*a^2*z^2 - 
  5*a^4*z^2 - a^8*z^2 + (7*z^3)/a + 10*a*z^3 + 5*a^3*z^3 - 2*a^5*z^3 - 
  4*a^7*z^3 + 14*z^4 - (3*z^4)/a^2 + 32*a^2*z^4 + 10*a^4*z^4 - 4*a^6*z^4 + 
  a^8*z^4 - (10*z^5)/a - 8*a*z^5 - 4*a^3*z^5 - 3*a^5*z^5 + 3*a^7*z^5 - 
  14*z^6 + z^6/a^2 - 27*a^2*z^6 - 8*a^4*z^6 + 4*a^6*z^6 + (3*z^7)/a - 
  2*a*z^7 - a^3*z^7 + 4*a^5*z^7 + 4*z^8 + 8*a^2*z^8 + 4*a^4*z^8 + 2*a*z^9 + 
  2*a^3*z^9, 1 + a^(-6) + 2/a^4 + a^(-2) - (3*z)/a^7 - (6*z)/a^5 - 
  (4*z)/a^3 - z/a + 2*z^2 + (2*z^2)/a^8 - (4*z^2)/a^6 - (10*z^2)/a^4 - 
  (2*z^2)/a^2 - (2*z^3)/a^9 + (9*z^3)/a^7 + (20*z^3)/a^5 + (13*z^3)/a^3 + 
  (3*z^3)/a - a*z^3 - 7*z^4 - (6*z^4)/a^8 + (10*z^4)/a^6 + (22*z^4)/a^4 - 
  z^4/a^2 + z^5/a^9 - (11*z^5)/a^7 - (18*z^5)/a^5 - (17*z^5)/a^3 - 
  (10*z^5)/a + a*z^5 + 4*z^6 + (3*z^6)/a^8 - (10*z^6)/a^6 - (22*z^6)/a^4 - 
  (5*z^6)/a^2 + (5*z^7)/a^7 + (5*z^7)/a^5 + (6*z^7)/a^3 + (6*z^7)/a + 
  (5*z^8)/a^6 + (10*z^8)/a^4 + (5*z^8)/a^2 + (2*z^9)/a^5 + (2*z^9)/a^3, 
 -1 - 2/a^4 - 4/a^2 - z/a^7 + (2*z)/a^3 + (2*z)/a + a*z + 4*z^2 + z^2/a^8 - 
  z^2/a^6 + z^2/a^4 + (7*z^2)/a^2 - z^3/a^9 + (6*z^3)/a^7 + (11*z^3)/a^5 + 
  (4*z^3)/a^3 - (2*z^3)/a - 2*a*z^3 - 6*z^4 - (6*z^4)/a^8 + (2*z^4)/a^6 + 
  (9*z^4)/a^4 - (5*z^4)/a^2 + z^5/a^9 - (13*z^5)/a^7 - (20*z^5)/a^5 - 
  (11*z^5)/a^3 - (4*z^5)/a + a*z^5 + 3*z^6 + (4*z^6)/a^8 - (8*z^6)/a^6 - 
  (17*z^6)/a^4 - (2*z^6)/a^2 + (7*z^7)/a^7 + (8*z^7)/a^5 + (5*z^7)/a^3 + 
  (4*z^7)/a + (6*z^8)/a^6 + (10*z^8)/a^4 + (4*z^8)/a^2 + (2*z^9)/a^5 + 
  (2*z^9)/a^3, -a^2 + a^4 + a^6 - a*z - 2*a^3*z - 2*a^5*z + a^9*z - 
  7*a^2*z^2 - 14*a^4*z^2 - 5*a^6*z^2 + a^8*z^2 - a^10*z^2 + 4*a*z^3 + 
  11*a^3*z^3 + 14*a^5*z^3 + 2*a^7*z^3 - 4*a^9*z^3 + a^11*z^3 + 19*a^2*z^4 + 
  37*a^4*z^4 + 8*a^6*z^4 - 7*a^8*z^4 + 3*a^10*z^4 - 4*a*z^5 - 4*a^3*z^5 - 
  15*a^5*z^5 - 10*a^7*z^5 + 5*a^9*z^5 - 14*a^2*z^6 - 32*a^4*z^6 - 
  12*a^6*z^6 + 6*a^8*z^6 + a*z^7 - 5*a^3*z^7 + 6*a^7*z^7 + 3*a^2*z^8 + 
  8*a^4*z^8 + 5*a^6*z^8 + 2*a^3*z^9 + 2*a^5*z^9, 
 2 + a^(-4) + 2/a^2 - (2*z)/a^5 - (4*z)/a^3 - (3*z)/a - a*z + z^2 + 
  (2*z^2)/a^6 - (2*z^2)/a^4 - (6*z^2)/a^2 + 3*a^2*z^2 + (8*z^3)/a^5 + 
  (15*z^3)/a^3 + (13*z^3)/a + 4*a*z^3 - 2*a^3*z^3 - 7*z^4 - (3*z^4)/a^6 + 
  (7*z^4)/a^4 + (13*z^4)/a^2 - 9*a^2*z^4 + a^4*z^4 - (9*z^5)/a^5 - 
  (17*z^5)/a^3 - (23*z^5)/a - 11*a*z^5 + 4*a^3*z^5 - 2*z^6 + z^6/a^6 - 
  (10*z^6)/a^4 - (21*z^6)/a^2 + 8*a^2*z^6 + (3*z^7)/a^5 + (3*z^7)/a^3 + 
  (9*z^7)/a + 9*a*z^7 + 6*z^8 + (4*z^8)/a^4 + (10*z^8)/a^2 + (2*z^9)/a^3 + 
  (2*z^9)/a, -2 - a^(-4) - 3/a^2 - a^2 - z/a^3 - z/a + a*z + a^3*z + 7*z^2 + 
  z^2/a^6 + z^2/a^4 + (3*z^2)/a^2 + 3*a^2*z^2 - a^4*z^2 + (7*z^3)/a^5 + 
  (15*z^3)/a^3 + (13*z^3)/a + 2*a*z^3 - 3*a^3*z^3 - 5*z^4 - (2*z^4)/a^6 + 
  (5*z^4)/a^4 + (8*z^4)/a^2 - 5*a^2*z^4 + a^4*z^4 - (11*z^5)/a^5 - 
  (23*z^5)/a^3 - (21*z^5)/a - 6*a*z^5 + 3*a^3*z^5 - 3*z^6 + z^6/a^6 - 
  (12*z^6)/a^4 - (21*z^6)/a^2 + 5*a^2*z^6 + (4*z^7)/a^5 + (5*z^7)/a^3 + 
  (7*z^7)/a + 6*a*z^7 + 5*z^8 + (5*z^8)/a^4 + (10*z^8)/a^2 + (2*z^9)/a^3 + 
  (2*z^9)/a, -1 - a^(-2) - a^2 - z/a^3 - (4*z)/a - 4*a*z - a^3*z + 8*z^2 + 
  (3*z^2)/a^4 + (7*z^2)/a^2 + 7*a^2*z^2 + 3*a^4*z^2 - z^3/a^5 + (6*z^3)/a^3 + 
  (19*z^3)/a + 19*a*z^3 + 6*a^3*z^3 - a^5*z^3 - 8*z^4 - (6*z^4)/a^4 - 
  (10*z^4)/a^2 - 10*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - (11*z^5)/a^3 - 
  (32*z^5)/a - 32*a*z^5 - 11*a^3*z^5 + a^5*z^5 - 12*z^6 + (4*z^6)/a^4 - 
  (2*z^6)/a^2 - 2*a^2*z^6 + 4*a^4*z^6 + (7*z^7)/a^3 + (14*z^7)/a + 14*a*z^7 + 
  7*a^3*z^7 + 12*z^8 + (6*z^8)/a^2 + 6*a^2*z^8 + (2*z^9)/a + 2*a*z^9, 
 1 - a^4 - 2*a^6 - a^8 - 2*a^3*z - 4*a^5*z - a^7*z + a^9*z + 3*a^2*z^2 + 
  6*a^4*z^2 + 6*a^6*z^2 + 3*a^8*z^2 + 5*a*z^3 + 19*a^3*z^3 + 20*a^5*z^3 + 
  4*a^7*z^3 - 2*a^9*z^3 - 6*z^4 - 9*a^2*z^4 - 2*a^4*z^4 - 4*a^6*z^4 - 
  5*a^8*z^4 + z^5/a - 15*a*z^5 - 35*a^3*z^5 - 27*a^5*z^5 - 7*a^7*z^5 + 
  a^9*z^5 + 5*z^6 - 4*a^2*z^6 - 15*a^4*z^6 - 3*a^6*z^6 + 3*a^8*z^6 + 
  9*a*z^7 + 15*a^3*z^7 + 11*a^5*z^7 + 5*a^7*z^7 + 7*a^2*z^8 + 12*a^4*z^8 + 
  5*a^6*z^8 + 2*a^3*z^9 + 2*a^5*z^9, -2 + a^(-4) - 2*a^2 - z/a^5 - z/a^3 - 
  (2*z)/a - 2*a*z + 8*z^2 + (2*z^2)/a^6 - (4*z^2)/a^4 - (5*z^2)/a^2 + 
  6*a^2*z^2 - a^4*z^2 + (7*z^3)/a^5 + (7*z^3)/a^3 + (9*z^3)/a + 7*a*z^3 - 
  2*a^3*z^3 - 6*z^4 - (3*z^4)/a^6 + (9*z^4)/a^4 + (15*z^4)/a^2 - 8*a^2*z^4 + 
  a^4*z^4 - (9*z^5)/a^5 - (11*z^5)/a^3 - (15*z^5)/a - 10*a*z^5 + 3*a^3*z^5 - 
  3*z^6 + z^6/a^6 - (11*z^6)/a^4 - (21*z^6)/a^2 + 6*a^2*z^6 + (3*z^7)/a^5 + 
  z^7/a^3 + (5*z^7)/a + 7*a*z^7 + 5*z^8 + (4*z^8)/a^4 + (9*z^8)/a^2 + 
  (2*z^9)/a^3 + (2*z^9)/a, 5 + 2/a^2 + 2*a^2 - (3*z)/a^3 - (6*z)/a - 4*a*z + 
  a^5*z - 19*z^2 + z^2/a^4 - (9*z^2)/a^2 - 7*a^2*z^2 + 2*a^4*z^2 - 
  (2*z^3)/a^5 + (9*z^3)/a^3 + (18*z^3)/a + 9*a*z^3 - 2*a^5*z^3 + 35*z^4 - 
  (6*z^4)/a^4 + (16*z^4)/a^2 + 7*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - 
  (12*z^5)/a^3 - (13*z^5)/a - 7*a*z^5 - 6*a^3*z^5 + a^5*z^5 - 26*z^6 + 
  (3*z^6)/a^4 - (13*z^6)/a^2 - 7*a^2*z^6 + 3*a^4*z^6 + (5*z^7)/a^3 + 
  (2*z^7)/a + a*z^7 + 4*a^3*z^7 + 9*z^8 + (5*z^8)/a^2 + 4*a^2*z^8 + 
  (2*z^9)/a + 2*a*z^9, a^(-6) + a^(-4) - a^(-2) - z/a^9 - (5*z)/a^7 - 
  (5*z)/a^5 - z/a^3 + (2*z^2)/a^10 + (2*z^2)/a^8 - (2*z^2)/a^6 + z^2/a^4 + 
  (3*z^2)/a^2 - (2*z^3)/a^11 + (7*z^3)/a^9 + (21*z^3)/a^7 + (18*z^3)/a^5 + 
  (6*z^3)/a^3 + z^4/a^12 - (8*z^4)/a^10 - (4*z^4)/a^8 + (10*z^4)/a^6 + 
  (2*z^4)/a^4 - (3*z^4)/a^2 + (4*z^5)/a^11 - (14*z^5)/a^9 - (32*z^5)/a^7 - 
  (22*z^5)/a^5 - (8*z^5)/a^3 + (8*z^6)/a^10 - (5*z^6)/a^8 - (22*z^6)/a^6 - 
  (8*z^6)/a^4 + z^6/a^2 + (10*z^7)/a^9 + (12*z^7)/a^7 + (5*z^7)/a^5 + 
  (3*z^7)/a^3 + (7*z^8)/a^8 + (11*z^8)/a^6 + (4*z^8)/a^4 + (2*z^9)/a^7 + 
  (2*z^9)/a^5, -2*a^2 - a^4 - (2*z)/a^3 - (6*z)/a - 6*a*z - a^3*z + a^5*z - 
  6*z^2 - (6*z^2)/a^2 + 7*a^2*z^2 + 7*a^4*z^2 + (5*z^3)/a^3 + (18*z^3)/a + 
  25*a*z^3 + 7*a^3*z^3 - 4*a^5*z^3 + a^7*z^3 + 28*z^4 + (17*z^4)/a^2 - 
  6*a^2*z^4 - 14*a^4*z^4 + 3*a^6*z^4 - (4*z^5)/a^3 - (10*z^5)/a - 29*a*z^5 - 
  17*a^3*z^5 + 6*a^5*z^5 - 31*z^6 - (13*z^6)/a^2 - 9*a^2*z^6 + 9*a^4*z^6 + 
  z^7/a^3 - (3*z^7)/a + 5*a*z^7 + 9*a^3*z^7 + 9*z^8 + (3*z^8)/a^2 + 
  6*a^2*z^8 + (2*z^9)/a + 2*a*z^9, 3 + 2/a^4 + 4/a^2 - (3*z)/a^5 - 
  (5*z)/a^3 - (3*z)/a - a*z - 7*z^2 - z^2/a^8 + (2*z^2)/a^6 - (6*z^2)/a^4 - 
  (18*z^2)/a^2 + 2*a^2*z^2 - (3*z^3)/a^7 + (9*z^3)/a^5 + (16*z^3)/a^3 + 
  (10*z^3)/a + 6*a*z^3 + 11*z^4 + z^4/a^8 - (6*z^4)/a^6 + (10*z^4)/a^4 + 
  (31*z^4)/a^2 - 3*a^2*z^4 + (3*z^5)/a^7 - (10*z^5)/a^5 - (15*z^5)/a^3 - 
  (11*z^5)/a - 9*a*z^5 - 12*z^6 + (5*z^6)/a^6 - (9*z^6)/a^4 - (27*z^6)/a^2 + 
  a^2*z^6 + (6*z^7)/a^5 + (3*z^7)/a^3 + 3*a*z^7 + 4*z^8 + (5*z^8)/a^4 + 
  (9*z^8)/a^2 + (2*z^9)/a^3 + (2*z^9)/a, 2/a^6 + 3/a^4 + z/a^9 - (2*z)/a^7 - 
  (5*z)/a^5 - (3*z)/a^3 - z/a + 2*z^2 + (2*z^2)/a^8 - (4*z^2)/a^6 - 
  (7*z^2)/a^4 + z^2/a^2 - (2*z^3)/a^9 + (5*z^3)/a^7 + (17*z^3)/a^5 + 
  (16*z^3)/a^3 + (5*z^3)/a - a*z^3 - 6*z^4 - (5*z^4)/a^8 + (4*z^4)/a^6 + 
  (13*z^4)/a^4 - (2*z^4)/a^2 + z^5/a^9 - (8*z^5)/a^7 - (21*z^5)/a^5 - 
  (25*z^5)/a^3 - (12*z^5)/a + a*z^5 + 4*z^6 + (3*z^6)/a^8 - (6*z^6)/a^6 - 
  (19*z^6)/a^4 - (6*z^6)/a^2 + (5*z^7)/a^7 + (8*z^7)/a^5 + (10*z^7)/a^3 + 
  (7*z^7)/a + (5*z^8)/a^6 + (11*z^8)/a^4 + (6*z^8)/a^2 + (2*z^9)/a^5 + 
  (2*z^9)/a^3, -3 - a^(-6) - 2/a^4 - 3/a^2 - 2*a^2 - (2*z)/a^5 - (2*z)/a^3 - 
  z/a - a*z + 12*z^2 + (3*z^2)/a^6 + (6*z^2)/a^4 + (10*z^2)/a^2 + 5*a^2*z^2 + 
  (7*z^3)/a^5 + (16*z^3)/a^3 + (17*z^3)/a + 7*a*z^3 - a^3*z^3 - 17*z^4 - 
  (3*z^4)/a^6 - z^4/a^4 - (4*z^4)/a^2 - 10*a^2*z^4 + a^4*z^4 - (8*z^5)/a^5 - 
  (23*z^5)/a^3 - (34*z^5)/a - 15*a*z^5 + 4*a^3*z^5 + z^6/a^6 - (7*z^6)/a^4 - 
  (17*z^6)/a^2 + 9*a^2*z^6 + (3*z^7)/a^5 + (6*z^7)/a^3 + (14*z^7)/a + 
  11*a*z^7 + 7*z^8 + (4*z^8)/a^4 + (11*z^8)/a^2 + (2*z^9)/a^3 + (2*z^9)/a, 
 -a^(-8) - 2/a^6 - 2/a^4 - 2/a^2 - (4*z)/a^7 - (6*z)/a^5 - (2*z)/a^3 - z^2 + 
  z^2/a^10 + z^2/a^8 + (3*z^2)/a^6 + (10*z^2)/a^4 + (6*z^2)/a^2 + 
  (8*z^3)/a^9 + (20*z^3)/a^7 + (24*z^3)/a^5 + (10*z^3)/a^3 - (2*z^3)/a + 
  z^4 - (2*z^4)/a^10 + (4*z^4)/a^8 + (5*z^4)/a^6 - (9*z^4)/a^4 - 
  (7*z^4)/a^2 - (11*z^5)/a^9 - (28*z^5)/a^7 - (32*z^5)/a^5 - (12*z^5)/a^3 + 
  (3*z^5)/a + z^6/a^10 - (11*z^6)/a^8 - (21*z^6)/a^6 - (3*z^6)/a^4 + 
  (6*z^6)/a^2 + (4*z^7)/a^9 + (7*z^7)/a^7 + (11*z^7)/a^5 + (8*z^7)/a^3 + 
  (5*z^8)/a^8 + (11*z^8)/a^6 + (6*z^8)/a^4 + (2*z^9)/a^7 + (2*z^9)/a^5, 
 -a^2 + 3*a^4 + 5*a^6 + 2*a^8 - 6*a^5*z - 12*a^7*z - 6*a^9*z + 3*a^2*z^2 - 
  2*a^4*z^2 - 10*a^6*z^2 + 4*a^10*z^2 - a^12*z^2 + 5*a^3*z^3 + 14*a^5*z^3 + 
  25*a^7*z^3 + 14*a^9*z^3 - 2*a^11*z^3 - 3*a^2*z^4 + 4*a^4*z^4 + 17*a^6*z^4 + 
  2*a^8*z^4 - 7*a^10*z^4 + a^12*z^4 - 8*a^3*z^5 - 17*a^5*z^5 - 26*a^7*z^5 - 
  14*a^9*z^5 + 3*a^11*z^5 + a^2*z^6 - 9*a^4*z^6 - 23*a^6*z^6 - 7*a^8*z^6 + 
  6*a^10*z^6 + 3*a^3*z^7 + 3*a^5*z^7 + 8*a^7*z^7 + 8*a^9*z^7 + 4*a^4*z^8 + 
  10*a^6*z^8 + 6*a^8*z^8 + 2*a^5*z^9 + 2*a^7*z^9, 
 9 + 4/a^2 + 4*a^2 + z/a^5 - (3*z)/a^3 - (10*z)/a - 10*a*z - 3*a^3*z + 
  a^5*z - 18*z^2 + z^2/a^4 - (8*z^2)/a^2 - 8*a^2*z^2 + a^4*z^2 - 
  (2*z^3)/a^5 + (5*z^3)/a^3 + (21*z^3)/a + 21*a*z^3 + 5*a^3*z^3 - 2*a^5*z^3 + 
  28*z^4 - (5*z^4)/a^4 + (9*z^4)/a^2 + 9*a^2*z^4 - 5*a^4*z^4 + z^5/a^5 - 
  (9*z^5)/a^3 - (18*z^5)/a - 18*a*z^5 - 9*a^3*z^5 + a^5*z^5 - 24*z^6 + 
  (3*z^6)/a^4 - (9*z^6)/a^2 - 9*a^2*z^6 + 3*a^4*z^6 + (5*z^7)/a^3 + 
  (5*z^7)/a + 5*a*z^7 + 5*a^3*z^7 + 10*z^8 + (5*z^8)/a^2 + 5*a^2*z^8 + 
  (2*z^9)/a + 2*a*z^9, a^2 + 5*a^4 + 3*a^6 - 2*a*z - 6*a^3*z - 8*a^5*z - 
  2*a^7*z + 2*a^9*z - 7*a^2*z^2 - 17*a^4*z^2 - 6*a^6*z^2 + 4*a^8*z^2 + 
  5*a*z^3 + 20*a^3*z^3 + 26*a^5*z^3 + 5*a^7*z^3 - 5*a^9*z^3 + a^11*z^3 + 
  17*a^2*z^4 + 36*a^4*z^4 + 5*a^6*z^4 - 11*a^8*z^4 + 3*a^10*z^4 - 4*a*z^5 - 
  11*a^3*z^5 - 27*a^5*z^5 - 14*a^7*z^5 + 6*a^9*z^5 - 13*a^2*z^6 - 
  33*a^4*z^6 - 12*a^6*z^6 + 8*a^8*z^6 + a*z^7 - 3*a^3*z^7 + 4*a^5*z^7 + 
  8*a^7*z^7 + 3*a^2*z^8 + 9*a^4*z^8 + 6*a^6*z^8 + 2*a^3*z^9 + 2*a^5*z^9, 
 a^(-12) + 4/a^10 + 2/a^8 - 2/a^6 - z/a^13 - (9*z)/a^11 - (8*z)/a^9 + 
  z^2/a^14 + z^2/a^12 - (9*z^2)/a^10 - z^2/a^8 + (7*z^2)/a^6 - z^2/a^4 + 
  (8*z^3)/a^13 + (28*z^3)/a^11 + (26*z^3)/a^9 + (4*z^3)/a^7 - (2*z^3)/a^5 - 
  (2*z^4)/a^14 + (3*z^4)/a^12 + (15*z^4)/a^10 + z^4/a^8 - (8*z^4)/a^6 + 
  z^4/a^4 - (11*z^5)/a^13 - (31*z^5)/a^11 - (31*z^5)/a^9 - (8*z^5)/a^7 + 
  (3*z^5)/a^5 + z^6/a^14 - (11*z^6)/a^12 - (24*z^6)/a^10 - (6*z^6)/a^8 + 
  (6*z^6)/a^6 + (4*z^7)/a^13 + (7*z^7)/a^11 + (10*z^7)/a^9 + (7*z^7)/a^7 + 
  (5*z^8)/a^12 + (11*z^8)/a^10 + (6*z^8)/a^8 + (2*z^9)/a^11 + (2*z^9)/a^9, 
 a^(-4) + a^(-2) - a^2 - (2*z)/a^5 - (4*z)/a^3 - (4*z)/a - 2*a*z + 2*z^2 + 
  (2*z^2)/a^6 - (4*z^2)/a^4 - (8*z^2)/a^2 + 3*a^2*z^2 - a^4*z^2 + 
  (7*z^3)/a^5 + (13*z^3)/a^3 + (16*z^3)/a + 7*a*z^3 - 3*a^3*z^3 + 3*z^4 - 
  (3*z^4)/a^6 + (8*z^4)/a^4 + (21*z^4)/a^2 - 6*a^2*z^4 + a^4*z^4 - 
  (9*z^5)/a^5 - (14*z^5)/a^3 - (17*z^5)/a - 9*a*z^5 + 3*a^3*z^5 - 7*z^6 + 
  z^6/a^6 - (11*z^6)/a^4 - (24*z^6)/a^2 + 5*a^2*z^6 + (3*z^7)/a^5 + z^7/a^3 + 
  (4*z^7)/a + 6*a*z^7 + 5*z^8 + (4*z^8)/a^4 + (9*z^8)/a^2 + (2*z^9)/a^3 + 
  (2*z^9)/a, -1 - 3*a^2 + a^6 + z/a + a*z - 2*a^3*z - 6*a^5*z - 4*a^7*z + 
  3*z^2 + 2*a^2*z^2 - 8*a^4*z^2 - 6*a^6*z^2 + a^8*z^2 - (2*z^3)/a - 2*a*z^3 + 
  9*a^3*z^3 + 21*a^5*z^3 + 10*a^7*z^3 - 2*a^9*z^3 - 6*z^4 + 25*a^4*z^4 + 
  13*a^6*z^4 - 6*a^8*z^4 + z^5/a - 5*a*z^5 - 9*a^3*z^5 - 16*a^5*z^5 - 
  12*a^7*z^5 + a^9*z^5 + 3*z^6 - 5*a^2*z^6 - 23*a^4*z^6 - 12*a^6*z^6 + 
  3*a^8*z^6 + 4*a*z^7 + 2*a^3*z^7 + 3*a^5*z^7 + 5*a^7*z^7 + 4*a^2*z^8 + 
  9*a^4*z^8 + 5*a^6*z^8 + 2*a^3*z^9 + 2*a^5*z^9, 
 3 + a^(-2) + a^2 - (2*z)/a^3 - (4*z)/a - 2*a*z + a^3*z + a^5*z - 15*z^2 + 
  (2*z^2)/a^4 - (6*z^2)/a^2 - 4*a^2*z^2 + 3*a^4*z^2 - (2*z^3)/a^5 + 
  (8*z^3)/a^3 + (13*z^3)/a + 4*a*z^3 - a^3*z^3 - 2*a^5*z^3 + 27*z^4 - 
  (6*z^4)/a^4 + (12*z^4)/a^2 + 3*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - 
  (11*z^5)/a^3 - (12*z^5)/a - 6*a*z^5 - 5*a^3*z^5 + a^5*z^5 - 22*z^6 + 
  (3*z^6)/a^4 - (11*z^6)/a^2 - 5*a^2*z^6 + 3*a^4*z^6 + (5*z^7)/a^3 + 
  (3*z^7)/a + 2*a*z^7 + 4*a^3*z^7 + 9*z^8 + (5*z^8)/a^2 + 4*a^2*z^8 + 
  (2*z^9)/a + 2*a*z^9, -1 - a^(-2) - a^2 - z/a^5 - (3*z)/a^3 - (4*z)/a - 
  2*a*z + 5*z^2 + (3*z^2)/a^6 + (5*z^2)/a^4 + (4*z^2)/a^2 + 3*a^2*z^2 - 
  (2*z^3)/a^7 + (6*z^3)/a^5 + (19*z^3)/a^3 + (18*z^3)/a + 7*a*z^3 - z^4 + 
  z^4/a^8 - (8*z^4)/a^6 - (9*z^4)/a^4 + (2*z^4)/a^2 - 3*a^2*z^4 + 
  (4*z^5)/a^7 - (13*z^5)/a^5 - (33*z^5)/a^3 - (24*z^5)/a - 8*a*z^5 - 7*z^6 + 
  (8*z^6)/a^6 - (3*z^6)/a^4 - (19*z^6)/a^2 + a^2*z^6 + (10*z^7)/a^5 + 
  (13*z^7)/a^3 + (6*z^7)/a + 3*a*z^7 + 4*z^8 + (7*z^8)/a^4 + (11*z^8)/a^2 + 
  (2*z^9)/a^3 + (2*z^9)/a, 2 + a^(-4) + 2/a^2 + z/a^7 + z/a^5 - z/a^3 - 
  (2*z)/a - a*z - 5*z^2 - z^2/a^8 + (2*z^2)/a^6 - (3*z^2)/a^4 - 
  (13*z^2)/a^2 + 2*a^2*z^2 - (3*z^3)/a^7 + (3*z^3)/a^5 + (8*z^3)/a^3 + 
  (9*z^3)/a + 7*a*z^3 + 9*z^4 + z^4/a^8 - (5*z^4)/a^6 + (4*z^4)/a^4 + 
  (22*z^4)/a^2 - 3*a^2*z^4 + (3*z^5)/a^7 - (7*z^5)/a^5 - (13*z^5)/a^3 - 
  (12*z^5)/a - 9*a*z^5 - 11*z^6 + (5*z^6)/a^6 - (6*z^6)/a^4 - (23*z^6)/a^2 + 
  a^2*z^6 + (6*z^7)/a^5 + (4*z^7)/a^3 + z^7/a + 3*a*z^7 + 4*z^8 + 
  (5*z^8)/a^4 + (9*z^8)/a^2 + (2*z^9)/a^3 + (2*z^9)/a, 
 -a^(-4) - 2/a^2 + z/a^5 - (3*z)/a - 3*a*z - a^3*z + (3*z^2)/a^4 + 
  (3*z^2)/a^2 + 2*a^2*z^2 + 2*a^4*z^2 - (2*z^3)/a^5 + (3*z^3)/a^3 + 
  (15*z^3)/a + 17*a*z^3 + 6*a^3*z^3 - a^5*z^3 + 5*z^4 - (5*z^4)/a^4 - 
  (2*z^4)/a^2 - 4*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - (7*z^5)/a^3 - (22*z^5)/a - 
  27*a*z^5 - 12*a^3*z^5 + a^5*z^5 - 16*z^6 + (3*z^6)/a^4 - (4*z^6)/a^2 - 
  5*a^2*z^6 + 4*a^4*z^6 + (5*z^7)/a^3 + (9*z^7)/a + 11*a*z^7 + 7*a^3*z^7 + 
  11*z^8 + (5*z^8)/a^2 + 6*a^2*z^8 + (2*z^9)/a + 2*a*z^9, 
 1 - (2*z)/a^3 - (6*z)/a - 6*a*z - 2*a^3*z - 10*z^2 - z^2/a^6 + (2*z^2)/a^4 - 
  7*a^2*z^2 + z^3/a^7 - (3*z^3)/a^5 + (10*z^3)/a^3 + (28*z^3)/a + 19*a*z^3 + 
  5*a^3*z^3 + 33*z^4 + (3*z^4)/a^6 - (9*z^4)/a^4 + (4*z^4)/a^2 + 17*a^2*z^4 + 
  (5*z^5)/a^5 - (17*z^5)/a^3 - (29*z^5)/a - 11*a*z^5 - 4*a^3*z^5 - 33*z^6 + 
  (7*z^6)/a^4 - (13*z^6)/a^2 - 13*a^2*z^6 + (8*z^7)/a^3 + (4*z^7)/a - 
  3*a*z^7 + a^3*z^7 + 9*z^8 + (6*z^8)/a^2 + 3*a^2*z^8 + (2*z^9)/a + 2*a*z^9, 
 7 + 3/a^2 + 3*a^2 + z/a^5 - z/a^3 - (5*z)/a - 5*a*z - a^3*z + a^5*z - 
  18*z^2 + (2*z^2)/a^4 - (7*z^2)/a^2 - 7*a^2*z^2 + 2*a^4*z^2 - (2*z^3)/a^5 + 
  (4*z^3)/a^3 + (13*z^3)/a + 13*a*z^3 + 4*a^3*z^3 - 2*a^5*z^3 + 22*z^4 - 
  (5*z^4)/a^4 + (6*z^4)/a^2 + 6*a^2*z^4 - 5*a^4*z^4 + z^5/a^5 - (8*z^5)/a^3 - 
  (16*z^5)/a - 16*a*z^5 - 8*a^3*z^5 + a^5*z^5 - 20*z^6 + (3*z^6)/a^4 - 
  (7*z^6)/a^2 - 7*a^2*z^6 + 3*a^4*z^6 + (5*z^7)/a^3 + (6*z^7)/a + 6*a*z^7 + 
  5*a^3*z^7 + 10*z^8 + (5*z^8)/a^2 + 5*a^2*z^8 + (2*z^9)/a + 2*a*z^9, 
 -a^(-2) - a^4 - a^6 - z/a - 3*a*z - 6*a^3*z - 4*a^5*z + 2*z^2 + 
  (3*z^2)/a^2 - a^2*z^2 + 6*a^4*z^2 + 5*a^6*z^2 - a^8*z^2 + (6*z^3)/a + 
  13*a*z^3 + 21*a^3*z^3 + 12*a^5*z^3 - 2*a^7*z^3 + z^4 - (3*z^4)/a^2 + 
  8*a^2*z^4 - 4*a^4*z^4 - 7*a^6*z^4 + a^8*z^4 - (8*z^5)/a - 19*a*z^5 - 
  27*a^3*z^5 - 13*a^5*z^5 + 3*a^7*z^5 - 8*z^6 + z^6/a^2 - 20*a^2*z^6 - 
  5*a^4*z^6 + 6*a^6*z^6 + (3*z^7)/a + 4*a*z^7 + 9*a^3*z^7 + 8*a^5*z^7 + 
  4*z^8 + 10*a^2*z^8 + 6*a^4*z^8 + 2*a*z^9 + 2*a^3*z^9, 
 a^(-8) + 3/a^6 + 2/a^4 - a^(-2) - (4*z)/a^9 - (10*z)/a^7 - (7*z)/a^5 - 
  z/a^3 - z^2/a^12 + z^2/a^10 - (3*z^2)/a^8 - (10*z^2)/a^6 - (2*z^2)/a^4 + 
  (3*z^2)/a^2 - (3*z^3)/a^11 + (13*z^3)/a^9 + (30*z^3)/a^7 + (19*z^3)/a^5 + 
  (5*z^3)/a^3 + z^4/a^12 - (5*z^4)/a^10 + (10*z^4)/a^8 + (22*z^4)/a^6 + 
  (3*z^4)/a^4 - (3*z^4)/a^2 + (3*z^5)/a^11 - (13*z^5)/a^9 - (28*z^5)/a^7 - 
  (20*z^5)/a^5 - (8*z^5)/a^3 + (5*z^6)/a^10 - (11*z^6)/a^8 - (26*z^6)/a^6 - 
  (9*z^6)/a^4 + z^6/a^2 + (7*z^7)/a^9 + (7*z^7)/a^7 + (3*z^7)/a^5 + 
  (3*z^7)/a^3 + (6*z^8)/a^8 + (10*z^8)/a^6 + (4*z^8)/a^4 + (2*z^9)/a^7 + 
  (2*z^9)/a^5, -1 - 4*a^2 - 2*a^4 + 2*a^3*z + 2*a^5*z - 3*z^2 - 3*a^2*z^2 + 
  a^4*z^2 + a^6*z^2 + (6*z^3)/a + 13*a*z^3 + 9*a^3*z^3 - a^5*z^3 - 
  3*a^7*z^3 + 15*z^4 - (2*z^4)/a^2 + 28*a^2*z^4 + 3*a^4*z^4 - 7*a^6*z^4 + 
  a^8*z^4 - (11*z^5)/a - 16*a*z^5 - 17*a^3*z^5 - 8*a^5*z^5 + 4*a^7*z^5 - 
  18*z^6 + z^6/a^2 - 35*a^2*z^6 - 9*a^4*z^6 + 7*a^6*z^6 + (4*z^7)/a + 
  4*a^3*z^7 + 8*a^5*z^7 + 6*z^8 + 13*a^2*z^8 + 7*a^4*z^8 + 3*a*z^9 + 
  3*a^3*z^9, -a^(-6) - 3/a^4 - 3/a^2 + z/a^7 + z/a^5 - z/a^3 - z/a + 3*z^2 + 
  (3*z^2)/a^6 + (8*z^2)/a^4 + (8*z^2)/a^2 + (5*z^3)/a^7 + (16*z^3)/a^5 + 
  (17*z^3)/a^3 + (5*z^3)/a - a*z^3 - 6*z^4 - (5*z^4)/a^8 - (4*z^4)/a^6 + 
  z^4/a^4 - (6*z^4)/a^2 + z^5/a^9 - (16*z^5)/a^7 - (36*z^5)/a^5 - 
  (30*z^5)/a^3 - (10*z^5)/a + a*z^5 + 4*z^6 + (5*z^6)/a^8 - (9*z^6)/a^6 - 
  (23*z^6)/a^4 - (5*z^6)/a^2 + (10*z^7)/a^7 + (15*z^7)/a^5 + (12*z^7)/a^3 + 
  (7*z^7)/a + (9*z^8)/a^6 + (16*z^8)/a^4 + (7*z^8)/a^2 + (3*z^9)/a^5 + 
  (3*z^9)/a^3, -2*a^2 - a^4 - z/a - 3*a*z - 2*a^3*z + (2*z^2)/a^2 - 
  5*a^2*z^2 - 3*a^4*z^2 - (2*z^3)/a^3 + (5*z^3)/a + 18*a*z^3 + 18*a^3*z^3 + 
  7*a^5*z^3 + z^4 + z^4/a^4 - (8*z^4)/a^2 + 26*a^2*z^4 + 14*a^4*z^4 - 
  2*a^6*z^4 + (4*z^5)/a^3 - (13*z^5)/a - 27*a*z^5 - 21*a^3*z^5 - 11*a^5*z^5 - 
  9*z^6 + (8*z^6)/a^2 - 35*a^2*z^6 - 17*a^4*z^6 + a^6*z^6 + (10*z^7)/a + 
  8*a*z^7 + 2*a^3*z^7 + 4*a^5*z^7 + 8*z^8 + 14*a^2*z^8 + 6*a^4*z^8 + 
  3*a*z^9 + 3*a^3*z^9, 3 + a^(-2) + a^2 - (2*z)/a^3 - (5*z)/a - 5*a*z - 
  2*a^3*z - 6*z^2 + (2*z^2)/a^4 - z^2/a^2 - a^2*z^2 + 2*a^4*z^2 - z^3/a^5 + 
  (8*z^3)/a^3 + (22*z^3)/a + 22*a*z^3 + 8*a^3*z^3 - a^5*z^3 + 12*z^4 - 
  (5*z^4)/a^4 + z^4/a^2 + a^2*z^4 - 5*a^4*z^4 + z^5/a^5 - (13*z^5)/a^3 - 
  (34*z^5)/a - 34*a*z^5 - 13*a^3*z^5 + a^5*z^5 - 26*z^6 + (4*z^6)/a^4 - 
  (9*z^6)/a^2 - 9*a^2*z^6 + 4*a^4*z^6 + (8*z^7)/a^3 + (13*z^7)/a + 13*a*z^7 + 
  8*a^3*z^7 + 16*z^8 + (8*z^8)/a^2 + 8*a^2*z^8 + (3*z^9)/a + 3*a*z^9, 
 1 - z/a - 3*a*z - 3*a^3*z - a^5*z - z^2 + z^2/a^2 - 3*a^2*z^2 + a^4*z^2 + 
  2*a^6*z^2 + (6*z^3)/a + 17*a*z^3 + 19*a^3*z^3 + 6*a^5*z^3 - 2*a^7*z^3 + 
  9*z^4 - (2*z^4)/a^2 + 19*a^2*z^4 - a^4*z^4 - 8*a^6*z^4 + a^8*z^4 - 
  (10*z^5)/a - 22*a*z^5 - 29*a^3*z^5 - 13*a^5*z^5 + 4*a^7*z^5 - 15*z^6 + 
  z^6/a^2 - 32*a^2*z^6 - 8*a^4*z^6 + 8*a^6*z^6 + (4*z^7)/a + 3*a*z^7 + 
  9*a^3*z^7 + 10*a^5*z^7 + 6*z^8 + 14*a^2*z^8 + 8*a^4*z^8 + 3*a*z^9 + 
  3*a^3*z^9, a^(-6) + a^(-4) - a^(-2) - (3*z)/a^7 - (5*z)/a^5 - (3*z)/a^3 - 
  z/a + 2*z^2 + z^2/a^8 - (3*z^2)/a^6 - (4*z^2)/a^4 + (2*z^2)/a^2 - z^3/a^9 + 
  (8*z^3)/a^7 + (21*z^3)/a^5 + (18*z^3)/a^3 + (5*z^3)/a - a*z^3 - 6*z^4 - 
  (5*z^4)/a^8 + (6*z^4)/a^6 + (17*z^4)/a^4 + z^5/a^9 - (14*z^5)/a^7 - 
  (29*z^5)/a^5 - (26*z^5)/a^3 - (11*z^5)/a + a*z^5 + 4*z^6 + (4*z^6)/a^8 - 
  (12*z^6)/a^6 - (28*z^6)/a^4 - (8*z^6)/a^2 + (8*z^7)/a^7 + (10*z^7)/a^5 + 
  (9*z^7)/a^3 + (7*z^7)/a + (8*z^8)/a^6 + (15*z^8)/a^4 + (7*z^8)/a^2 + 
  (3*z^9)/a^5 + (3*z^9)/a^3, 1 - z/a^3 - (3*z)/a - 3*a*z - a^3*z - 6*z^2 + 
  z^2/a^4 - (2*z^2)/a^2 - 2*a^2*z^2 + a^4*z^2 - z^3/a^5 + (5*z^3)/a^3 + 
  (15*z^3)/a + 15*a*z^3 + 5*a^3*z^3 - a^5*z^3 + 24*z^4 - (6*z^4)/a^4 + 
  (6*z^4)/a^2 + 6*a^2*z^4 - 6*a^4*z^4 + z^5/a^5 - (12*z^5)/a^3 - (20*z^5)/a - 
  20*a*z^5 - 12*a^3*z^5 + a^5*z^5 - 30*z^6 + (4*z^6)/a^4 - (11*z^6)/a^2 - 
  11*a^2*z^6 + 4*a^4*z^6 + (7*z^7)/a^3 + (6*z^7)/a + 6*a*z^7 + 7*a^3*z^7 + 
  14*z^8 + (7*z^8)/a^2 + 7*a^2*z^8 + (3*z^9)/a + 3*a*z^9, 
 -1 - a^(-2) - a^2 - z/a^5 - (3*z)/a^3 - (4*z)/a - 2*a*z + 6*z^2 + z^2/a^6 + 
  z^2/a^2 + 4*a^2*z^2 + (7*z^3)/a^5 + (19*z^3)/a^3 + (22*z^3)/a + 9*a*z^3 - 
  a^3*z^3 - 7*z^4 - (2*z^4)/a^6 + (8*z^4)/a^4 + (13*z^4)/a^2 - 9*a^2*z^4 + 
  a^4*z^4 - (10*z^5)/a^5 - (26*z^5)/a^3 - (37*z^5)/a - 17*a*z^5 + 4*a^3*z^5 - 
  7*z^6 + z^6/a^6 - (14*z^6)/a^4 - (31*z^6)/a^2 + 9*a^2*z^6 + (4*z^7)/a^5 + 
  (5*z^7)/a^3 + (13*z^7)/a + 12*a*z^7 + 9*z^8 + (6*z^8)/a^4 + (15*z^8)/a^2 + 
  (3*z^9)/a^3 + (3*z^9)/a, -3*a^6 + 3*a^10 + a^12 + 2*a^7*z - 4*a^9*z - 
  8*a^11*z - 2*a^13*z + 7*a^6*z^2 - 7*a^10*z^2 + a^12*z^2 + a^14*z^2 + 
  5*a^7*z^3 + 26*a^9*z^3 + 29*a^11*z^3 + 8*a^13*z^3 + a^4*z^4 - 11*a^6*z^4 - 
  3*a^8*z^4 + 17*a^10*z^4 + 6*a^12*z^4 - 2*a^14*z^4 + 4*a^5*z^5 - 
  17*a^7*z^5 - 44*a^9*z^5 - 33*a^11*z^5 - 10*a^13*z^5 + 10*a^6*z^6 - 
  9*a^8*z^6 - 33*a^10*z^6 - 13*a^12*z^6 + a^14*z^6 + 13*a^7*z^7 + 
  16*a^9*z^7 + 7*a^11*z^7 + 4*a^13*z^7 + 10*a^8*z^8 + 16*a^10*z^8 + 
  6*a^12*z^8 + 3*a^9*z^9 + 3*a^11*z^9, 1 + a^2 + 2*a^4 + a^6 - a^3*z - 
  3*a^5*z - 2*a^7*z - 3*a^2*z^2 - 7*a^4*z^2 - 3*a^6*z^2 + a^8*z^2 + 4*a*z^3 + 
  14*a^3*z^3 + 19*a^5*z^3 + 8*a^7*z^3 - a^9*z^3 - 5*z^4 + 3*a^2*z^4 + 
  22*a^4*z^4 + 9*a^6*z^4 - 5*a^8*z^4 + z^5/a - 15*a*z^5 - 30*a^3*z^5 - 
  28*a^5*z^5 - 13*a^7*z^5 + a^9*z^5 + 5*z^6 - 13*a^2*z^6 - 36*a^4*z^6 - 
  14*a^6*z^6 + 4*a^8*z^6 + 10*a*z^7 + 11*a^3*z^7 + 9*a^5*z^7 + 8*a^7*z^7 + 
  10*a^2*z^8 + 19*a^4*z^8 + 9*a^6*z^8 + 4*a^3*z^9 + 4*a^5*z^9, 
 -1 - 2/a^4 - 4/a^2 + (2*z)/a^5 + (2*z)/a^3 + 2*z^2 + 2*a^2*z^2 + 
  (4*z^3)/a^5 + (14*z^3)/a^3 + (18*z^3)/a + 6*a*z^3 - 2*a^3*z^3 + 3*z^4 - 
  z^4/a^6 + (12*z^4)/a^4 + (24*z^4)/a^2 - 7*a^2*z^4 + a^4*z^4 - 
  (11*z^5)/a^5 - (25*z^5)/a^3 - (32*z^5)/a - 14*a*z^5 + 4*a^3*z^5 - 13*z^6 + 
  z^6/a^6 - (20*z^6)/a^4 - (42*z^6)/a^2 + 8*a^2*z^6 + (5*z^7)/a^5 + 
  (3*z^7)/a^3 + (9*z^7)/a + 11*a*z^7 + 10*z^8 + (8*z^8)/a^4 + (18*z^8)/a^2 + 
  (4*z^9)/a^3 + (4*z^9)/a, -3 - 2/a^2 - 2*a^2 - (2*z)/a - 2*a*z + 12*z^2 + 
  (6*z^2)/a^2 + 6*a^2*z^2 + (5*z^3)/a^3 + (21*z^3)/a + 21*a*z^3 + 5*a^3*z^3 + 
  4*z^4 - (5*z^4)/a^4 - (3*z^4)/a^2 - 3*a^2*z^4 - 5*a^4*z^4 + z^5/a^5 - 
  (15*z^5)/a^3 - (38*z^5)/a - 38*a*z^5 - 15*a^3*z^5 + a^5*z^5 - 32*z^6 + 
  (5*z^6)/a^4 - (11*z^6)/a^2 - 11*a^2*z^6 + 5*a^4*z^6 + (10*z^7)/a^3 + 
  (14*z^7)/a + 14*a*z^7 + 10*a^3*z^7 + 20*z^8 + (10*z^8)/a^2 + 10*a^2*z^8 + 
  (4*z^9)/a + 4*a*z^9, 2/a^12 + 8/a^10 + 7/a^8 - (8*z)/a^11 - (8*z)/a^9 - 
  z^2/a^12 - (22*z^2)/a^10 - (21*z^2)/a^8 + (14*z^3)/a^11 + (14*z^3)/a^9 + 
  (21*z^4)/a^10 + (21*z^4)/a^8 - (7*z^5)/a^11 - (7*z^5)/a^9 - (8*z^6)/a^10 - 
  (8*z^6)/a^8 + z^7/a^11 + z^7/a^9 + z^8/a^10 + z^8/a^8, 
 7 + 3/a^2 + 3*a^2 + z/a^5 - z/a^3 - (6*z)/a - 8*a*z - 4*a^3*z - 15*z^2 + 
  z^2/a^4 - (6*z^2)/a^2 - 8*a^2*z^2 + z^3/a^3 + (8*z^3)/a + 17*a*z^3 + 
  10*a^3*z^3 + 13*z^4 + (2*z^4)/a^2 + 11*a^2*z^4 - (5*z^5)/a - 11*a*z^5 - 
  6*a^3*z^5 - 6*z^6 - 6*a^2*z^6 + z^7/a + 2*a*z^7 + a^3*z^7 + z^8 + a^2*z^8, 
 2*a^2 + 7*a^4 + 4*a^6 - 2*a*z - 6*a^3*z - 8*a^5*z - a^7*z + 3*a^9*z - 
  4*a^2*z^2 - 16*a^4*z^2 - 11*a^6*z^2 + a^8*z^2 + a*z^3 + 11*a^3*z^3 + 
  16*a^5*z^3 + 2*a^7*z^3 - 4*a^9*z^3 + 2*a^2*z^4 + 16*a^4*z^4 + 11*a^6*z^4 - 
  3*a^8*z^4 - 5*a^3*z^5 - 9*a^5*z^5 - 3*a^7*z^5 + a^9*z^5 - 6*a^4*z^6 - 
  5*a^6*z^6 + a^8*z^6 + a^3*z^7 + 2*a^5*z^7 + a^7*z^7 + a^4*z^8 + a^6*z^8, 
 5*a^4 + 6*a^6 + 2*a^8 - 5*a^5*z - 8*a^7*z - 2*a^9*z + a^11*z - 9*a^4*z^2 - 
  14*a^6*z^2 - 2*a^8*z^2 + a^10*z^2 - 2*a^12*z^2 + 5*a^5*z^3 + 16*a^7*z^3 + 
  7*a^9*z^3 - 4*a^11*z^3 + 3*a^4*z^4 + 11*a^6*z^4 + 4*a^8*z^4 - 3*a^10*z^4 + 
  a^12*z^4 - 3*a^5*z^5 - 10*a^7*z^5 - 5*a^9*z^5 + 2*a^11*z^5 - 4*a^6*z^6 - 
  2*a^8*z^6 + 2*a^10*z^6 + a^5*z^7 + 3*a^7*z^7 + 2*a^9*z^7 + a^6*z^8 + 
  a^8*z^8, a^(-12) + 4/a^10 + 2/a^8 - 2/a^6 - (6*z)/a^11 - (5*z)/a^9 + 
  z/a^7 - (11*z^2)/a^10 - (5*z^2)/a^8 + (6*z^2)/a^6 + (11*z^3)/a^11 + 
  (13*z^3)/a^9 + (2*z^3)/a^7 + (12*z^4)/a^10 + (7*z^4)/a^8 - (5*z^4)/a^6 - 
  (6*z^5)/a^11 - (10*z^5)/a^9 - (4*z^5)/a^7 - (6*z^6)/a^10 - (5*z^6)/a^8 + 
  z^6/a^6 + z^7/a^11 + (2*z^7)/a^9 + z^7/a^7 + z^8/a^10 + z^8/a^8, 
 2 + a^(-2) - a^2 - a^4 - (2*z)/a^3 - (5*z)/a - 5*a*z - a^3*z + a^5*z - 
  4*z^2 - (3*z^2)/a^2 + 2*a^2*z^2 + 3*a^4*z^2 + z^3/a^3 + (9*z^3)/a + 
  15*a*z^3 + 4*a^3*z^3 - 3*a^5*z^3 + 8*z^4 + (2*z^4)/a^2 - 6*a^4*z^4 - 
  (4*z^5)/a - 11*a*z^5 - 6*a^3*z^5 + a^5*z^5 - 4*z^6 - 2*a^2*z^6 + 
  2*a^4*z^6 + z^7/a + 3*a*z^7 + 2*a^3*z^7 + z^8 + a^2*z^8, 
 -1 - 2*a^2 + 2*a^4 + 2*a^6 + z/a + a*z - 3*a^3*z - 9*a^5*z - 6*a^7*z + 
  2*z^2 + 6*a^2*z^2 - 4*a^6*z^2 - 2*a*z^3 + 8*a^3*z^3 + 21*a^5*z^3 + 
  11*a^7*z^3 - 7*a^2*z^4 + 7*a^6*z^4 + a*z^5 - 8*a^3*z^5 - 15*a^5*z^5 - 
  6*a^7*z^5 + 2*a^2*z^6 - 3*a^4*z^6 - 5*a^6*z^6 + 2*a^3*z^7 + 3*a^5*z^7 + 
  a^7*z^7 + a^4*z^8 + a^6*z^8, -2*a^2 + 2*a^6 + a^8 + a^3*z - a^5*z - 
  5*a^7*z - 3*a^9*z + 3*a^2*z^2 + 2*a^4*z^2 - 3*a^6*z^2 + 2*a^8*z^2 + 
  4*a^10*z^2 + a^3*z^3 + 2*a^5*z^3 + 10*a^7*z^3 + 9*a^9*z^3 - 2*a^4*z^4 - 
  2*a^6*z^4 - 4*a^8*z^4 - 4*a^10*z^4 + a^3*z^5 - 3*a^5*z^5 - 12*a^7*z^5 - 
  8*a^9*z^5 + 2*a^4*z^6 - a^8*z^6 + a^10*z^6 + 2*a^5*z^7 + 4*a^7*z^7 + 
  2*a^9*z^7 + a^6*z^8 + a^8*z^8, 3*a^4 + 2*a^6 - a*z - 4*a^3*z - 8*a^5*z - 
  5*a^7*z - a^2*z^2 - 7*a^4*z^2 - 6*a^6*z^2 + 9*a^3*z^3 + 19*a^5*z^3 + 
  10*a^7*z^3 + 10*a^4*z^4 + 10*a^6*z^4 - 6*a^3*z^5 - 12*a^5*z^5 - 6*a^7*z^5 - 
  6*a^4*z^6 - 6*a^6*z^6 + a^3*z^7 + 2*a^5*z^7 + a^7*z^7 + a^4*z^8 + a^6*z^8, 
 -a^2 + 2*a^4 + 3*a^6 + a^8 - 4*a^5*z - 7*a^7*z - 3*a^9*z + a^2*z^2 - 
  3*a^4*z^2 - 6*a^6*z^2 + a^8*z^2 + 3*a^10*z^2 + a^3*z^3 + 7*a^5*z^3 + 
  16*a^7*z^3 + 10*a^9*z^3 + 2*a^4*z^4 + 6*a^6*z^4 - 4*a^10*z^4 - 4*a^5*z^5 - 
  13*a^7*z^5 - 9*a^9*z^5 - 4*a^6*z^6 - 3*a^8*z^6 + a^10*z^6 + a^5*z^7 + 
  3*a^7*z^7 + 2*a^9*z^7 + a^6*z^8 + a^8*z^8, a^(-12) + 3/a^10 - 3/a^6 - 
  (2*z)/a^13 - (8*z)/a^11 - (4*z)/a^9 + (2*z)/a^7 + z^2/a^14 + z^2/a^12 - 
  (7*z^2)/a^10 + (7*z^2)/a^6 + (3*z^3)/a^13 + (14*z^3)/a^11 + (11*z^3)/a^9 - 
  z^4/a^12 + (5*z^4)/a^10 + z^4/a^8 - (5*z^4)/a^6 - (8*z^5)/a^11 - 
  (11*z^5)/a^9 - (3*z^5)/a^7 + z^6/a^12 - (3*z^6)/a^10 - (3*z^6)/a^8 + 
  z^6/a^6 + (2*z^7)/a^11 + (3*z^7)/a^9 + z^7/a^7 + z^8/a^10 + z^8/a^8, 
 4 + 2/a^2 - a^4 - (3*z)/a^3 - (6*z)/a - 4*a*z + a^3*z + 2*a^5*z - 6*z^2 - 
  (4*z^2)/a^2 + a^2*z^2 + 3*a^4*z^2 + (3*z^3)/a^3 + (9*z^3)/a + 8*a*z^3 - 
  a^3*z^3 - 3*a^5*z^3 + 3*z^4 + (2*z^4)/a^2 - 4*a^2*z^4 - 5*a^4*z^4 - 
  (4*z^5)/a - 8*a*z^5 - 3*a^3*z^5 + a^5*z^5 + z^6/a^2 + a^2*z^6 + 2*a^4*z^6 + 
  (2*z^7)/a + 4*a*z^7 + 2*a^3*z^7 + z^8 + a^2*z^8, 
 -2 - a^(-4) - 3/a^2 - a^2 - (2*z)/a^3 - (4*z)/a - 2*a*z + 6*z^2 + z^2/a^4 + 
  (4*z^2)/a^2 + 3*a^2*z^2 + (7*z^3)/a^3 + (16*z^3)/a + 9*a*z^3 - 2*z^4 + 
  (2*z^4)/a^2 - 4*a^2*z^4 - (5*z^5)/a^3 - (14*z^5)/a - 9*a*z^5 - 3*z^6 - 
  (4*z^6)/a^2 + a^2*z^6 + z^7/a^3 + (3*z^7)/a + 2*a*z^7 + z^8 + z^8/a^2, 
 -1 - a^(-2) - 2*a^2 - 2*a^4 - a^6 - z/a - 3*a*z - 5*a^3*z - 3*a^5*z + 
  4*z^2 + z^2/a^2 + 7*a^2*z^2 + 8*a^4*z^2 + 4*a^6*z^2 + (2*z^3)/a + 9*a*z^3 + 
  15*a^3*z^3 + 8*a^5*z^3 - 2*z^4 - 5*a^2*z^4 - 7*a^4*z^4 - 4*a^6*z^4 - 
  7*a*z^5 - 15*a^3*z^5 - 8*a^5*z^5 + z^6 - a^2*z^6 - a^4*z^6 + a^6*z^6 + 
  2*a*z^7 + 4*a^3*z^7 + 2*a^5*z^7 + a^2*z^8 + a^4*z^8, 
 -3 - a^(-6) - 2/a^4 - 3/a^2 - 2*a^2 - (2*z)/a^5 - (2*z)/a^3 - z/a - a*z + 
  12*z^2 + (3*z^2)/a^6 + (6*z^2)/a^4 + (10*z^2)/a^2 + 5*a^2*z^2 + 
  (3*z^3)/a^5 + (5*z^3)/a^3 + (8*z^3)/a + 6*a*z^3 - 12*z^4 - (5*z^4)/a^4 - 
  (13*z^4)/a^2 - 4*a^2*z^4 + z^5/a^5 - (6*z^5)/a^3 - (14*z^5)/a - 7*a*z^5 + 
  z^6 + (3*z^6)/a^4 + (3*z^6)/a^2 + a^2*z^6 + (3*z^7)/a^3 + (5*z^7)/a + 
  2*a*z^7 + z^8 + z^8/a^2, a^(-12) + 6/a^10 + 6/a^8 - (2*z)/a^15 - z/a^13 - 
  (5*z)/a^11 - (6*z)/a^9 - (2*z^2)/a^14 - (19*z^2)/a^10 - (21*z^2)/a^8 + 
  z^3/a^15 + z^3/a^13 + (13*z^3)/a^11 + (13*z^3)/a^9 + z^4/a^14 + 
  (20*z^4)/a^10 + (21*z^4)/a^8 - (7*z^5)/a^11 - (7*z^5)/a^9 - (8*z^6)/a^10 - 
  (8*z^6)/a^8 + z^7/a^11 + z^7/a^9 + z^8/a^10 + z^8/a^8, 
 1 + 2*a^2 + 4*a^4 + 2*a^6 - 2*a^3*z - 6*a^5*z - 4*a^7*z - 4*a^2*z^2 - 
  12*a^4*z^2 - 8*a^6*z^2 + 6*a^3*z^3 + 16*a^5*z^3 + 10*a^7*z^3 + a^2*z^4 + 
  12*a^4*z^4 + 11*a^6*z^4 - 5*a^3*z^5 - 11*a^5*z^5 - 6*a^7*z^5 - 6*a^4*z^6 - 
  6*a^6*z^6 + a^3*z^7 + 2*a^5*z^7 + a^7*z^7 + a^4*z^8 + a^6*z^8, 
 2 + 2*a^2 + a^4 - z/a - 3*a*z - 4*a^3*z - 2*a^5*z - 4*z^2 + z^2/a^2 - 
  9*a^2*z^2 - a^4*z^2 + 3*a^6*z^2 + (2*z^3)/a + 5*a*z^3 + 13*a^3*z^3 + 
  10*a^5*z^3 + 3*z^4 + 8*a^2*z^4 + a^4*z^4 - 4*a^6*z^4 - 3*a*z^5 - 
  12*a^3*z^5 - 9*a^5*z^5 - 4*a^2*z^6 - 3*a^4*z^6 + a^6*z^6 + a*z^7 + 
  3*a^3*z^7 + 2*a^5*z^7 + a^2*z^8 + a^4*z^8, a^(-12) + 5/a^10 + 4/a^8 - 
  a^(-6) + (2*z)/a^13 - (4*z)/a^11 - (6*z)/a^9 - z^2/a^12 - (17*z^2)/a^10 - 
  (10*z^2)/a^8 + (6*z^2)/a^6 + (9*z^3)/a^11 + (12*z^3)/a^9 + (3*z^3)/a^7 + 
  z^4/a^12 + (15*z^4)/a^10 + (9*z^4)/a^8 - (5*z^4)/a^6 - (5*z^5)/a^11 - 
  (9*z^5)/a^9 - (4*z^5)/a^7 - (6*z^6)/a^10 - (5*z^6)/a^8 + z^6/a^6 + 
  z^7/a^11 + (2*z^7)/a^9 + z^7/a^7 + z^8/a^10 + z^8/a^8, 
 3*a^4 + 2*a^6 - a*z - 3*a^3*z - 5*a^5*z - 2*a^7*z + a^9*z - 4*a^2*z^2 - 
  10*a^4*z^2 - 3*a^6*z^2 + 3*a^8*z^2 + a*z^3 + 7*a^3*z^3 + 14*a^5*z^3 + 
  5*a^7*z^3 - 3*a^9*z^3 + 3*a^2*z^4 + 11*a^4*z^4 + 2*a^6*z^4 - 6*a^8*z^4 - 
  3*a^3*z^5 - 10*a^5*z^5 - 6*a^7*z^5 + a^9*z^5 - 4*a^4*z^6 - 2*a^6*z^6 + 
  2*a^8*z^6 + a^3*z^7 + 3*a^5*z^7 + 2*a^7*z^7 + a^4*z^8 + a^6*z^8, 
 3 + 4*a^2 + 2*a^4 - 2*a^3*z - 2*a^5*z - 7*z^2 - 12*a^2*z^2 - 2*a^4*z^2 + 
  2*a^6*z^2 - a^8*z^2 + 8*a^3*z^3 + 4*a^5*z^3 - 4*a^7*z^3 + 3*z^4 + 
  8*a^2*z^4 - 2*a^4*z^4 - 6*a^6*z^4 + a^8*z^4 - a*z^5 - 8*a^3*z^5 - 
  4*a^5*z^5 + 3*a^7*z^5 - 2*a^2*z^6 + 2*a^4*z^6 + 4*a^6*z^6 + a*z^7 + 
  4*a^3*z^7 + 3*a^5*z^7 + a^2*z^8 + a^4*z^8, 2*a^4 + a^6 + a^8 + a^10 - 
  a^5*z - 2*a^7*z - 6*a^9*z - 5*a^11*z - 4*a^4*z^2 - 2*a^6*z^2 - 4*a^8*z^2 - 
  6*a^10*z^2 + 8*a^7*z^3 + 18*a^9*z^3 + 10*a^11*z^3 + a^4*z^4 + 9*a^8*z^4 + 
  10*a^10*z^4 - 6*a^7*z^5 - 12*a^9*z^5 - 6*a^11*z^5 - 6*a^8*z^6 - 
  6*a^10*z^6 + a^7*z^7 + 2*a^9*z^7 + a^11*z^7 + a^8*z^8 + a^10*z^8, 
 1 - z/a^3 - (3*z)/a - 3*a*z - a^3*z - 3*z^2 - (3*z^2)/a^2 + 3*a^2*z^2 + 
  3*a^4*z^2 + z^3/a^3 + (6*z^3)/a + 12*a*z^3 + 5*a^3*z^3 - 2*a^5*z^3 + 
  5*z^4 + (3*z^4)/a^2 - 6*a^2*z^4 - 8*a^4*z^4 - (2*z^5)/a - 11*a*z^5 - 
  8*a^3*z^5 + a^5*z^5 - 2*z^6 + a^2*z^6 + 3*a^4*z^6 + z^7/a + 4*a*z^7 + 
  3*a^3*z^7 + z^8 + a^2*z^8, -1 - a^(-2) - a^2 - z/a^5 - (3*z)/a^3 - 
  (4*z)/a - 2*a*z + 6*z^2 + z^2/a^6 + z^2/a^2 + 4*a^2*z^2 + (3*z^3)/a^5 + 
  (8*z^3)/a^3 + (13*z^3)/a + 8*a*z^3 - 6*z^4 - (2*z^4)/a^2 - 4*a^2*z^4 - 
  (6*z^5)/a^3 - (14*z^5)/a - 8*a*z^5 - z^6 + z^6/a^4 - z^6/a^2 + a^2*z^6 + 
  (2*z^7)/a^3 + (4*z^7)/a + 2*a*z^7 + z^8 + z^8/a^2, 
 a^2 + 5*a^4 + 3*a^6 - a*z - 3*a^3*z - 5*a^5*z - a^7*z + 2*a^9*z - 
  3*a^2*z^2 - 11*a^4*z^2 - 6*a^6*z^2 + 2*a^8*z^2 + a*z^3 + 6*a^3*z^3 + 
  9*a^5*z^3 + a^7*z^3 - 3*a^9*z^3 + 3*a^2*z^4 + 10*a^4*z^4 + 2*a^6*z^4 - 
  5*a^8*z^4 - 2*a^3*z^5 - 7*a^5*z^5 - 4*a^7*z^5 + a^9*z^5 - 3*a^4*z^6 - 
  a^6*z^6 + 2*a^8*z^6 + a^3*z^7 + 3*a^5*z^7 + 2*a^7*z^7 + a^4*z^8 + a^6*z^8, 
 4*a^4 + 4*a^6 + a^8 - 3*a^5*z - 3*a^7*z + a^9*z + a^11*z - 7*a^4*z^2 - 
  9*a^6*z^2 + a^10*z^2 - a^12*z^2 + 2*a^5*z^3 + 5*a^7*z^3 - a^9*z^3 - 
  4*a^11*z^3 + 3*a^4*z^4 + 5*a^6*z^4 - 4*a^8*z^4 - 5*a^10*z^4 + a^12*z^4 - 
  a^5*z^5 - 6*a^7*z^5 - 2*a^9*z^5 + 3*a^11*z^5 - a^6*z^6 + 3*a^8*z^6 + 
  4*a^10*z^6 + a^5*z^7 + 4*a^7*z^7 + 3*a^9*z^7 + a^6*z^8 + a^8*z^8, 
 -a^(-4) - 2/a^2 - z/a^9 - (3*z)/a^7 - (2*z)/a^5 + z^2/a^10 + z^2/a^8 + 
  (3*z^2)/a^6 + (8*z^2)/a^4 + (5*z^2)/a^2 + (3*z^3)/a^9 + (6*z^3)/a^7 + 
  (8*z^3)/a^5 + (5*z^3)/a^3 - (5*z^4)/a^6 - (9*z^4)/a^4 - (4*z^4)/a^2 - 
  (5*z^5)/a^7 - (12*z^5)/a^5 - (7*z^5)/a^3 + z^6/a^8 + z^6/a^2 + 
  (2*z^7)/a^7 + (4*z^7)/a^5 + (2*z^7)/a^3 + z^8/a^6 + z^8/a^4, 
 -1 + a^(-6) - 3/a^2 - (3*z)/a^7 - (3*z)/a^5 + z/a^3 + (2*z)/a + a*z + 
  4*z^2 - (2*z^2)/a^6 + (4*z^2)/a^4 + (10*z^2)/a^2 + (3*z^3)/a^7 + 
  (5*z^3)/a^5 + z^3/a^3 - (3*z^3)/a - 2*a*z^3 - 7*z^4 + (2*z^4)/a^6 - 
  (6*z^4)/a^4 - (15*z^4)/a^2 - (2*z^5)/a^5 - (7*z^5)/a^3 - (4*z^5)/a + 
  a*z^5 + 3*z^6 + z^6/a^6 + (3*z^6)/a^4 + (5*z^6)/a^2 + (2*z^7)/a^5 + 
  (5*z^7)/a^3 + (3*z^7)/a + z^8/a^4 + z^8/a^2, 
 8*a^8 + 10*a^10 + 3*a^12 - 10*a^9*z - 11*a^11*z + a^13*z + 2*a^15*z - 
  22*a^8*z^2 - 26*a^10*z^2 - 3*a^12*z^2 - a^14*z^2 - 2*a^16*z^2 + 
  17*a^9*z^3 + 19*a^11*z^3 - 3*a^13*z^3 - 5*a^15*z^3 + 21*a^8*z^4 + 
  25*a^10*z^4 + 2*a^12*z^4 - a^14*z^4 + a^16*z^4 - 8*a^9*z^5 - 8*a^11*z^5 + 
  2*a^13*z^5 + 2*a^15*z^5 - 8*a^8*z^6 - 9*a^10*z^6 + a^14*z^6 + a^9*z^7 + 
  a^11*z^7 + a^8*z^8 + a^10*z^8, 6 + 3/a^2 + a^2 - a^4 - (5*z)/a^3 - 
  (10*z)/a - 6*a*z + 2*a^3*z + 3*a^5*z - 12*z^2 - (7*z^2)/a^2 - 2*a^2*z^2 + 
  3*a^4*z^2 + (10*z^3)/a^3 + (22*z^3)/a + 12*a*z^3 - 4*a^3*z^3 - 4*a^5*z^3 + 
  14*z^4 + (10*z^4)/a^2 - 4*a^4*z^4 - (6*z^5)/a^3 - (13*z^5)/a - 7*a*z^5 + 
  a^3*z^5 + a^5*z^5 - 7*z^6 - (6*z^6)/a^2 + a^4*z^6 + z^7/a^3 + (2*z^7)/a + 
  a*z^7 + z^8 + z^8/a^2, a^(-12) + 2/a^10 - 2/a^8 - 4/a^6 - (4*z)/a^13 - 
  (10*z)/a^11 - (3*z)/a^9 + (3*z)/a^7 + (3*z^2)/a^14 + (2*z^2)/a^12 - 
  (5*z^2)/a^10 + (5*z^2)/a^8 + (9*z^2)/a^6 + (10*z^3)/a^13 + (21*z^3)/a^11 + 
  (9*z^3)/a^9 - (2*z^3)/a^7 - (4*z^4)/a^14 - z^4/a^12 + (7*z^4)/a^10 - 
  (2*z^4)/a^8 - (6*z^4)/a^6 - (9*z^5)/a^13 - (15*z^5)/a^11 - (6*z^5)/a^9 + 
  z^6/a^14 - (3*z^6)/a^12 - (5*z^6)/a^10 + z^6/a^6 + (2*z^7)/a^13 + 
  (3*z^7)/a^11 + z^7/a^9 + z^8/a^12 + z^8/a^10, 
 3 + 2/a^4 + 4/a^2 - (2*z)/a^5 - (2*z)/a^3 - 5*z^2 + (4*z^2)/a^6 - z^2/a^4 - 
  (11*z^2)/a^2 + a^2*z^2 + (8*z^3)/a^5 + (6*z^3)/a^3 + 2*a*z^3 + 4*z^4 - 
  (4*z^4)/a^6 - z^4/a^4 + (7*z^4)/a^2 - (8*z^5)/a^5 - (9*z^5)/a^3 - z^5/a + 
  z^6/a^6 - (2*z^6)/a^4 - (3*z^6)/a^2 + (2*z^7)/a^5 + (3*z^7)/a^3 + z^7/a + 
  z^8/a^4 + z^8/a^2, -2*a^2 - a^4 - a*z - 2*a^3*z - 2*a^5*z - a^7*z + 4*z^2 + 
  7*a^2*z^2 + a^4*z^2 - 2*a^6*z^2 - (2*z^3)/a + 3*a*z^3 + 8*a^3*z^3 + 
  4*a^5*z^3 + a^7*z^3 - 8*z^4 - 9*a^2*z^4 + 2*a^4*z^4 + 3*a^6*z^4 + z^5/a - 
  7*a*z^5 - 9*a^3*z^5 - a^5*z^5 + 3*z^6 + 2*a^2*z^6 - a^4*z^6 + 3*a*z^7 + 
  4*a^3*z^7 + a^5*z^7 + a^2*z^8 + a^4*z^8, -a^(-8) + 2/a^4 + (4*z)/a^9 + 
  (4*z)/a^7 + (2*z^2)/a^10 + (7*z^2)/a^8 - (5*z^2)/a^4 - (4*z^3)/a^11 - 
  (8*z^3)/a^9 - (6*z^3)/a^7 - (2*z^3)/a^5 + z^4/a^12 - (8*z^4)/a^10 - 
  (15*z^4)/a^8 - (3*z^4)/a^6 + (3*z^4)/a^4 + (4*z^5)/a^11 - (3*z^5)/a^7 + 
  z^5/a^5 + (6*z^6)/a^10 + (8*z^6)/a^8 + (2*z^6)/a^6 + (4*z^7)/a^9 + 
  (5*z^7)/a^7 + z^7/a^5 + z^8/a^8 + z^8/a^6, 
 -2 + a^(-4) - 2*a^2 + (2*z)/a^3 + z/a - a*z + 9*z^2 - (5*z^2)/a^4 - 
  (2*z^2)/a^2 + 5*a^2*z^2 - a^4*z^2 - (4*z^3)/a^3 + (2*z^3)/a + 3*a*z^3 - 
  3*a^3*z^3 - 13*z^4 + (3*z^4)/a^4 - z^4/a^2 - 8*a^2*z^4 + a^4*z^4 + 
  z^5/a^3 - (7*z^5)/a - 5*a*z^5 + 3*a^3*z^5 + 6*z^6 + z^6/a^2 + 5*a^2*z^6 + 
  z^7/a^3 + (5*z^7)/a + 4*a*z^7 + z^8 + z^8/a^2, 
 -a^2 + a^4 + a^6 + a^3*z + a^5*z + a^7*z + a^9*z - 2*a^2*z^2 - 4*a^4*z^2 + 
  a^6*z^2 + 3*a^8*z^2 + a*z^3 - a^7*z^3 - 2*a^9*z^3 + 4*a^2*z^4 + 3*a^4*z^4 - 
  8*a^6*z^4 - 7*a^8*z^4 + a^3*z^5 - 5*a^5*z^5 - 5*a^7*z^5 + a^9*z^5 + 
  3*a^6*z^6 + 3*a^8*z^6 + a^3*z^7 + 4*a^5*z^7 + 3*a^7*z^7 + a^4*z^8 + 
  a^6*z^8, -a^(-8) - a^(-6) - a^(-2) + (2*z)/a^9 - (3*z)/a^5 - z/a^3 + 
  z^2/a^8 + (3*z^2)/a^4 + (4*z^2)/a^2 + (3*z^3)/a^7 + (10*z^3)/a^5 + 
  (7*z^3)/a^3 + z^4/a^8 + (2*z^4)/a^6 - (3*z^4)/a^4 - (4*z^4)/a^2 - 
  (3*z^5)/a^7 - (11*z^5)/a^5 - (8*z^5)/a^3 - (3*z^6)/a^6 - (2*z^6)/a^4 + 
  z^6/a^2 + z^7/a^7 + (3*z^7)/a^5 + (2*z^7)/a^3 + z^8/a^6 + z^8/a^4, 
 -3*a^6 - a^8 + a^10 + 2*a^7*z + a^11*z + 3*a^13*z + 9*a^6*z^2 + 3*a^8*z^2 - 
  3*a^10*z^2 + 3*a^12*z^2 - a^7*z^3 - 3*a^11*z^3 - 4*a^13*z^3 - 6*a^6*z^4 - 
  a^8*z^4 + a^10*z^4 - 4*a^12*z^4 + a^11*z^5 + a^13*z^5 + a^6*z^6 + a^12*z^6, 
 3 + 3*a^2 - a^6 - 2*a*z - 7*a^3*z - 5*a^5*z - 7*z^2 - 9*a^2*z^2 + 
  5*a^4*z^2 + 5*a^6*z^2 - 2*a^8*z^2 + 15*a^3*z^3 + 12*a^5*z^3 - 3*a^7*z^3 + 
  3*z^4 + 6*a^2*z^4 - 4*a^4*z^4 - 6*a^6*z^4 + a^8*z^4 - a*z^5 - 11*a^3*z^5 - 
  8*a^5*z^5 + 2*a^7*z^5 - 2*a^2*z^6 + a^4*z^6 + 3*a^6*z^6 + a*z^7 + 
  4*a^3*z^7 + 3*a^5*z^7 + a^2*z^8 + a^4*z^8, 1 + a^(-6) + 2/a^4 + a^(-2) - 
  (2*z)/a^7 - (3*z)/a^5 - z/a^3 + 2*z^2 - (4*z^2)/a^6 - (4*z^2)/a^4 + 
  (2*z^2)/a^2 + (3*z^3)/a^7 + (7*z^3)/a^5 + (8*z^3)/a^3 + (3*z^3)/a - a*z^3 - 
  8*z^4 + (4*z^4)/a^6 + z^4/a^4 - (11*z^4)/a^2 - (4*z^5)/a^5 - (15*z^5)/a^3 - 
  (10*z^5)/a + a*z^5 + 4*z^6 + z^6/a^6 + (3*z^6)/a^2 + (3*z^7)/a^5 + 
  (8*z^7)/a^3 + (5*z^7)/a + (2*z^8)/a^4 + (2*z^8)/a^2, 
 3 + a^(-2) + a^2 - (2*z)/a^3 - (5*z)/a - 5*a*z - 2*a^3*z - 9*z^2 - 
  (6*z^2)/a^2 + 3*a^4*z^2 + (3*z^3)/a^3 + (10*z^3)/a + 16*a*z^3 + 7*a^3*z^3 - 
  2*a^5*z^3 + 8*z^4 + (4*z^4)/a^2 - 3*a^2*z^4 - 7*a^4*z^4 - (6*z^5)/a - 
  17*a*z^5 - 10*a^3*z^5 + a^5*z^5 - 3*z^6 + z^6/a^2 - a^2*z^6 + 3*a^4*z^6 + 
  (3*z^7)/a + 7*a*z^7 + 4*a^3*z^7 + 2*z^8 + 2*a^2*z^8, 
 a^(-6) + a^(-4) - a^(-2) - z/a^9 - (5*z)/a^7 - (5*z)/a^5 - z/a^3 + 
  (2*z^2)/a^10 + (2*z^2)/a^8 - (2*z^2)/a^6 + z^2/a^4 + (3*z^2)/a^2 + 
  (10*z^3)/a^9 + (18*z^3)/a^7 + (11*z^3)/a^5 + (3*z^3)/a^3 - (3*z^4)/a^10 - 
  (2*z^4)/a^8 - (2*z^4)/a^6 - (3*z^4)/a^4 - (11*z^5)/a^9 - (22*z^5)/a^7 - 
  (10*z^5)/a^5 + z^5/a^3 + z^6/a^10 - (4*z^6)/a^8 - (2*z^6)/a^6 + 
  (3*z^6)/a^4 + (3*z^7)/a^9 + (7*z^7)/a^7 + (4*z^7)/a^5 + (2*z^8)/a^8 + 
  (2*z^8)/a^6
}

Is = Function /@ (Is /. {a -> #1, z -> #2})

MapThread[(Kauffman[#1] = #2)&, {KOs, Is}]

Clear[KOs, Is]

End[]; EndPackage[]

