(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     16229,        443]
NotebookOptionsPosition[     13373,        367]
NotebookOutlinePosition[     13842,        385]
CellTagsIndexPosition[     13799,        382]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["RootsOfUnity package", "Subtitle",
 CellChangeTimes->{{3.430764258098104*^9, 
  3.4307642594901056`*^9}},ExpressionUUID->"bf1873d1-6a9c-41d0-8bec-\
2d888c8b3717"],

Cell["\<\
A subpackage for QuantumGroups v2.
Version 2.0, September 18, 2008, Scott Morrison\
\>", "Text",
 CellChangeTimes->{{3.4307642617433453`*^9, 
  3.4307642699551535`*^9}},ExpressionUUID->"8b61aa2a-7f89-4927-b314-\
bdcffcd73d94"],

Cell[CellGroupData[{

Cell["Introduction", "Section",ExpressionUUID->"5c048005-5986-4f35-95c9-c085e6341663"],

Cell["", "Text",ExpressionUUID->"e77de34a-e092-4dcf-9cde-96f1ef99c083"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation", "Section",ExpressionUUID->"7ed2e104-8a4c-4768-8cbe-9d0a5e50db0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<QuantumGroups`RootsOfUnity`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<QuantumGroups`\>\"", ",", "\"\<QuantumGroups`RootSystems`\>\""}], 
     "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.430404683340555*^9, 3.430404683560872*^9}, {
   3.43076424481901*^9, 3.4307642553040867`*^9}, 
   3.430764842738776*^9},ExpressionUUID->"98481f62-8e0a-49a1-a34f-\
679f6ec81547"],

Cell[BoxData[
 RowBox[{"AlcoveDefiningRoot", ";", "WeightInAlcoveQ", ";", "AlcoveWeights", 
  ";", "AlcoveWeightsInLattice", ";", "AlcoveRoots", ";", "LevelFromRoot", 
  ";", "RootFromLevel", ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4307643358398914`*^9, 3.430764353855797*^9}, {
  3.4360485863494415`*^9, 
  3.4360485875912275`*^9}},ExpressionUUID->"ada1744e-9bfd-4a6e-8c55-\
f9662d199a07"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3dc7a1bc-2bf4-4f68-b120-60d5889364e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AlcoveDefiningRoot", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"AlcoveDefiningRoot", "[", 
    RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lp", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"EvenQ", "[", "l", "]"}], ",", 
         RowBox[{"l", "/", "2"}], ",", "l"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Divisible", "[", 
        RowBox[{"lp", ",", 
         RowBox[{"LacingNumber", "[", "\[CapitalGamma]", "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LongDominantRoots", "[", "\[CapitalGamma]", "]"}], 
        "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ShortDominantRoots", "[", "\[CapitalGamma]", "]"}], 
        "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4201291321106224`*^9, 3.42012914983611*^9}, {
  3.4201293299951663`*^9, 3.420129396901373*^9}, {3.4201294387515507`*^9, 
  3.420129464618746*^9}, {3.4201295078208675`*^9, 3.420129508071227*^9}, {
  3.4216219010828657`*^9, 3.421621907482067*^9}, {3.430762247927621*^9, 
  3.430762252003482*^9}},ExpressionUUID->"5cd8698c-f49c-459f-865d-\
431af14a05a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WeightInAlcoveQ", "[", 
    RowBox[{"\[CapitalGamma]_", ",", "l_Integer"}], "]"}], "[", 
   RowBox[{"\[Lambda]", ":", 
    RowBox[{"{", "___Integer", "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"And", "@@", 
     RowBox[{"(", 
      RowBox[{"NonNegative", "/@", "\[Lambda]"}], ")"}]}], ")"}], "\[And]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"KillingForm", "[", "\[CapitalGamma]", "]"}], "[", 
      RowBox[{
       RowBox[{"AlcoveDefiningRoot", "[", 
        RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], ",", 
       RowBox[{"\[Lambda]", "+", 
        RowBox[{"\[Rho]", "[", "\[CapitalGamma]", "]"}]}]}], "]"}], "<", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"EvenQ", "[", "l", "]"}], ",", 
       RowBox[{"l", "/", "2"}], ",", "l"}], "]"}]}], ")"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4201296627736783`*^9, 3.420129705575224*^9}, {
   3.4201298147421985`*^9, 3.420129892724331*^9}, {3.4201304902935934`*^9, 
   3.420130490714198*^9}, 
   3.4307622540764627`*^9},ExpressionUUID->"06ad8b82-b05c-4705-8967-\
9f4bfb43436b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AlcoveWeights", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"AlcoveWeights", "[", 
    RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ar", "=", 
        RowBox[{"AlcoveDefiningRoot", "[", 
         RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}]}], ",", 
       RowBox[{"\[Lambda]", "=", 
        RowBox[{"ZeroVector", "[", 
         RowBox[{"Rank", "[", "\[CapitalGamma]", "]"}], "]"}]}], ",", "p"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Reap", "[", "\[IndentingNewLine]", 
       RowBox[{"While", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Sow", "[", "\[Lambda]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Lambda]", "+=", 
          RowBox[{"UnitVector", "[", 
           RowBox[{
            RowBox[{"Rank", "[", "\[CapitalGamma]", "]"}], ",", "1"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Not]", 
             RowBox[{"ZeroVectorQ", "[", "\[Lambda]", "]"}]}], "\[And]", 
            RowBox[{"\[Not]", 
             RowBox[{
              RowBox[{"WeightInAlcoveQ", "[", 
               RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], "[", "\[Lambda]",
               "]"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "odometer", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"p", "=", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{"\[Lambda]", ",", 
                RowBox[{"x_", "/;", 
                 RowBox[{"x", ">", "0"}]}]}], "]"}], "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "\[Lambda]", "\[LeftDoubleBracket]", "p", 
              "\[RightDoubleBracket]"}], "=", "0"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"p", "<", 
               RowBox[{"Rank", "[", "\[CapitalGamma]", "]"}]}], ",", 
              RowBox[{"++", 
               RowBox[{"\[Lambda]", "\[LeftDoubleBracket]", 
                RowBox[{"p", "+", "1"}], "\[RightDoubleBracket]"}]}]}], "]"}],
             ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"\[Not]", 
          RowBox[{"ZeroVectorQ", "[", "\[Lambda]", "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}], 
      "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4201295375936785`*^9, 3.4201295651032352`*^9}, {
   3.4201296187603903`*^9, 3.420129658076925*^9}, {3.4201298348310847`*^9, 
   3.4201298415307183`*^9}, {3.4201299001850595`*^9, 3.420130262976728*^9}, {
   3.4201302952631536`*^9, 3.420130299449173*^9}, {3.4201303355410705`*^9, 
   3.420130354558416*^9}, {3.4201304157163568`*^9, 3.4201304222858033`*^9}, {
   3.4201312367469406`*^9, 3.4201312428457108`*^9}, 
   3.4307622556086655`*^9},ExpressionUUID->"8382dc3b-d5e1-4e31-9464-\
7459299a3817"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AlcoveWeightsInLattice", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_", ",", "All"}], "]"}], ":=", 
  RowBox[{"AlcoveWeights", "[", 
   RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4306704878307457`*^9, 
  3.430670501099826*^9}},ExpressionUUID->"9770d1a0-3e75-417c-bc98-\
7a9665cb8dfe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AlcoveWeightsInLattice", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_", ",", "lattice_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"AlcoveWeightsInLattice", "[", 
    RowBox[{"\[CapitalGamma]", ",", "l", ",", "lattice"}], "]"}], "=", 
   RowBox[{"Cases", "[", 
    RowBox[{
     RowBox[{"AlcoveWeights", "[", 
      RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], ",", 
     RowBox[{"\[Lambda]_", "/;", 
      RowBox[{"WeightInLatticeQ", "[", 
       RowBox[{"\[CapitalGamma]", ",", "\[Lambda]", ",", "lattice"}], 
       "]"}]}]}], "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.430669901928259*^9, 3.4306699268440866`*^9}, {
  3.430670479148261*^9, 
  3.4306704866790895`*^9}},ExpressionUUID->"4fc03dbb-7eff-4b5f-a2ed-\
1235746d824d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AlcoveRoots", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"AlcoveRoots", "[", 
    RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], "=", 
   RowBox[{"Cases", "[", 
    RowBox[{
     RowBox[{"AlcoveWeights", "[", 
      RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], ",", 
     RowBox[{"\[Lambda]_", "/;", 
      RowBox[{"RootWeightQ", "[", 
       RowBox[{"\[CapitalGamma]", ",", "\[Lambda]"}], "]"}]}]}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.429981641473896*^9, {3.4299860529072256`*^9, 3.4299860632220573`*^9}, 
   3.4360485709272656`*^9},ExpressionUUID->"fe3db3fe-5c4f-469a-ad72-\
da04fead50ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LevelFromRoot", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["l", 
    RowBox[{"2", 
     RowBox[{"LacingNumber", "[", "\[CapitalGamma]", "]"}]}]], "-", 
   RowBox[{"DualCoxeterNumber", "[", "\[CapitalGamma]", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4299760870470223`*^9, 3.429976130068885*^9}, {
   3.4299762105045457`*^9, 3.4299762207893343`*^9}, {3.429976291781416*^9, 
   3.4299763863073378`*^9}, {3.429976961764805*^9, 3.429976974062488*^9}, 
   3.436048510169901*^9},ExpressionUUID->"a805edbd-3860-46f2-972f-\
290c191f1849"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RootFromLevel", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"2", 
   RowBox[{"LacingNumber", "[", "\[CapitalGamma]", "]"}], 
   RowBox[{"(", 
    RowBox[{"k", "+", 
     RowBox[{"DualCoxeterNumber", "[", "\[CapitalGamma]", "]"}]}], 
    ")"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4299761324122543`*^9, 3.4299761605627327`*^9}, {
   3.429976213338621*^9, 3.429976222521826*^9}, {3.4299762946255054`*^9, 
   3.42997629964272*^9}, {3.4299763923460207`*^9, 3.429976417492179*^9}, {
   3.429976931150784*^9, 3.4299769457918367`*^9}, 
   3.436048512172781*^9},ExpressionUUID->"1437bbe9-25d1-4b32-b6a9-\
096a0e467b33"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AlcoveRoots", "[", 
   RowBox[{"\[CapitalGamma]_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"AlcoveRoots", "[", 
    RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], "=", 
   RowBox[{"Cases", "[", 
    RowBox[{
     RowBox[{"AlcoveWeights", "[", 
      RowBox[{"\[CapitalGamma]", ",", "l"}], "]"}], ",", 
     RowBox[{"\[Lambda]_", "/;", 
      RowBox[{"RootWeightQ", "[", 
       RowBox[{"\[CapitalGamma]", ",", "\[Lambda]"}], "]"}]}]}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.429981641473896*^9, {3.4299860529072256`*^9, 3.4299860632220573`*^9}, {
   3.430406278774677*^9, 
   3.4304062815386515`*^9}},ExpressionUUID->"3fa63cce-1bf8-4dfe-ac13-\
b082b9427eb1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TwistFactor", "[", 
   RowBox[{"\[CapitalGamma]_", ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "\[CapitalGamma]_", "]"}], "[", "\[Lambda]_", 
     "]"}]}], "]"}], ":=", 
  SuperscriptBox["Global`q", 
   RowBox[{
    RowBox[{"KillingForm", "[", "\[CapitalGamma]", "]"}], "[", 
    RowBox[{"\[Lambda]", ",", 
     RowBox[{"\[Lambda]", "+", 
      RowBox[{"2", 
       RowBox[{"\[Rho]", "[", "\[CapitalGamma]", "]"}]}]}]}], 
    "]"}]]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71858508072515*^9, 
  3.718585082036059*^9}},ExpressionUUID->"6b750819-1b87-40cf-9f36-\
7764323e42ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d3a7c92f-0493-4187-9fac-b909dfe63d02"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f4870834-ddfc-44b3-a7b2-d99746595446"]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1615, 978},
WindowMargins->{{Automatic, 223}, {172, Automatic}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 18, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 168, 3, 51, "Subtitle", "ExpressionUUID" -> \
"bf1873d1-6a9c-41d0-8bec-2d888c8b3717"],
Cell[738, 27, 236, 6, 49, "Text", "ExpressionUUID" -> \
"8b61aa2a-7f89-4927-b314-bdcffcd73d94"],
Cell[CellGroupData[{
Cell[999, 37, 86, 0, 64, "Section", "ExpressionUUID" -> \
"5c048005-5986-4f35-95c9-c085e6341663"],
Cell[1088, 39, 71, 0, 30, "Text", "ExpressionUUID" -> \
"e77de34a-e092-4dcf-9cde-96f1ef99c083"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1196, 44, 88, 0, 64, "Section", "ExpressionUUID" -> \
"7ed2e104-8a4c-4768-8cbe-9d0a5e50db0b"],
Cell[1287, 46, 485, 12, 48, "Input", "ExpressionUUID" -> \
"98481f62-8e0a-49a1-a34f-679f6ec81547",
 InitializationCell->True],
Cell[1775, 60, 416, 8, 48, "Input", "ExpressionUUID" -> \
"ada1744e-9bfd-4a6e-8c55-f9662d199a07",
 InitializationCell->True],
Cell[2194, 70, 177, 4, 48, "Input", "ExpressionUUID" -> \
"3dc7a1bc-2bf4-4f68-b120-60d5889364e4",
 InitializationCell->True],
Cell[2374, 76, 1507, 36, 133, "Input", "ExpressionUUID" -> \
"5cd8698c-f49c-459f-865d-431af14a05a0",
 InitializationCell->True],
Cell[3884, 114, 1150, 30, 48, "Input", "ExpressionUUID" -> \
"06ad8b82-b05c-4705-8967-9f4bfb43436b",
 InitializationCell->True],
Cell[5037, 146, 3366, 76, 343, "Input", "ExpressionUUID" -> \
"8382dc3b-d5e1-4e31-9464-7459299a3817",
 InitializationCell->True],
Cell[8406, 224, 384, 9, 48, "Input", "ExpressionUUID" -> \
"9770d1a0-3e75-417c-bc98-7a9665cb8dfe",
 InitializationCell->True],
Cell[8793, 235, 789, 19, 48, "Input", "ExpressionUUID" -> \
"4fc03dbb-7eff-4b5f-a2ed-1235746d824d",
 InitializationCell->True],
Cell[9585, 256, 711, 19, 48, "Input", "ExpressionUUID" -> \
"fe3db3fe-5c4f-469a-ad72-da04fead50ef",
 InitializationCell->True],
Cell[10299, 277, 640, 14, 69, "Input", "ExpressionUUID" -> \
"a805edbd-3860-46f2-972f-290c191f1849",
 InitializationCell->True],
Cell[10942, 293, 703, 16, 48, "Input", "ExpressionUUID" -> \
"1437bbe9-25d1-4b32-b6a9-096a0e467b33",
 InitializationCell->True],
Cell[11648, 311, 739, 20, 48, "Input", "ExpressionUUID" -> \
"3fa63cce-1bf8-4dfe-ac13-b082b9427eb1",
 InitializationCell->True],
Cell[12390, 333, 634, 18, 49, "Input", "ExpressionUUID" -> \
"6b750819-1b87-40cf-9f36-7764323e42ef",
 InitializationCell->True],
Cell[13027, 353, 154, 4, 48, "Input", "ExpressionUUID" -> \
"d3a7c92f-0493-4187-9fac-b909dfe63d02",
 InitializationCell->True],
Cell[13184, 359, 161, 4, 48, "Input", "ExpressionUUID" -> \
"f4870834-ddfc-44b3-a7b2-d99746595446",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

